TestCafeClient.define('Automation.Hover.Playback', function (require, exports) {
    var Hammerhead = HammerheadClient.get('Hammerhead'),
        Util = Hammerhead.Util,
        Settings = require('Settings'),
        NativeMethods = Hammerhead.NativeMethods, 

        AutomationSettings = require('Automation.Settings'),
        MovePlaybackAutomation = require('Automation.Move.Playback');

    exports.run = function (element, options, callback) {
        if (Settings.RECORDING && !Settings.PLAYBACK && !Util.isElementVisible(element)) {
            NativeMethods.setTimeout.call(window, callback, AutomationSettings.ACTION_STEP_DELAY);
            return;
        }

        if (options.offsetX)
            options.offsetX = Math.round(options.offsetX);
        if (options.offsetY)
            options.offsetY = Math.round(options.offsetY);

        MovePlaybackAutomation.run(element, false, options, callback);
    };
});
