TestCafeClient.define('Automation.Press.Playback', function (require, exports) {
    var Hammerhead = HammerheadClient.get('Hammerhead'),
        async = Hammerhead.async,
        Util = Hammerhead.Util,
        NativeMethods = Hammerhead.NativeMethods,
        Settings = require('Settings'),
        KeyPressSimulator = require('Automation.Press.KeyPressSimulator'),
        AutomationUtil = require('Automation.Util'),
        SelectElementUi = require('UI.SelectElement');

    exports.run = function (keys, actionCallback) {
        var parsedKeys = Util.parseKeysString(keys),
            commands = parsedKeys.commands;

        async.forEachSeries(
            commands,
            function (command, callback) {
                //NOTE: in Mozilla prentDefault for 'keydown' and 'keypress' event in select element
                // does not affect on the appointment of the new selectedIndex
                //so we should process switching between options only on playback anf after change action
                if (Util.isSelectElement(Util.getActiveElement())) {
                    if (!/enter|tab/.test(command) || ((!Settings.RECORDING || Settings.PLAYBACK) && /enter|tab/.test(command)))
                        SelectElementUi.switchOptionsByKeys(command);
                }

                KeyPressSimulator.press(command, function () {
                    NativeMethods.setTimeout.call(window, callback, AutomationUtil.ACTION_STEP_DELAY);
                });
            },
            function () {
                actionCallback();
            }
        );
    };
});
