TestCafeClient.define('Automation.Scroll', function (require, exports) {
    var Hammerhead = HammerheadClient.get('Hammerhead'),
        $ = Hammerhead.$,
        Util = Hammerhead.Util,
        ScrollPlaybackAutomation = require('Automation.Scroll.Playback');

    exports.setScroll = function (iFrameWin, point, actionOptions, callback) {
        var iFrame = Util.getIFrameByWindow(iFrameWin),
            target = point ? Util.getFixedPosition(point, iFrameWin, true) : iFrame,
            options = point ? null : actionOptions;

        ScrollPlaybackAutomation.run(target, options, null, callback);
    };

    exports.getScrollData = function (iFrameWin) {
        var iFrame = Util.getIFrameByWindow(iFrameWin);

        return {
            scroll: Util.getElementScroll($(Util.findDocument(document))),
            iFrameOffset: Util.getOffsetPosition(iFrame),
            iFrameBorders: Util.getBordersWidth($(iFrame)),
            iFramePadding: Util.getElementPadding($(iFrame))
        };
    };
});
