TestCafeClient.define('ActionBarrier', function (require, exports) {
    var XhrBarrier = require('ActionBarrier.Xhr');

    //API

    //NOTE: actionSynchronizer provides XHRRequest auto-wait functionality via barrier mechanism.
    //Usually barriers are used for thread synchronization in operating systems
    //(see: http://en.wikipedia.org/wiki/Barrier_(computer_science)). But idea was adopted for
    //action/requests operations background.
    exports.init = function () {
        XhrBarrier.init();
    };

    exports.waitPageInitialization = function (callback) {
        XhrBarrier.waitPageInitialRequests(callback);
    };

    //NOTE: run action, wait for xhrWatch and iframeWatch response
    exports.waitActionSideEffectsCompletion = function (action, callback) {
        XhrBarrier.startBarrier(callback);

        action.call(window, function () {
            XhrBarrier.waitBarrier();
        });
    };
});