TestCafeClient.define('TestRunner.SourceIndexTracker', function (require, exports) {
    var Hammerhead = HammerheadClient.get('Hammerhead'),
        Util = Hammerhead.Util,
        Settings = require('Settings');

    var SOURCE_INDEX_ARG_REGEXP = /#(\d+)/;

    exports.currentIndex = null;

    exports.wrapTrackableMethods = function (methodsHost, methodNames) {
        Util.arrForEach(methodNames, function (methName) {
            var originalMeth = methodsHost[methName];

            methodsHost[methName] = function () {
                var args = Array.prototype.slice.call(arguments);

                if (Settings.ENABLE_SOURCE_INDEX) {
                    var idxArg = args[args.length - 1],
                        idxMatch = typeof idxArg === 'string' && idxArg.match(SOURCE_INDEX_ARG_REGEXP);

                    //NOTE: check if we actually have sourc index. Because in some edge case it can't be
                    //calcualted by compiler
                    if (idxMatch) {
                        exports.currentIndex = parseInt(idxMatch[1], 10);
                        args.pop();
                    }
                }

                return originalMeth.apply(this, args);
            };
        });
    };
});