TestCafeClient.define('UI.ProgressBar', function () {
    var Hammerhead = HammerheadClient.get('Hammerhead'),

        $ = Hammerhead.$,
        ShadowUI = Hammerhead.ShadowUI;

    var CONTAINER_CLASS = 'progress-bar',
        VALUE_CLASS = 'value',
        SUCCESS_CLASS = 'success';

    var ProgressBar = this.exports = function ($container, startValue) {
        this.$container = $('<div></div>').appendTo($container);
        this.$value = $('<div></div>').appendTo(this.$container);

        ShadowUI.addClass(this.$container, CONTAINER_CLASS);
        ShadowUI.addClass(this.$value, VALUE_CLASS);

        this.setValue(startValue);
    };

    ProgressBar.prototype.setValue = function (value) {
        if (typeof value !== 'number' || value < 0)
            value = 0;
        else if (value > 100)
            value = 100;

        this.$value.css('width', value + '%');
    };

    ProgressBar.prototype.setSuccess = function (value) {
        if (value)
            ShadowUI.addClass(this.$container, SUCCESS_CLASS);
        else
            ShadowUI.removeClass(this.$container, SUCCESS_CLASS);
    };
});