TestCafeClient.define('UI.ProgressPanel', function (require) {
    var Hammerhead = HammerheadClient.get('Hammerhead'),

        $ = Hammerhead.$,
        ShadowUI = Hammerhead.ShadowUI,
        ProgressBar = require('UI.ProgressBar');

    var PANEL_CLASS = 'progress-panel',
        TITLE_CLASS = 'title',
        CONTENT_CLASS = 'content';

    //Util
    var $window = $(window);

    function showAtWindowCenter($element) {
        var top = Math.round($window.height() / 2 - ($element.outerHeight() / 2)),
            left = Math.round($window.width() / 2 - ($element.outerWidth() / 2));

        $element.css({
            top: top,
            left: left
        });
    }

    //ProgressPanel
    var ProgressPanel = this.exports = function (text, startValue) {
        this.$panel = $('<div></div>').css('visibility', 'hidden').appendTo(ShadowUI.getRoot());

        var panel = this,
            $title = $('<div></div>').text(text).appendTo(this.$panel),
            $content = $('<div></div>').appendTo(this.$panel);

        ShadowUI.addClass(this.$panel, PANEL_CLASS);
        ShadowUI.addClass($title, TITLE_CLASS);
        ShadowUI.addClass($content, CONTENT_CLASS);

        this.progressBar = new ProgressBar($content, startValue);
        showAtWindowCenter(this.$panel);

        this.disposePanel = function () {
            panel._onWindowResize();
        };
        ShadowUI.bind($window, 'resize', this.disposePanel);

        this.$panel.css('display', 'none').css('visibility', '');
        this.$panel.fadeIn(200);
    };

    ProgressPanel.prototype._onWindowResize = function () {
        showAtWindowCenter(this.$panel);
    };

    //API
    ProgressPanel.prototype.setValue = function (value) {
        this.progressBar.setValue(value);
    };

    ProgressPanel.prototype.close = function (force) {
        var panel = this;

        ShadowUI.unbind($window, 'resize', this.disposePanel);

        this.$panel.fadeOut(force ? 0 : 600, function () {
            panel.$panel.remove();
        });
    };

    ProgressPanel.prototype.setSuccess = function (value) {
        this.progressBar.setSuccess(value);
    };
});