TestCafeClient.define('UI.RecorderWidgets.AssertionsBlock', function () {
    var Hammerhead = HammerheadClient.get('Hammerhead'),
        $ = Hammerhead.$,
        ShadowUI = Hammerhead.ShadowUI;

    var ASSERTIONS_BLOCK_CLASS = 'assertions-block',
        TITLE_CLASS = 'title',
        CONTENT_CLASS = 'content';

    var AssertionsBlock = this.exports = function ($container, context, showTitle) {
        this.$block = $('<div></div>').appendTo($container);
        this.context = context;

        this.$title = $('<div></div>').css('display', showTitle ? '' : 'none').appendTo(this.$block);
        this.$title.text(context ?
            'Assertions in IFrame: ' + context :
            'Assertions in the main window');

        this.$content = $('<div></div>').appendTo(this.$block);

        this.assertions = [];
        this.assertionsInfo = [];

        ShadowUI.addClass(this.$block, ASSERTIONS_BLOCK_CLASS);
        ShadowUI.addClass(this.$title, TITLE_CLASS);
        ShadowUI.addClass(this.$content, CONTENT_CLASS);
    };

    AssertionsBlock.prototype.addAssertion = function ($assertion, info) {
        this.assertions.push($assertion);
        this.assertionsInfo.push(info);
        $assertion.appendTo(this.$content);
    };

    AssertionsBlock.prototype.removeAssertion = function ($assertion) {
        var index = $.inArray($assertion, this.assertions);

        if (index > -1) {
            this.assertions.splice(index, 1);
            this.assertionsInfo.splice(index, 1);
        }
    };

    AssertionsBlock.prototype.showTitle = function () {
        this.$title.css('display', '');
    };

    AssertionsBlock.prototype.hideTitle = function () {
        this.$title.css('display', 'none');
    };

    AssertionsBlock.prototype.getAssertionsCount = function () {
        return this.assertions.length;
    };

    AssertionsBlock.prototype.getContext = function () {
        return this.context;
    };

    AssertionsBlock.prototype.getAssertionsInfo = function () {
        return this.assertionsInfo;
    };

    AssertionsBlock.prototype.remove = function () {
        this.$block.remove();
        this.$title.remove();
    };
});
