TestCafeClient.define('UI.RecorderWidgets.BackToInitialPage', function (require, exports) {
    var Hammerhead = HammerheadClient.get('Hammerhead'),
        $ = Hammerhead.$,
        Util = Hammerhead.Util,
        ShadowUI = Hammerhead.ShadowUI,
        ConfirmDialog = require('UI.RecorderWidgets.ConfirmDialog'),
        ButtonWidget = require('UI.RecorderWidgets.Button');

    //Const
    var BACK_TO_INITIAL_PAGE_CLASS = 'back-to-initial',
        BUTTONS_CLASS = 'buttons',

    //Popup text
        POPUP_MESSAGE_TEXT = ['The tested page state was changed by the test steps, which are now deleted. Please return to the initial test page.'];

    //Events
    exports.BACK_TO_INITIAL_PAGE_EVENT = 'backToInitialPageButtonClick';

    //Globals
    var dialog = null,
        eventEmitter = null,
        $backToInitialPageButton = null;

    //Markup
    var createButtons = function () {
        var $buttons = $('<div></div>');
        ShadowUI.addClass($buttons, BUTTONS_CLASS);

        $backToInitialPageButton = ButtonWidget.create($buttons, 'Go back to initial page');

        return $buttons;
    };

    var createDialog = function ($container) {
        dialog = new ConfirmDialog($container, {
            message: POPUP_MESSAGE_TEXT,
            footerContent: createButtons(),
            popupWidth: 540
        });

        ShadowUI.addClass(dialog.popup.$popup, BACK_TO_INITIAL_PAGE_CLASS);
        init();
    };

//Behavior
    var init = function () {
        ShadowUI.bind($backToInitialPageButton, 'click', function () {
            closeDialog(function () {
                eventEmitter.emit(exports.BACK_TO_INITIAL_PAGE_EVENT);
            });
        });

        dialog.popup.onkeydown(function (e) {
            if (e.keyCode === Util.KEYS_MAPS.SPECIAL_KEYS.enter) {
                $backToInitialPageButton.trigger('click');
                Util.preventDefault(e);
            }

            //NOTE: we should prevent page scrolling
            if (e.target === dialog.popup.$popup[0] && Util.isArrowKey(e.keyCode))
                Util.preventDefault(e);
        }, true);
    };

    var closeDialog = function (callback) {
        dialog.popup.close(callback);
    };

    //API
    exports.init = function ($container) {
        eventEmitter = new Util.EventEmitter();
        createDialog($container);
    };

    exports.events = {
        on: function (ev, listener) {
            eventEmitter.on(ev, listener);
        }
    };
});