TestCafeClient.define('UI.RecorderWidgets.Button', function () {
    var Hammerhead = HammerheadClient.get('Hammerhead'),
        $ = Hammerhead.$,
        Util = Hammerhead.Util,
        ShadowUI = Hammerhead.ShadowUI;

    //Const
    var BUTTON_CLASS = 'button',
        BUTTON_ICON_CLASS = 'button-icon';

    this.exports.create = function ($container, text, withImg) {
        var $button = $('<button></button>').appendTo($container);

        if (withImg) {
            ShadowUI.addClass($('<div></div>').appendTo($button), BUTTON_ICON_CLASS);
            var $span = $('<span></span>').html(text).appendTo($button);

            if (Util.isSafari) {
                $span.css({
                    position: 'relative',
                    top: '2px'
                });
            }
        }
        else {
            $button.html(text);

            //HACK: (B239762) It impossible to fix the bug with css because the font looks differently on windows and mac.
            if (Util.isSafari) {
                $button.css({
                    paddingTop: '2px',
                    paddingBottom: '0px'
                });
            }
        }

        ShadowUI.addClass($button, BUTTON_CLASS);

        return $button;
    };
});