TestCafeClient.define('UI.RecorderWidgets.ConfirmDialog', function (require) {
    var Hammerhead = HammerheadClient.get('Hammerhead'),
        $ = Hammerhead.$,
        ShadowUI = Hammerhead.ShadowUI,
        PopupWidget = require('UI.RecorderWidgets.Popup');

    //Const
    var CONFIRM_DIALOG_CONTENT_CLASS = 'confirm',
        CONFIRM_MESSAGE_CLASS = 'confirm-message',
        JUSTIFY_TEXT_CLASS = 'justify-text';

    var ConfirmDialog = this.exports = function ($container, args) {
        this.options = args;
        this.popup = null;
        this.headerText = '';
        this.confirmMessage = [];

        this._createDialog($container);
    };

    //Markup
    ConfirmDialog.prototype._createDialog = function ($container) {
        this.headerText = this.options.headerText || '';
        this.confirmMessage = this.options.message || '';

        var popupOptions = {
            width: this.options.popupWidth || 528,
            content: this._createContent($('<div></div>')),
            footerContent: this.options.footerContent,
            headerText: this.options.headerText,
            showAtWindowCenter: true
        };

        this.popup = new PopupWidget($container, popupOptions);
    };

    ConfirmDialog.prototype._createContent = function ($container) {
        var dialog = this;
        ShadowUI.addClass($container, CONFIRM_DIALOG_CONTENT_CLASS);

        var $confirmMessage = $('<div></div>').appendTo($container);
        ShadowUI.addClass($confirmMessage, CONFIRM_MESSAGE_CLASS);

        var $span = null;

        if (this.confirmMessage.length)
            $.each(this.confirmMessage, function (index, value) {
                $span = $('<span></span>').appendTo($confirmMessage)
                    .html(value);

                if (dialog.options.justifyText)
                    ShadowUI.addClass($span, JUSTIFY_TEXT_CLASS);
            });
        else {
            $span = $('<span></span>').appendTo($confirmMessage)
                .html(this.confirmMessage);

            if (dialog.options.justifyText)
                ShadowUI.addClass($span, JUSTIFY_TEXT_CLASS);
        }
        return $container;
    };


    //API
    ConfirmDialog.prototype.closeDialog = function (callback) {
        this.popup.close(callback);
    };

    ConfirmDialog.prototype.blind = function (blind) {
        this.popup.blind(blind);
    };
});