TestCafeClient.define('UI.ValidationMessageFactory', function (require, exports) {
    var Hammerhead = HammerheadClient.get('Hammerhead'),
        $ = Hammerhead.$,
        ShadowUI = Hammerhead.ShadowUI;

    var VALIDATION_MESSAGE_ELEMENT_ATTRIBUTE_NAME = 'validation-element',
        ERROR_CLASS = 'error',
        WARNING_CLASS = 'warning',
        VALIDATION_CLASS = 'validation',
        ERROR_MESSAGE_CLASS = 'error-message',
        WARNING_MESSAGE_CLASS = 'warning-message',
        WIDE_MESSAGE_CLASS = 'wide';

    function createValidationMessageElement($element) {
        var $messageElement = $('<div></div>').insertAfter($element);

        $('<span></span>').appendTo($messageElement);

        $element.data(VALIDATION_MESSAGE_ELEMENT_ATTRIBUTE_NAME, $messageElement);
        ShadowUI.addClass($messageElement, VALIDATION_CLASS);
        return $messageElement;
    }

    exports.error = function ($element, text, wide) {
        if (text) {
            var $messageElement = $element.data(VALIDATION_MESSAGE_ELEMENT_ATTRIBUTE_NAME) || createValidationMessageElement($element),
                $message = $messageElement.find('span');

            $message.text(text);
            ShadowUI.removeClass($messageElement, WARNING_MESSAGE_CLASS);
            ShadowUI.addClass($messageElement, ERROR_MESSAGE_CLASS);

            if (wide)
                ShadowUI.addClass($message, WIDE_MESSAGE_CLASS);
        }

        ShadowUI.removeClass($element, WARNING_CLASS);
        ShadowUI.addClass($element, ERROR_CLASS);
    };

    exports.warning = function ($element, text) {
        var $messageElement = $element.data(VALIDATION_MESSAGE_ELEMENT_ATTRIBUTE_NAME) || createValidationMessageElement($element);
        $messageElement.find('span').html(text);

        ShadowUI.removeClass($messageElement, ERROR_MESSAGE_CLASS);
        ShadowUI.addClass($messageElement, WARNING_MESSAGE_CLASS);
        ShadowUI.removeClass($element, ERROR_CLASS);
        ShadowUI.addClass($element, WARNING_CLASS);
    };

    exports.success = function ($element) {
        var $messageElement = $element.data(VALIDATION_MESSAGE_ELEMENT_ATTRIBUTE_NAME);
        if ($messageElement) {
            $messageElement.find('span').html('');

            ShadowUI.removeClass($messageElement, ERROR_MESSAGE_CLASS);
            ShadowUI.removeClass($messageElement, WARNING_MESSAGE_CLASS);
        }
        ShadowUI.removeClass($element, ERROR_CLASS);
        ShadowUI.removeClass($element, WARNING_CLASS);
    };
});