ControlPanel.define('CheckUpdates', function(require, exports) {
    //Consts
    var
    //Selectors
        GET_VERSION_NUMBER_URL = '/check_updates/',
        CURRENT_VERSION = '.footer .current-version',
        NEW_VERSION = '.footer .new-version';

    var $ = require('jQuery'),
        UXLog = require('UXLog');

    exports.check = function() {
        $.get(GET_VERSION_NUMBER_URL, function(versions) {
            if(!versions)
                return;

            if(versions.newVersion) {
                var newVersionHTML = [$(NEW_VERSION).html(), versions.newVersion].join(' ');

                $(CURRENT_VERSION).hide();
                $(NEW_VERSION)
                    .html(newVersionHTML)
                    .fadeIn()
                    .on('click', function () {
                        UXLog.write('"Download new version ' + versions.newVersion + '"+ button clicked');
                    });
            }
            else
                $(CURRENT_VERSION).text('v. ' + versions.curVersion).show();
        });
    };
});

