ControlPanel.define('Widgets.Draggable', function(require) {
    var $ = require('jQuery');

    var Draggable = function($el) {
        this.$el = $el;
        this.$cont = null;
        this.mouseX = 0;
        this.mouseY = 0;
        this.isDraggable = false;

        this._initDraggable();
    };

    Draggable.prototype._dragElm = function (x, y) {
        var diffX = x - this.mouseX,
            diffY = y - this.mouseY,
            elTop = parseInt(this.$cont.css('top')),
            elLeft = parseInt(this.$cont.css('left'));

        this.$cont.css({
            'top': Math.max(elTop + diffY, 0) + 'px',
            'left': Math.max(elLeft + diffX, 0) + 'px'
        });

        this.mouseX = x;
        this.mouseY = y;
    };

    Draggable.prototype._initDraggable = function () {
        var draggable = this,
            $el = draggable.$el;

        draggable.$cont = $el.parent();

        $el.off('mousedown');

        $el.on('mousedown', function (e) {
            draggable.mouseX = e.pageX;
            draggable.mouseY = e.pageY;
            draggable.isDraggable = true;

            e.preventDefault();
        });

        $(document).bind('mouseup', function () {
            draggable.isDraggable = false;
        });

        $(document).bind('mousemove', function (e) {
            if (draggable.isDraggable)
                draggable._dragElm(e.pageX, e.pageY);
        });
    };

    $.fn.draggable = function() {
        return new Draggable(this);
    };
});