HammerheadClient.define('Util.Browser', function (require) {
    var $ = require('jQuery');
    var bowser = require('bowser');

    var userAgent = navigator.userAgent.toLowerCase();
    var info = bowser._detect(userAgent);


    var version = parseInt(info.version, 10);
    var isIE = !!(info.msie || info.msedge);
    var hasTouchEvents = !!('ontouchstart' in window);

    this.exports = {
        //Platforms
        isMacPlatform: !!info.mac,
        isAndroid:     !!info.android,
        isIOS:         !!info.ios,

        //Browsers
        browserVersion:    version,
        isIE:              isIE,
        isIE11:            isIE && version === 11,
        isIE10:            isIE && version === 10,
        isIE9:             isIE && version === 9,
        isMozilla:         !!info.firefox,
        isMSEdge:          !!info.msedge,
        isChrome:          !!info.chrome,
        isSafari:          !!info.safari,
        isWebKit:          !!(info.webkit || info.blink),
        isOpera:           $.browser.opera,
        isOperaWithWebKit: /OPR/.test(navigator.userAgent),

        //Feature detection
        hasTouchEvents: hasTouchEvents,
        // NOTE: we need check of touch points only for IE, because it has
        // PointerEvent and MSPointerEvent (IE10, IE11) instead TouchEvent (T109295)
        hasTouchPoints: isIE && (navigator.maxTouchPoints > 0 || navigator.msMaxTouchPoints > 0),
        isTouchDevice:  !!(info.mobile || info.tablet) && hasTouchEvents
    };
});