HammerheadClient.define('Util.FeatureDetection', function (require, exports) {
    var NativeMethods = require('DOMSandbox.NativeMethods');

    // NOTE: In some browsers, elements without the url attribute return the location url
    // when accessing this attribute directly. See form.action in Edge 25 as an example.
    exports.emptyActionAttrFallbacksToTheLocation = NativeMethods.createElement.call(document, 'form').action ===
                                                    window.location.toString();

    // NOTE: In Chrome, toString(window) equals '[object Window]' and toString(Window.prototype) equals '[object Blob]',
    // this condition is also satisfied for Blob, Document, XMLHttpRequest, etc
    exports.instanceAndPrototypeToStringAreEqual = NativeMethods.objectToString.call(window) ===
                                                   NativeMethods.objectToString.call(window.Window.prototype);
});