#!/usr/bin/env bash
#Constants
installerTitle=$1
distFileName='./testcafe.dmg'
distFinalName='./DevExpress-TestCafe.dmg'
installerLocation="$(pwd)/${installerTitle}"

unzip ./tmpl/testcafe_tmpl.zip
sync

device=$(hdiutil attach -mountpoint "${installerTitle}" -readwrite -noverify -noautoopen "${distFileName}" | egrep '^/dev/' | sed 1q | awk '{print $1}')
sleep 5
#Write license
cat ./TestCafe.app/Contents/Resources/testcafe/TESTCAFE_EULA.txt >> "$installerLocation/EULA.txt"
echo -e "\n\n" >> "$installerLocation/EULA.txt"
cat ./TestCafe.app/Contents/Resources/testcafe/NODEJS_EULA.txt >> "$installerLocation/EULA.txt"

#Set permissions for executable files
chmod +x "./TestCafe.app/Contents/MacOS/TestCafe"
chmod +x "./TestCafe.app/Contents/Resources/testcafe/node"
chmod +x "./TestCafe.app/Contents/Resources/testcafe/lib/test_runner/shot_window"

#Copy TestCafe dist
cp -fR ./TestCafe.app $installerLocation

#Finalaze disk image
sync
hdiutil detach -force $installerTitle
hdiutil convert ${distFileName} -format UDZO -imagekey zlib-level=9 -o "${distFinalName}"