﻿using System;
using System.Diagnostics;

namespace TestCafe_Console
{
    static class Program
    {
        [STAThread]
        static void Main(string[] args)
        {
            Cli.executeCliCommand(args);
        }
    }

    static class Cli
    {
        private static string
            cliModuleFilePath = "./lib/cli/index.js";
        private static string
            stdout = "",
            stderr = "";
        private static Process nodeProcess = null;

        public static void executeCliCommand(string[] args)
        {
            string[] arguments = new string[args.Length + 1];

            arguments[0] = cliModuleFilePath;
            args.CopyTo(arguments, args.Length);

            NodeProcess cliProcess = new NodeProcess(String.Join(" ", arguments));
            nodeProcess = cliProcess.Execute();
            nodeProcess.Exited += delegate(object o, EventArgs e)
            {
                stdout = nodeProcess.StandardOutput.ReadToEnd();
                stderr = nodeProcess.StandardError.ReadToEnd();

                if (!string.IsNullOrEmpty(stdout))
                    Console.WriteLine(stdout);

                if (!string.IsNullOrEmpty(stderr))
                    Console.Error.WriteLine(stderr);
            };

            nodeProcess.WaitForExit();
        }
    }    
}
