"@fixture Add directory";

"@page http://127.0.0.1:1335/tests";

"@require :fs";
"@require :util";
"@require :tc";
"@require :mixin";

"@test"["Add directory"] = {
    '1': '@mixin Delete dir',
    '2.Click link "New directory"': function() {
        act.click(tc.dialogs.addDir.openBtn);
    },
    '3.Click submit button "Create"': function() {
        act.click(tc.dialogs.addDir.createBtn);
    },
    "4.Wait": function() {
        act.wait(200);
    },
    "5. Check errors": function() {
        notEq(tc.dialogs.addDir.nameInputErr, "");
    },
    '6.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.addDir.nameInput, "test", {
            offsetX: 73,
            offsetY: 19,
            caretPos: 0
        });
    },
    '7.Click submit button "Create"': function() {
        act.click(tc.dialogs.addDir.createBtn);
    },
    "8.Wait": function() {
        act.wait(200);
    },
    "9.Check page": function() {
        eq(tc.dir('test').length, 1);
    },
    "10.Clear resources": function() {
        var xhr = fs.deleteDir("/test");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    }
};

"@test"["Close button"] = {
    '1.Click link "New directory"': function() {
        act.click(tc.dialogs.addDir.openBtn);
    },
    '2.Type in input "Dir name:"': function() {
        act.type(tc.dialogs.addDir.nameInput, "test", {
            offsetX: 110,
            offsetY: 28,
            caretPos: 0
        });
    },
    '3.Click submit button "close"': function() {
        act.click(tc.dialogs.addDir.closeBtn);
    },
    '4.Click link "New directory"': function() {
        act.click(tc.dialogs.addDir.openBtn);
    },
    "5. Check input on emptiness": function() {
        eq(tc.dialogs.addDir.nameInput.val(), "");
    }
};