"@fixture Add fixture";

"@page http://127.0.0.1:1335/tests";

"@require :fs";
"@require :util";
"@require :tc";
"@require :mixin";

"@test"["Add fixture"] = {
    "1": "@mixin Delete fixture",
    '2.Click link "New fixture"': function() {
        act.click(tc.dialogs.addFixture.openBtn);
    },
    '3.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    "4.Check errors": function() {
        notEq(tc.dialogs.addFixture.nameInputErr, "");
        notEq(tc.dialogs.addFixture.fileInputErr, "");
        notEq(tc.dialogs.addFixture.pageInputErr, "");
    },
    '5.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.addFixture.nameInput, "test", {
            offsetX: 63,
            offsetY: 11,
            caretPos: 0
        });
    },
    '6.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    "7.Check errors": function() {
        notEq(tc.dialogs.addFixture.pageInputErr, "");
    },
    '8.Type in input "Web page:"': function() {
        act.type(tc.dialogs.addFixture.pageInput, "test", {
            offsetX: 95,
            offsetY: 21,
            caretPos: 0
        });
    },
    '9.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    "10.Check existing new fixture": function() {
        eq(tc.fixture('test').length, 1);
    },
    "11": "@mixin Delete fixture"
};

"@test"["Filename generator"] = {
    '1.Click link "New fixture"': function() {
        act.click(tc.dialogs.addFixture.openBtn);
    },
    '2.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.addFixture.nameInput, "test  //", {
            caretPos: 0
        });
    },
    "3.Check filename": function() {
        eq(tc.dialogs.addFixture.fileInput.val(), "test__.test.js");
    },
    '4.Click input "File name:"': function() {
        act.click(tc.dialogs.addFixture.fileInput, {
            offsetX: 85,
            offsetY: 18,
            caretPos: 14
        });
    },
    "5.Press key BACKSPACE": function() {
        act.press("backspace");
    },
    '6.Click input "Fixture name:"': function() {
        act.click(tc.dialogs.addFixture.nameInput, {
            offsetX: 115,
            offsetY: 17,
            caretPos: 8
        });
    },
    "7.Check filename": function() {
        eq(tc.dialogs.addFixture.fileInput.val(), "test__.test.j.test.js");
    },
    '8.Click input "File name:"': function() {
        act.click(tc.dialogs.addFixture.fileInput, {
            offsetX: 85,
            offsetY: 18,
            caretPos: 14
        });
    },
    "9.Set filename input value": function() {
        tc.dialogs.addFixture.fileInput.val('test__');
    },
    '10.Click input "Fixture page:"': function() {
        act.click(tc.dialogs.addFixture.pageInput, {
            offsetX: 164,
            offsetY: 27,
            caretPos: 14
        });
    },
    '11.Click input "File name:"': function() {
        act.click(tc.dialogs.addFixture.fileInput, {
            offsetX: 164,
            offsetY: 27,
            caretPos: 14
        });
    },
    "12.Check filename": function() {
        eq(tc.dialogs.addFixture.fileInput.val(), "test__.test.js");
    },
    "13.Clear filename input": function() {
        tc.dialogs.addFixture.fileInput.val('');
    },
    '14.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    "15.Check filename": function() {
        eq(tc.dialogs.addFixture.fileInput.val(), "test__.test.js");
    }
};

"@test"["Web page protocol generating"] = {
    "1": "@mixin Delete fixture",
    '2.Click link "New fixture"': function() {
        act.click(tc.dialogs.addFixture.openBtn);
    },
    '3.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.addFixture.nameInput, "test");
    },
    '4.Type in input "Web page:"': function() {
        act.type(tc.dialogs.addFixture.pageInput, "test", {
            replace: true
        });
    },
    '5.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    "6.Check protocol generating": function() {
        eq($.trim(tc.fixture('test').info.page), "http://test");
    },
    '7': "@mixin Delete fixture",
    '8.Click link "New fixture"': function() {
        act.click(tc.dialogs.addFixture.openBtn);
    },
    '9.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.addFixture.nameInput, "test");
    },
    '10.Type in input "Web page:"': function() {
        act.type(tc.dialogs.addFixture.pageInput, "http://test", {
            offsetX: 112,
            offsetY: 12,
            caretPos: 0,
            replace: true
        });
    },
    '11.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    "12.Check protocol generating": function() {
        eq($.trim(tc.fixture('test').info.page), "http://test");
    },
    '13': "@mixin Delete fixture"
};

"@test"["Close button"] = {
    '1.Click link "New fixture"': function() {
        act.click(tc.dialogs.addFixture.openBtn, {
            offsetX: 56,
            offsetY: 21
        });
    },
    '2.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    '3.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.addFixture.nameInput, "test", {
            offsetX: 110,
            offsetY: 28,
            caretPos: 0
        });
    },
    '4.Type in input "Web page:"': function() {
        act.type(tc.dialogs.addFixture.pageInput, "test", {
            offsetX: 157,
            offsetY: 13,
            caretPos: 0
        });
    },
    '5.Click submit button "close"': function() {
        act.click(tc.dialogs.addFixture.closeBtn, {
            offsetX: 5,
            offsetY: 9
        });
    },
    '6.Click link "New fixture"': function() {
        act.click(tc.dialogs.addFixture.openBtn);
    },
    "7. Check input on emptiness": function() {
        eq(tc.dialogs.addFixture.nameInput.val(), "");
        eq(tc.dialogs.addFixture.fileInput.val(), "");
        eq(tc.dialogs.addFixture.pageInput.val(), "");
    }
};

"@test"["Authentication"] = {
    '1': "@mixin Delete fixture",
    '2.Click link "New fixture"': function() {
        act.click(tc.dialogs.addFixture.openBtn);
    },
    '3.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.addFixture.nameInput, "test");
    },
    '4.Type in input "Web page:"': function() {
        act.type(tc.dialogs.addFixture.pageInput, "test");
    },
    '5.Check authentication bar': function() {
        eq(tc.dialogs.addFixture.authForm.css('display'), 'none');
    },
    '6.Click div': function() {
        act.click(tc.dialogs.addFixture.authFormBtn);
    },
    '7.Check authentication bar': function() {
        eq(tc.dialogs.addFixture.authForm.css('display'), 'table');
    },
    '8.Type in input "User name:"': function() {         
        act.type(tc.dialogs.addFixture.userInput, "test");
    },
    '9.Type in password input "Password:"': function() {
        act.type(tc.dialogs.addFixture.passInput, "test", {
            caretPos: 0
        });
    },
    '10.Click div': function() {
        act.click(tc.dialogs.addFixture.authFormBtn);
    },
    '11.Check authentication bar': function() {
        eq(tc.dialogs.addFixture.authForm.css('display'), 'none');
    },
    '12.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    '13.Wait': function() {
        act.wait(1e3);
    },
    '14.Click span': function() {
        util.showBtns();
        act.click(tc.fixture('test').btns.edit);
    },
    '15.Click link "Network..."': function() {
        act.click(tc.dialogs.editFixture.authFormBtn);
    },
    '16.Check authentication data': function() {
        eq(tc.dialogs.editFixture.userInput.val(), 'test');
        eq(tc.dialogs.editFixture.passInput.val(), 'test');
    },
    '17': "@mixin Delete fixture"
};

"@test"["Fixture already exists"] = {
    "1": "@mixin Delete fixture",
    '2': '@mixin Create fixture',
    '3.Click link "New fixture"': function() {
        act.click(tc.dialogs.addFixture.openBtn);
    },
    '4.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.addFixture.nameInput, "test");
    },
    '5.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    "6.Check errors": function() {
        eq(tc.dialogs.addFixture.nameInputErr, 'The "test" fixture already exists in the current directory.');
    },
    "7": "@mixin Delete fixture"
};