"@fixture Close project";
"@page http://localhost:1335/project";

"@require :util";
"@require :tc";

"@test"["Close project"] = {
    '1.Click link "Close project"': function() {
        act.click("#close-project-btn");
    },
    '2. Wait for animation': function() {
        act.wait(800);
    },
    '3.Check page state': function() {
        ok(!!$('.start-page-cont').length);
    },
    '4.Click link "Open project"': function() {
        act.click(tc.dialogs.openProject.openBtnStartPage);
    },
    '5.Click submit button "OK"': function() {
        act.click("#open-project-ok");
    },
    '6. Wait for animation': function() {
        act.wait(800);
    },
    '7.Check page state': function() {
        ok(!$('.start-page-cont').length);
    }
};

"@test"["Close project from nested level"] = {
    '2.Go to level 1': function() {
        act.click(tc.dir('level1'))
    },
    '2.Go to level 2': function() {
        act.click(tc.dir('level2'))
    },
    '1.Click link "Close project"': function() {
        act.click("#close-project-btn");
    },
    '2. Wait for animation': function() {
        act.wait(800);
    },
    '3.Check page state': function() {
        ok(!!$('.start-page-cont').length);
    },
    '4.Click link "Open project"': function() {
        act.click(tc.dialogs.openProject.openBtnStartPage);
    },
    '5.Select location': function() {
        act.click($('li.folder.expanded.selected').eq(0), {offsetY: 2});
    },
    '5.Click submit button "OK"': function() {
        act.click("#open-project-ok");
    },
    '6. Wait for animation': function() {
        act.wait(800);
    },
    '7.Check page state': function() {
        ok(!$('.start-page-cont').length);
        ok(window.location.pathname === '/project/');
    }
};

