"@fixture Create project";

"@page http://127.0.0.1:1335/tests";

"@require :util"
"@require :tc";

"@test"["Select directory"] = {
    "1.Click span": function() {
        act.click(tc.dialogs.createProject.openBtn, {});
    },
    "2.Open C:\\Program Files": function() {
        this.path = tc.dialogs.createProject.pathInput.val();
        act.dblclick(tc.dialogs.createProject.layout.find('li[data-path="C%3A%5CProgram%20Files"]'), {});
    },
    "3.Drag div": function() {
        act.drag(tc.dialogs.createProject.scroll, 0, -1e3, {});
    },
    "4.Click list item": function() {
        var listItem = tc.dialogs.createProject.layout.find("[data-path='C%3A%5C'].expanded span").eq(2);
        act.click(listItem, {});
    },
    "5.Check dir path": function() {
        eq(tc.dialogs.createProject.pathInput.val(), "C:\\");
    },
    "6.Click input": function() {
        act.click(tc.dialogs.createProject.pathInput, {
            caretPos: 3
        });
    },
    "7.Click input": function() {
        act.click(tc.dialogs.createProject.pathInput, {
            caretPos: 3
        });
    },
    "8.Type in input": function() {
        act.type(tc.dialogs.createProject.pathInput, "Program Files", {
            caretPos: 3
        });
    },
    "9.Check dir path": function() {
        eq(tc.dialogs.createProject.pathInput.val(), "C:\\Program Files");
    },
    '10.Click div "close"': function() {
        act.click(tc.dialogs.createProject.closeBtn, {});
    },
    "11.Click span": function() {
        act.click(tc.dialogs.createProject.openBtn, {});
    },
    "12.Check dir path": function() {
        eq(tc.dialogs.createProject.pathInput.val(), this.path);
    }
};

"@test"["Resize dialog"] = {
    "1.Click span": function() {
        act.click(tc.dialogs.createProject.openBtn, {});
    },
    "2.Drag div": function() {
        var $dialog = tc.dialogs.createProject.layout,
            div = tc.dialogs.createProject.resizeBtn,
            $fsTree = $dialog.find('.fs-tree-cont');

        this.height = $fsTree.innerHeight();
        this.width = $fsTree.innerWidth();

        act.drag(div, 50, 50);
    },
    "3.Check dialog size": function() {
        var $dialog = tc.dialogs.createProject.layout,
            $fsTree = $dialog.find('.fs-tree-cont');
        eq($fsTree.innerHeight(), this.height + 50);
        eq($fsTree.innerWidth(), this.width + 50);
    },
    "4.Drag div": function() {
        act.drag(tc.dialogs.createProject.resizeBtn, -535, -422, {
            offsetX: 4,
            offsetY: 7
        });
    },
    "5.Check dialog size": function() {
        var $dialog = tc.dialogs.createProject.layout,
            $fsTree = $dialog.find('.fs-tree-cont');
        eq($fsTree.innerHeight(), this.height);
        eq($fsTree.innerWidth(), this.width);
    }
};

"@test"["Move dialog"] = {
    "1.Click span": function() {
        act.click(tc.dialogs.createProject.openBtn);
    },
    '2.Drag span "Create project..."': function() {
        act.drag(tc.dialogs.createProject.header, -2e3, -2e3, {
            offsetX: 65,
            offsetY: 24
        });
    },
    "3.Check dialog position": function() {
        var $dialog = tc.dialogs.createProject.layout;
        eq($dialog.offset().top, 0);
        eq($dialog.offset().left, 0);
    },
    '4.Drag span "Open project..."': function() {
        act.drag(tc.dialogs.createProject.header, 200, 200, {
            offsetX: 194,
            offsetY: 14
        });
    },
    "5.Check dialog position": function() {
        var $dialog = tc.dialogs.createProject.layout;
        eq($dialog.offset().top, 200);
        eq($dialog.offset().left, 200);
    }
};

"@test"["Expand directory"] = {
    '1.Click submit button "Open project"': function() {
        act.click(tc.dialogs.createProject.openBtn);
    },
    '2.Check select': function() {
        ok($("[data-path='C%3A%5C']").hasClass('expanded'));
    },
    '3.Dblclick span "C:\\"': function() {
        var span = tc.dialogs.createProject.layout.find(".dir-name-label.expand-btn-opened").eq(0);
        act.dblclick(span);
    },
    '4.Check collapse': function() {
        ok(!tc.dialogs.createProject.layout.find("[data-path='C%3A%5C']").hasClass('expanded'));
    },
    '5.Dblclick span "C:\\"': function() {
        act.dblclick(tc.dialogs.createProject.layout.find('li[data-path="C%3A%5C"]'), {});
    },
    '6.Check expand': function() {
        ok($("[data-path='C%3A%5C']").hasClass('expanded'));
    }
};

"@test"["Validation"] = {
    '1.Open Create Project Dialog': function() {
        act.click(tc.dialogs.createProject.openBtn);
    },
    '2.Click OK btn': function() {
        act.click(tc.dialogs.createProject.okBtn);
    },
    '3.Check error msgs': function() {
        notEq(tc.dialogs.createProject.nameInputErr, "");
        eq(tc.dialogs.createProject.pathInputErr, "");
    },
    '4.Enter project name': function() {
        act.type(tc.dialogs.createProject.nameInput, 'Non-valid value */*/*/*');
    },
    '5.Click OK btn': function() {
        tc.dialogs.createProject.pathInput.val('');
        act.click(tc.dialogs.createProject.okBtn);
    },
    '6.Check error msgs': function() {
        eq(tc.dialogs.createProject.nameInput.val(), "Non-valid value ///");
    }
};