"@fixture Edit fixture";

"@page http://127.0.0.1:1335/project";

"@require :fs";
"@require :util";
"@require :tc";
"@require :mixin";

"@test"["Edit fixture"] = {
    '1': '@mixin Delete fixture test1',
    '2': '@mixin Create fixture',
    "3.Click edit btn": function() {
        util.showBtns();
        act.click(tc.fixture('test').btns.edit);
    },
    '4.Click input "Fixture name:"': function() {
        act.click(tc.dialogs.editFixture.nameInput, {
            offsetX: 121,
            offsetY: 19,
            caretPos: 12
        });
    },
    "5.Clear name input": function() {
        tc.dialogs.editFixture.nameInput.val('');
    },
    '6.Click input "Web page:"': function() {
        act.click(tc.dialogs.editFixture.pageInput, {
            offsetX: 121,
            offsetY: 19,
            caretPos: 12
        });
    },
    "7.Clear page input": function() {
        tc.dialogs.editFixture.pageInput.val('');
    },
    '8.Click submit button "OK"': function() {
        act.click(tc.dialogs.editFixture.createBtn);
    },
    "9.Check errors": function() {
        notEq(tc.dialogs.editFixture.nameInputErr, "");
        notEq(tc.dialogs.editFixture.pageInputErr, "");
    },
    '10.Type in input "fixture name:"': function() {
        act.type(tc.dialogs.editFixture.nameInput, "test1", {
            offsetX: 26,
            offsetY: 16,
            caretPos: 0
        });
    },
    '11.Type in input "Web page:"': function() {
        act.type(tc.dialogs.editFixture.pageInput, "test1", {
            offsetX: 88,
            offsetY: 30,
            caretPos: 0
        });
    },
    '12.Click submit button "OK"': function() {
        act.click(tc.dialogs.editFixture.createBtn);
    },
    "13.Check fixture": function() {
        eq(tc.fixture('test').length, 0);
        eq(tc.fixture('test1').length, 1);
        eq($.trim(tc.fixture('test1').info.page), "http://test1");
    },
    "14.Click edit btn": function() {
        util.showBtns();

        act.click(tc.fixture('test1').btns.edit);
    },
    '15.Click input "Fixture name:"': function() {
        act.click(tc.dialogs.editFixture.nameInput, {
            offsetX: 121,
            offsetY: 19,
            caretPos: 12
        });
    },
    "16.Press key BACKSPACE": function() {
        act.press("backspace");
    },
    '17.Click submit button "OK"': function() {
        act.click(tc.dialogs.editFixture.createBtn);
    },
    "18.Check fixture": function() {
        eq(tc.fixture('test1').length, 0);
        eq(tc.fixture('test').length, 1);
        eq($.trim(tc.fixture('test').info.page), "http://test1");
    },
    "19.Click edit btn": function() {
        util.showBtns();

        act.click(tc.fixture('test').btns.edit);
    },
    '20.Click input "Web page:"': function() {
        act.click(tc.dialogs.editFixture.pageInput, {
            offsetX: 77,
            offsetY: 13,
            caretPos: 12
        });
    },
    "21.Press key BACKSPACE": function() {
        act.press("backspace");
    },
    '22.Click submit button "OK"': function() {
        act.click(tc.dialogs.editFixture.createBtn);
    },
    "23.Check fixture": function() {
        eq(tc.fixture('test').length, 1);
        eq(tc.fixture('test1').length, 0);
        eq($.trim(tc.fixture('test').info.page), "http://test");
    },
    '24': '@mixin Delete fixture'
};

"@test"["Filename generator"] = {
    '1': '@mixin Create fixture',
    "2.Click edit fixture": function() {
        util.showBtns();

        act.click(tc.fixture('test').btns.edit);
    },
    "3.Clear fixture inputs": function() {
        tc.dialogs.editFixture.nameInput.val('');
        tc.dialogs.editFixture.pageInput.val('');
    },
    '4.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.editFixture.nameInput, "test  //", {
            caretPos: 0
        });
    },
    "5.Check filename": function() {
        eq(tc.dialogs.editFixture.fileInput.val(), "test__.test.js");
    },
    '6.Click input "File name:"': function() {
        act.click(tc.dialogs.editFixture.fileInput, {
            offsetX: 85,
            offsetY: 18,
            caretPos: 14
        });
    },
    "7.Press key BACKSPACE": function() {
        act.press("backspace");
    },
    '8.Click input "Fixture name:"': function() {
        act.click(tc.dialogs.editFixture.nameInput, {
            offsetX: 115,
            offsetY: 17,
            caretPos: 8
        });
    },
    "9.Check filename": function() {
        eq(tc.dialogs.editFixture.fileInput.val(), "test__.test.j.test.js");
    },
    '10.Click input "File name:"': function() {
        act.click(tc.dialogs.editFixture.fileInput, {
            offsetX: 85,
            offsetY: 18,
            caretPos: 14
        });
    },
    "11.Set file input value": function() {
        tc.dialogs.editFixture.fileInput.val('test__.test.js');
    },
    '12.Click input "fixture page:"': function() {
        act.click(tc.dialogs.editFixture.pageInput, {
            offsetX: 164,
            offsetY: 27,
            caretPos: 14
        });
    },
    '13.Click input "File name:"': function() {
        act.click(tc.dialogs.editFixture.fileInput, {
            offsetX: 164,
            offsetY: 27,
            caretPos: 14
        });
    },
    "14.Check filename": function() {
        eq(tc.dialogs.editFixture.fileInput.val(), "test__.test.js");
    },
    "15.Press key BACKSPACE": function() {
        tc.dialogs.editFixture.fileInput.val('');
    },
    '16.Click submit button "Create"': function() {
        act.click(tc.dialogs.editFixture.createBtn, {
            offsetX: 48,
            offsetY: 17
        });
    },
    "17.Check filename": function() {
        eq(tc.dialogs.editFixture.fileInput.val(), "test__.test.js");
    },
    '18': '@mixin Delete fixture'
};

"@test"["Web page protocol generating"] = {
    '1': '@mixin Create fixture',
    "2.Click edit btn": function() {
        util.showBtns();
        act.click(tc.fixture('test').btns.edit);
    },
    "3.Clear Web Page input": function() {
        tc.dialogs.editFixture.pageInput.val("");
    },
    '4.Type in input "Web page:"': function() {
        act.type(tc.dialogs.editFixture.pageInput, "webPage", {
            offsetX: 112,
            offsetY: 12,
            caretPos: 0
        });
    },
    '5.Click submit button "Create"': function() {
        act.click(tc.dialogs.editFixture.createBtn);
    },
    "6.Check protocol generating": function() {
        eq($.trim(tc.fixture('test').info.page), "http://webPage");
    },
    '7': '@mixin Create fixture',
    "8.Show edit buttons": function() {
        util.showBtns();
    },
    "9.Click edit btn": function() {
        act.click(tc.fixture('test').btns.edit);
    },
    "10.Clear Web Page input": function() {
        tc.dialogs.editFixture.pageInput.val('');
    },
    '11.Type in input "Web page:"': function() {
        act.type(tc.dialogs.editFixture.pageInput, "http://test", {
            offsetX: 112,
            offsetY: 12,
            caretPos: 0
        });
    },
    '12.Click submit button "Create"': function() {
        act.click(tc.dialogs.editFixture.createBtn);
    },
    "13.Check protocol generating": function() {
        eq($.trim(tc.fixture('test').info.page), "http://test");
    },
    '14': '@mixin Delete fixture'
};

"@test"["Close button"] = {
    '1': '@mixin Create fixture',
    "2.Click edit btns": function() {
        util.showBtns();
        act.click(tc.fixture('test').btns.edit);
    },
    '3.Type in input "Fixture name:"': function() {
        tc.dialogs.editFixture.nameInput.val('');
        tc.dialogs.editFixture.pageInput.val('');
    },
    '4.Click submit button "close"': function() {
        act.click(tc.dialogs.editFixture.closeBtn);
    },
    "5.Click edit btn": function() {
        util.showBtns();
        act.click(tc.fixture('test').btns.edit);
    },
    "6.Check input on emptiness": function() {
        eq(tc.dialogs.editFixture.nameInput.val(), "test");
        eq(tc.dialogs.editFixture.fileInput.val(), "test.test.js");
        eq(tc.dialogs.editFixture.pageInput.val(), "http://test");
    },
    '7': '@mixin Delete fixture'
};

"@test"["Authentication"] = {
    '1': '@mixin Delete fixture',
    '2.Click link "New fixture"': function() {
        act.click(tc.dialogs.addFixture.openBtn);
    },
    '3.Type in input "Fixture name:"': function() {
        act.type(tc.dialogs.addFixture.nameInput, "test", {
            caretPos: 0
        });
    },
    '4.Type in input "Web page:"': function() {
        act.type(tc.dialogs.addFixture.pageInput, "test", {
            caretPos: 0
        });
    },
    "5.Click div": function() {
        act.click(tc.dialogs.addFixture.authFormBtn);
    },
    '6.Type in input "User name:"': function() {
        act.type(tc.dialogs.addFixture.userInput, "test", {
            caretPos: 0
        });
    },
    '7.Type in password input "Password:"': function() {
        act.type(tc.dialogs.addFixture.passInput, "test", {
            caretPos: 0
        });
    },
    '8.Click submit button "Create"': function() {
        act.click(tc.dialogs.addFixture.createBtn);
    },
    '9.Wait fs event and animation': function() {
        act.wait(1e3);
    },
    '10.Set visibility': function() {
        util.showBtns();
    },
    "11.Click span": function() {
        act.click(tc.fixture('test').btns.edit);
    },
    "12.Click div": function() {
        act.click(tc.dialogs.editFixture.authFormBtn);
    },
    '13.Type in input "User name:"': function() {
        act.type(tc.dialogs.editFixture.userInput, "1", {
            caretPos: 4
        });
    },
    '14.Type in password input "Password:"': function() {
        act.type(tc.dialogs.editFixture.passInput, "1", {
            caretPos: 4
        });
    },
    '15.Click submit button "OK"': function() {
        act.click(tc.dialogs.editFixture.createBtn);
    },
    '16.Wait fs event and animation': function() {
        act.wait(1e3);
    },
    '17.Set visibility': function() {
        util.showBtns();
    },
    "18.Click span": function() {
        act.click(tc.fixture('test').btns.edit);
    },
    "19.Click div": function() {
        act.click(tc.dialogs.editFixture.authFormBtn);
    },
    '20.Check authentication data': function() {
        eq(tc.dialogs.editFixture.userInput.val(), 'test1');
        eq(tc.dialogs.editFixture.passInput.val(), 'test1');
    },
    '21': '@mixin Delete fixture'
};