"@fixture Open project";

"@page http://127.0.0.1:1335/project";

"@require :util"
"@require :tc";

"@test"["Select directory"] = {
    "1.Click span": function() {
        act.click(tc.dialogs.openProject.openBtn, {});
    },
    "2.Drag div": function() {
        this.path = tc.dialogs.openProject.pathInput.val();
        act.drag(tc.dialogs.openProject.scroll, 0, -1e3, {});
    },
    "3.Click list item": function() {
        var listItem = $("[data-path='C%3A%5C'].expanded span").eq(2);
        act.click(listItem, {});
    },
    "4.Check dir path": function() {
        eq(tc.dialogs.openProject.pathInput.val(), "C:\\");
    },
    "5.Click input": function() {
        act.click(tc.dialogs.openProject.pathInput, {
            caretPos: 3
        });
    },
    "6.Click input": function() {
        act.click(tc.dialogs.openProject.pathInput, {
            caretPos: 3
        });
    },
    "7.Type in input": function() {
        act.type(tc.dialogs.openProject.pathInput, "Program Files", {
            caretPos: 3
        });
    },
    "8.Check dir path": function() {
        eq(tc.dialogs.openProject.pathInput.val(), "C:\\Program Files");
    },
    '9.Click div "close"': function() {
        act.click(tc.dialogs.openProject.closeBtn, {});
    },
    "10.Click span": function() {
        act.click(tc.dialogs.openProject.openBtn, {});
    },
    "11.Check dir path": function() {
        eq(tc.dialogs.openProject.pathInput.val(), this.path);
    }
};

"@test"["Resize dialog"] = {
    "1.Click span": function() {
        act.click(tc.dialogs.openProject.openBtn, {});
    },
    "2.Drag div": function() {
        var $dialog = tc.dialogs.openProject.layout,
            div = tc.dialogs.openProject.resizeBtn;

        this.height = $dialog.innerHeight();
        this.width = $dialog.innerWidth();
        act.drag(div, 50, 50);
    },
    "3.Check dialog size": function() {
        var $dialog = tc.dialogs.openProject.layout;
        eq($dialog.innerHeight(), this.height + 50);
        eq($dialog.innerWidth(), this.width + 50);
    },
    "4.Drag div": function() {
        act.drag(tc.dialogs.openProject.resizeBtn, -535, -422, {
            offsetX: 4,
            offsetY: 7
        });
    },
    "5.Check dialog size": function() {
        var $dialog = tc.dialogs.openProject.layout;
        eq($dialog.innerHeight(), this.height);
        eq($dialog.innerWidth(), this.width);
    }
};

"@test"["Move dialog"] = {
    "1.Click span": function() {
        act.click(tc.dialogs.openProject.openBtn);
    },
    '2.Drag span "Open project..."': function() {
        act.drag(tc.dialogs.openProject.header, -2e3, -2e3, {
            offsetX: 65,
            offsetY: 24
        });
    },
    "3.Check dialog position": function() {
        var $dialog = tc.dialogs.openProject.layout;
        eq($dialog.offset().top, 0);
        eq($dialog.offset().left, 0);
    },
    '4.Drag span "Open project..."': function() {
        act.drag(tc.dialogs.openProject.header, 200, 200, {
            offsetX: 194,
            offsetY: 14
        });
    },
    "5.Check dialog position": function() {
        var $dialog = tc.dialogs.openProject.layout;
        eq($dialog.offset().top, 200);
        eq($dialog.offset().left, 200);
    }
};

"@test"["Expand directory"] = {
    '1.Click submit button "Open project"': function() {
        act.click(tc.dialogs.openProject.openBtn);
    },
    "2.Drag div": function() {
        act.drag(tc.dialogs.openProject.scroll, 0, -1e3, {});
    },
    '3.Click span "C:\\"': function() {
        var span = $(".dir-name-label.expand-btn-opened").eq(0);
        act.click(span);
    },
    '4.Check select': function() {
        ok(tc.dialogs.openProject.layout.find("[data-path='C%3A%5C']").hasClass('expanded'));
    },
    '5.Dblclick span "C:\\"': function() {
        var span = $(".dir-name-label.expand-btn-opened").eq(0);
        act.dblclick(span);
    },
    '6.Check collapse': function() {
        ok(!tc.dialogs.openProject.layout.find("[data-path='C%3A%5C']").hasClass('expanded'));
    },
    '7.Dblclick span "C:\\"': function() {
        var span = $("#fs-tree").find(":containsExcludeChildren(C)");
        act.dblclick(span);
    },
    '8.Check expand': function() {
        ok(tc.dialogs.openProject.layout.find("[data-path='C%3A%5C']").hasClass('expanded'));
    }
};