"@fixture Rename dir";

"@page http://127.0.0.1:1335/project";

"@require :fs";
"@require :util";
"@require :tc";
"@require :mixin";

"@test"["Rename dir"] = {
    '1': '@mixin Delete dirs',
    '2': '@mixin Create dir',
    "2.Wait": function () {
        act.wait(1e3);
    },
    "3.Click span": function () {
        util.showBtns();
        act.click(tc.dir('test').btns.rename);
    },
    "4.Press key DELETE": function () {
        tc.dialogs.renameDir.nameInput.val('');
    },
    '5.Click submit button "OK"': function () {
        act.click(tc.dialogs.renameDir.renameBtn);
    },
    "6.Check rename error": function () {
        notEq(tc.dialogs.renameDir.nameInputErr, "");
    },
    '7.Type in input "Directory name:"': function () {
        act.type(tc.dialogs.renameDir.nameInput, "test", {
            offsetX: 160,
            offsetY: 20,
            caretPos: 0
        });
    },
    '8.Click submit button "OK"': function () {
        act.click(tc.dialogs.renameDir.renameBtn);
    },
    "9.Check rename error": function () {
        eq(tc.dir('test').length, 1);
    },
    "10.Click span": function () {
        act.click(tc.dir('test').btns.rename);
    },
    '11.Type in input "Directory name:"': function () {
        act.type(tc.dialogs.renameDir.nameInput, "2", {
            offsetX: 105,
            offsetY: 8,
            caretPos: 4
        });
    },
    '12.Click submit button "OK"': function () {
        act.click(tc.dialogs.renameDir.renameBtn);
    },
    "13.Check rename error": function () {
        eq(tc.dir('test').length, 0);
        eq(tc.dir('test2').length, 1);
    },
    '14': '@mixin Delete dirs'
};

"@test"["Close button"] = {
    '1': '@mixin Create dir',
    "2.Wait": function () {
        act.wait(1e3);
    },
    "3.Click span": function () {
        util.showBtns();
        act.click(tc.dir('test').btns.rename);
    },
    "4.Clear directory name input": function () {
        tc.dialogs.renameDir.nameInput.val('');
    },
    '5.Click submit button "close"': function () {
        act.click(tc.dialogs.renameDir.closeBtn);
    },
    "6.Click div": function () {
        act.click(tc.dir('test').btns.rename);
    },
    '7.Check name': function () {
        eq(tc.dialogs.renameDir.nameInput.val(), 'test');
    },
    '8': '@mixin Delete dir'
};