"@fixture Add browser";

"@page http://127.0.0.1:1335/options";

"@require :util";

"@test"["Add browser"] = {
    "1.Try remove browser": function() {
        var xhr = util.deleteBrowser("test");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    },
    "2.Reload options view 1": function() {
        var link = $(".footer .links a").eq(0);
        act.click(link);
    },
    "3.Reload options view 2": function() {
        var link = $(".footer .links a").eq(0);
        act.click(link);
    },
    '4.Click list item "Browsers"': function() {
        act.click(":containsExcludeChildren(Browsers)");
    },
    '5.Click submit button "Add new browser"': function() {
        act.click("#add-browser-btn");
    },
    "6.Check init values": function() {
        eq($("#edit-browser-name").val(), "");
        eq($("#edit-browser-path").val(), "");
        eq($("#edit-browser-cmd").val(), "");
        eq($(".icon-checked").attr("data-browser-icon"), "unknown");
    },
    '7.Type in input "Browser name:"': function() {
        act.type("#edit-browser-name", "test", {
            replace: false
        });
    },
    '8.Type in input "Path:"': function() {
        act.type("#edit-browser-path", "C:\\Program Files\\Internet Explorer\\iexplore.exe");
    },
    '9.Type in input "Command line options:"': function() {
        act.type("#edit-browser-cmd", "cmd");
    },
    "10.Click span": function() {
        act.click(".icon-types .browser-icon.ie");
    },
    '11.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    "12.Set visibility": function() {
        util.showBtns();
    },
    "13.Click span": function() {
        act.click('.browser-row[data-browser-name="test"] .edit-browser-btn');
    },
    "14.Check values": function() {
        eq($("#edit-browser-name").val(), "test");
        eq($("#edit-browser-path").val(), "C:\\Program Files\\Internet Explorer\\iexplore.exe");
        eq($("#edit-browser-cmd").val(), "cmd");
        eq($(".icon-checked").attr("data-browser-icon"), "ie");
    },
    "15.Try remove browser": function() {
        var xhr = util.deleteBrowser("test");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    }
};

"@test"["Validation"] = {
    "1.Try remove browser": function() {
        var xhr = util.deleteBrowser("1");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    },
    "2.Reload options view 1": function() {
        var link = $(".footer .links a").eq(0);
        act.click(link);
    },
    "3.Reload options view 2": function() {
        var link = $(".footer .links a").eq(0);
        act.click(link);
    },
    '4.Click list item "Browsers"': function() {
        act.click(":containsExcludeChildren(Browsers)");
    },
    '5.Click submit button "Add new browser"': function() {
        act.click("#add-browser-btn");
    },
    '6.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    '7.Check error msg': function() {
        ok($('#edit-browser-name').hasClass('err-value'));
        ok($('#edit-browser-path').hasClass('err-value'));
        ok(!$('#edit-browser-cmd').hasClass('err-value'));
    },
    '8.Type in input "Browser name:"': function() {
        act.type("#edit-browser-name", "1");
    },
    '9.Type in input "Browser name:"': function() {
        act.type("#edit-browser-path", "1");
    },
    '10.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    '11.Check error msg': function() {
        ok(!$('#edit-browser-name').hasClass('err-value'));
        ok($('#edit-browser-path').hasClass('err-value'));
        ok(!$('#edit-browser-cmd').hasClass('err-value'));
    },
    '12.Type in input "Path:"': function() {
        act.type("#edit-browser-path", "C:\\Program Files\\Internet Explorer\\iexplore.exe", {
            replace: true
        });
    },
    '13.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    '14.Check Existing': function() {
        eq($('.browser-row[data-browser-name="1"]').length, 1);
    },
    "15.Try remove browser": function() {
        var xhr = util.deleteBrowser("1");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    }
};