"@fixture Change report path";
"@page http://127.0.0.1:1335/options";

"@require :util"
"@require :tc";

"@test"["Select directory"] = {
    '1.Go to reports tab': function() {
        act.click('.options-tabs li[data-tab="reports-options"]');
    },
    "2.Click span": function() {
        act.click(tc.dialogs.reportsPath.openBtn);
    },
    "3.Drag div": function() {
        this.initValue = tc.dialogs.reportsPath.pathInput.val();

        act.drag(tc.dialogs.reportsPath.scroll, 0, -1e3);
    },
    "4.Click list item": function() {
        var listItem = $("[data-path='C%3A%5C'].expanded span").eq(2);
        act.click(listItem);
    },
    "5.Check dir path": function() {
        eq(tc.dialogs.reportsPath.pathInput.val(), "C:\\");
    },
    "6.Click input": function() {
        act.click(tc.dialogs.reportsPath.pathInput, {
            caretPos: 3
        });
    },
    "7.Click input": function() {
        act.click(tc.dialogs.reportsPath.pathInput, {
            caretPos: 3
        });
    },
    "8.Type in input": function() {
        act.type(tc.dialogs.reportsPath.pathInput, "Program Files", {
            caretPos: 3
        });
    },
    "9.Check dir path": function() {
        eq(tc.dialogs.reportsPath.pathInput.val(), "C:\\Program Files");
    },
    '10.Click div "close"': function() {
        act.click(tc.dialogs.reportsPath.closeBtn);
    },
    "11.Click span": function() {
        act.click(tc.dialogs.reportsPath.openBtn);
    },
    "12.Check dir path": function() {
        eq(tc.dialogs.reportsPath.pathInput.val(), this.initValue);
    }
};

"@test"["Resize dialog"] = {
    '1.Go to reports tab': function() {
        act.click('.options-tabs li[data-tab="reports-options"]');
    },
    "2.Click span": function() {
        act.click(tc.dialogs.reportsPath.openBtn);
    },
    "3.Wait": function() {
        act.wait(2e3);
    },
    "4.Drag div": function() {
        var $dialog = tc.dialogs.reportsPath.layout,
            div = tc.dialogs.reportsPath.resizeBtn;

        this.height = $dialog.innerHeight();
        this.width = $dialog.innerWidth();
        console.log(this.height);console.log(this.width);
        act.drag(div, 50, 50);
    },
    "5.Check dialog size": function() {
        var $dialog = tc.dialogs.reportsPath.layout;
        eq($dialog.innerHeight(), this.height + 50);
        eq($dialog.innerWidth(), this.width + 50);
    },
    "6.Drag div": function() {
        var div = tc.dialogs.reportsPath.resizeBtn;
        act.drag(div, -535, -422, {
            offsetX: 4,
            offsetY: 7
        });
    },
    "7.Check dialog size": function() {
        var $dialog = tc.dialogs.reportsPath.layout;
        eq($dialog.innerHeight(), this.height);
        eq($dialog.innerWidth(), this.width);
    }
};

"@test"["Move dialog"] = {
    '1.Go to reports tab': function() {
        act.click('.options-tabs li[data-tab="reports-options"]');
    },
    "2.Click span": function() {
        act.click(tc.dialogs.reportsPath.openBtn);
    },
    '3.Drag span "Open project..."': function() {
        act.drag(tc.dialogs.reportsPath.header, -2e3, -2e3, {
            offsetX: 65,
            offsetY: 24
        });
    },
    "4.Check dialog position": function() {
        var $dialog = tc.dialogs.reportsPath.layout;
        eq($dialog.offset().top, 0);
        eq($dialog.offset().left, 0);
    },
    '5.Drag span "Open project..."': function() {
        var $dialog = tc.dialogs.reportsPath.layout;

        act.drag(tc.dialogs.reportsPath.header, 200, 200, {
            offsetX: 194,
            offsetY: 14
        });
    },
    "6.Check dialog position": function() {
        var $dialog = tc.dialogs.reportsPath.layout;
        eq($dialog.offset().top, 200);
        eq($dialog.offset().left, 200);
    }
};

"@test"["Expand directory"] = {
    '1.Go to reports tab': function() {
        act.click('.options-tabs li[data-tab="reports-options"]');
    },
    '2.Click submit button "Open project"': function() {
        act.click(tc.dialogs.reportsPath.openBtn);
    },
    "3.Drag div": function() {
        act.drag(tc.dialogs.reportsPath.scroll, 0, -1e3);
    },
    '4.Click span "C:\\"': function() {
        var span = $(".dir-name-label.expand-btn-opened").eq(0);
        act.click(span);
    },
    '5.Check select': function() {
        ok(tc.dialogs.reportsPath.layout.find("[data-path='C%3A%5C']").hasClass('expanded'));
    },
    '6.Dblclick span "C:\\"': function() {
        var span = $(".dir-name-label.expand-btn-opened").eq(0);
        act.dblclick(span);
    },
    '7.Check collapse': function() {
        ok(!tc.dialogs.reportsPath.layout.find("[data-path='C%3A%5C']").hasClass('expanded'));
    },
    '8.Dblclick span "C:\\"': function() {
        var span = $("#reports-path-fs-tree").find(":containsExcludeChildren(C)");
        act.dblclick(span);
    },
    '9.Check expand': function() {
        ok(tc.dialogs.reportsPath.layout.find("[data-path='C%3A%5C']").hasClass('expanded'));
    }
};