"@fixture Edit browser";

"@page http://127.0.0.1:1335/options";

"@require :util";

"@test"["Edit browser"] = {
    "1.Try remove browser": function() {
        var xhr = util.deleteBrowser("Internet Explorer");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    },
    "2.Try remove browser": function() {
        var xhr = util.deleteBrowser("test");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    },
    "3.Reload options view 1": function() {
        var link = $(".footer .links a").eq(0);
        act.click(link);
    },
    "4.Reload options view 2": function() {
        var link = $(".footer .links a").eq(0);
        act.click(link);
    },
    '5.Click list item "Browsers"': function() {
        act.click(":containsExcludeChildren(Browsers)");
    },
    '6.Click submit button "Add new browser"': function() {
        act.click("#add-browser-btn");
    },
    '7.Type in input "Browser name:"': function() {
        act.type("#edit-browser-name", "test", {
            replace: false
        });
    },
    '8.Click input "Path:"': function() {
        act.click("#edit-browser-path");
    },
    "9.Enter browser path": function() {
        act.type("#edit-browser-path", "C:\\Program Files\\Internet Explorer\\iexplore.exe");
    },
    '10.Type in input "Command line options:"': function() {
        act.type("#edit-browser-cmd", "test");
    },
    '11.Click list item "Internet Explorer"': function() {
        act.click("[title='Internet Explorer'][data-browser-icon='ie']");
    },
    '12.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    "13.Set visibility": function() {
        util.showBtns();
    },
    "14.Click span": function() {
        act.click(".browser-row[data-browser-name='test'] .edit-browser-btn");
    },
    '15.Select in input "Browser name:"': function() {
        act.select("#edit-browser-name", 4, 0);
    },
    '16.Type in input "Browser name:"': function() {
        act.type("#edit-browser-name", "Internet Explorer", {
            caretPos: 0,
            replace: false
        });
    },
    '17.Select in input "Command line options:"': function() {
        act.select("#edit-browser-cmd", 4, 0);
    },
    "18.Press key BACKSPACE": function() {
        act.press("backspace");
    },
    "19.Click span": function() {
        var span = $("#browser-options-dialog").find(".browser-icon.unknown");
        act.click(span);
    },
    '20.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    "21.Set visibility": function() {
        util.showBtns();
    },
    "22.Click span": function() {
        act.click(".browser-row[data-browser-name='Internet Explorer'] .edit-browser-btn");
    },
    "23.Check editing": function() {
        eq($("#edit-browser-name").val(), "Internet Explorer");
        eq($("#edit-browser-path").val(), "C:\\Program Files\\Internet Explorer\\iexplore.exe");
        eq($("#edit-browser-cmd").val(), "");
        eq($(".icon-checked").attr("data-browser-icon"), "unknown");
    },
    "24.Try remove browser": function() {
        util.deleteBrowser("Internet Explorer");
        util.deleteBrowser("test");
    }
};

"@test"["Validation"] = {
    "1.Try remove browser": function() {
        var xhr = util.deleteBrowser("test");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);

    },
    "2.Try remove browser": function() {
        var xhr = util.deleteBrowser("1");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    },
    "3.Reload options view 1": function() {
        var link = $(".footer .links a").eq(0);
        act.click(link);
    },
    "4.Reload options view 2": function() {
        var link = $(".footer .links a").eq(0);
        act.click(link);
    },
    "5.Click browser options btn": function() {
        var link = $('.options-tabs li').eq(0);
        act.click(link);
    },
    '6.Click submit button "Add new browser"': function() {
        act.click("#add-browser-btn");
    },
    '7.Type in input "Browser name:"': function() {
        act.type("#edit-browser-name", "test", {
            replace: false
        });
    },
    '8.Click input "Path:"': function() {
        act.click("#edit-browser-path");
    },
    "9.Enter browser path": function() {
        act.type("#edit-browser-path", "C:\\Program Files\\Internet Explorer\\iexplore.exe");
    },
    "10.Click span": function() {
        act.click(".icon-types .browser-icon.ie");
    },
    '11.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    "12.Set visibility": function() {
        util.showBtns();
    },
    "13.Click span": function() {
        act.click('.browser-row[data-browser-name="test"] .edit-browser-btn');
    },
    '14.Select in input "Browser name:"': function() {
        act.select("#edit-browser-name", 4, 0);
    },
    "15.Press key BACKSPACE": function() {
        act.press("backspace");
    },
    '16.Select in input "Browser path:"': function() {
        act.select("#edit-browser-path", 0, 47);
    },
    "17.Press key BACKSPACE": function() {
        act.press("backspace");
    },
    '18.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    '19.Check errors': function() {
        ok($("#edit-browser-name").hasClass('err-value'));
        ok($("#edit-browser-path").hasClass('err-value'));
        ok(!$("#edit-browser-cmd").hasClass('err-value'));
    },
    '20.Select in input "Path:"': function() {
        act.select("#edit-browser-path", 0, 47);
    },
    "21.Press key BACKSPACE": function() {
        act.press("backspace");
    },
    '22.Type in input "Path:"': function() {
        act.type("#edit-browser-path", "1", {
            replace: false
        });
    },
    '23.Type in input "Browser name:"': function() {
        act.type("#edit-browser-name", "1");
    },
    '24.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    '25.Check errors': function() {
        ok(!$("#edit-browser-name").hasClass('err-value'));
        ok($("#edit-browser-path").hasClass('err-value'));
        ok(!$("#edit-browser-cmd").hasClass('err-value'));
    },
    '26.Select in input "Path:"': function() {
        act.select("#edit-browser-path", 1, 0);
    },
    "27.Enter browser path": function() {
        act.type("#edit-browser-path", "C:\\Program Files\\Internet Explorer\\iexplore.exe");
    },
    '28.Click list item "Unknown Browser"': function() {
        act.click("[title='Unknown Browser'][data-browser-icon='unknown']");
    },
    '29.Click submit button "OK"': function() {
        act.click("#configure-browser-ok-btn");
    },
    "30.Set visibility": function() {
        util.showBtns();
    },
    "31.Click span": function() {
        act.click('.browser-row[data-browser-name="1"] .edit-browser-btn');
    },
    '32.Check browser options': function() {
        eq($("#edit-browser-name").val(), "1");
        eq($("#edit-browser-path").val(), "C:\\Program Files\\Internet Explorer\\iexplore.exe");
        eq($("#edit-browser-cmd").val(), "");
        eq($(".icon-checked").attr("data-browser-icon"), "unknown");
    },
    "33.Try remove browser": function() {
        var xhr = util.deleteBrowser("test");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    },
    "34.Try remove browser": function() {
        var xhr = util.deleteBrowser("1");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    }
};