"@fixture Operations with reports";

"@page http://127.0.0.1:1335/project";

"@require :util";
"@require :tc";
"@require :mixin";

"@test"["Clear reports"] = {
    '1': '@mixin Run tests and go to results view',
    '2.Wait for the task':function(){
        act.wait(1e3);
    },
    '3.Click clear reports': function() {
        act.click(tc.dialogs.clearReports.openBtn);
    },
    '4.Click no btn': function() {
        act.click(tc.dialogs.clearReports.noBtn);
    },
    '5.Click clear reports': function() {
        act.click(tc.dialogs.clearReports.openBtn);
    },
    '6.Click yes btn': function() {
        act.click(tc.dialogs.clearReports.yesBtn);
    },
    '7.Check results': function() {
        ok(!$('.task-results-item.failed-view').length);
        ok(!$('.task-results-item.succeeded-view').length);
    }
};

"@test"["Remove single report - list view"] = {
    '1': '@mixin Run tests and go to results view',
    '2.Click clear reports': function() {
        var $btn = tc.dialogs.removeReport.openBtn.eq(0);
        this.taskUid = $btn.closest('.detail-link').attr('data-taskid');

        act.click($btn);
    },
    '3.Click no btn': function() {
        act.click(tc.dialogs.removeReport.noBtn);
    },
    '4.Click clear reports': function() {
        act.click(tc.dialogs.removeReport.openBtn.eq(0));
    },
    '5.Click yes btn': function() {
        act.click(tc.dialogs.removeReport.yesBtn);
    },
    '6.Check results': function() {
        ok(!$('.detail-link[data-taskid="' + this.taskUid + '"]').length);
    }
};

"@test"["Remove single report - detail view"] = {
    '1': '@mixin Run tests and go to results view',
    '2.Go to detail view': function() {
        act.click($('.detail-link').eq(0));
    },
    '3.Click clear reports': function() {
        var $btn = tc.dialogs.removeReport.openBtn;
        this.taskUid = $btn.closest('.detail-link').attr('data-taskid');

        act.click($btn);
    },
    '4.Click no btn': function() {
        act.click(tc.dialogs.removeReport.noBtn);
    },
    '5.Click clear reports': function() {
        act.click(tc.dialogs.removeReport.openBtn.eq(0));
    },
    '6.Click yes btn': function() {
        act.click(tc.dialogs.removeReport.yesBtn);
    },
    '7.Check results': function() {
        ok(!$('.detail-link[data-taskid="' + this.taskUid + '"]').length);
        ok(/\/results\/$/.test(window.location.pathname));
    }
};
