"@fixture Results navigation";

"@page http://127.0.0.1:1335/project";

"@require :util";
"@require :tc";
"@require :mixin";

"@test"["Results navigation"] = {
    '1': '@mixin Run tests and go to results view',
    '2.Check creating results': function () {
        eq($('.task-name.detail-link').eq(0).text(), '"Fast test" fixture tests');
    },
    '3.Click paragraph "0"': function () {
        var task = $('.task-name.detail-link').eq(0);

        act.click(task);
    },
    '4.Check detail task view': function () {
        ok(/\/results\/[a-z0-9-]{36}/.test(window.location.pathname));
    },
    '5.Click link "results"': function () {
        act.click('.root.nav-link');
    },
    '6.Check results view': function () {
        ok(/\/results\/$/.test(window.location.pathname));
    }
};

"@test"["Restart task - list view"] = {
    '1': '@mixin Run tests and go to results view',
    '2.Click restart': function() {
        act.click($('.detail-link .restart-task').eq(0));
    },
    '3.Check location': function() {
        ok(/\/results\/$/.test(window.location.pathname));
    },
    '4.Hover': function() {
        act.hover($('.detail-link .restart-task').eq(0));
    },
    '5.Restart tests': function() {
        act.click($('.restart-options').eq(0).find('li').eq(0));
    },
    '6.Check location': function() {
        ok(/\/results\/[a-z0-9-]{36}/.test(window.location.pathname));
    }
};

"@test"["Restart task - detail view"] = {
    '1': '@mixin Run tests and go to results view',
    '2.Click link "RESULTS"': function () {
        act.click(":containsExcludeChildren(RESULTS)");
    },
    '3.Go to detail view': function() {
        act.click($('.detail-link').eq(0));
    },
    '4.Click restart': function() {
        act.click($('.report-head .restart-task').eq(0));
    },
    '5.Check location': function() {
        ok(/\/results\/[a-z0-9-]{36}/.test(window.location.pathname));
    },
    '6.Hover': function() {
        act.hover($('.report-head .restart-task').eq(0));
    },
    '7.Restart tests': function() {
        act.click($('.restart-options').eq(0).find('li').eq(0));
    },
    '8.Check location': function() {
        ok(/\/results\/[a-z0-9-]{36}/.test(window.location.pathname));
    }
};

"@test"["Hide top panel"] = {
    '1': '@mixin Run tests and go to results view',
    '2.Wait for the task':function(){
        act.wait(1e3);
    },
    '3.Check top panel visibility': function() {
        ok($('.results-top-buttons').is(':visible'));
    },
    '4.Update page': function() {
        act.navigateTo(window.location.href);
    },
    '5.Check top panel visibility': function() {
        ok($('.results-top-buttons').is(':visible'));
    },
    '6.Go to detail view': function() {
        act.click($('.detail-link').eq(0));
    },
    '7.Check top panel visibility': function() {
        ok(!$('.results-top-buttons').is(':visible'));
    },
    '8.Update page': function() {
        act.navigateTo(window.location.href);
    },
    '9.Check top panel visibility': function() {
        ok(!$('.results-top-buttons').is(':visible'));
    },
    '10.Go to list view': function() {
        act.click($('.root.nav-link'));
    },
    '11.Check top panel visibility': function() {
        ok($('.results-top-buttons').is(':visible'));
    },
    '12.Open clear reports dialog': function() {
        act.click(tc.dialogs.clearReports.openBtn);
    },
    '13.Click yes button': function() {
        act.click(tc.dialogs.clearReports.yesBtn);
    },
    '14.Check top panel visibility': function() {
        ok(!$('.results-top-buttons').is(':visible'));
    }
};

"@test"["Run directory test - name with space symbol"] = {
    '1.Add ie to config': function () {
        var xhr = util.addBrowser('Internet Explorer');

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    },
    '2.Navigate to level1': function () {
        act.click(tc.dir('level1'));
    },
    '3.Set visibility': function () {
        util.showBtns();
    },
    '4.Click link "Run"': function () {
        var $row = tc.dir('spaces in name'),
            link = $row.find(".run-button");

        this.taskUid = $row.attr('data-fixtureuid');

        act.click(link);
    },
    '5.Click span "Internet Explorer"': function () {
        act.click("[data-browsername='Internet Explorer']");
    },
    '6.Click submit button "Run"': function () {
        act.click("#dialog-run-btn");
    },
    '7.Wait': function () {
        act.wait(5e3);
    },
    '8.Click link "RESULTS"': function () {
        act.click(":containsExcludeChildren(RESULTS)");
    },
    '9.Check creating results': function () {
        eq($('.task-name.detail-link').eq(0).text(), '"spaces in name" directory tests');
    }
};

"@test"["Expand test errors"] = {
    '1': '@mixin Run tests and go to results view',
    '2': function() {
        act.click($('.detail-link').eq(0));
    },
    '2. Expand "Fail" row': function() {
        var $row = $('.dx-datagrid').find('p.fail').closest('tr');
        act.click($row, {offsetX: 10, offsetY: 10});
    },
    '3. Check expanding': function() {
        var $row = $('.dx-datagrid').find('p.fail').closest('tr');
        notEq($row.next().css('display'), 'none');
    },
    '4. Try expand "Passed" row': function() {
        var $row = $('.dx-datagrid').find('p.passed').closest('tr');
        act.click($row, {offsetX: 10, offsetY: 10});
    },
    '5. Check expanding': function() {
        var $row = $('.dx-datagrid').find('p.passed').closest('tr');
        notOk(($row.next()).hasClass('dx-master-detail-row'));
    }
};