"@fixture Navigation State";

"@page http://127.0.0.1:1335/project";

"@require :tc";
"@require :util";
"@require :fs";

"@test"["Restore navigation state"] = {
    "1.At level 1": function() {
        act.click(tc.dir('level1'), {
            offsetX: 340,
            offsetY: 34
        });
    },
    "2.At level 2": function() {
        act.click(tc.dir('level2'), {
            offsetX: 356,
            offsetY: 15
        });
    },
    '3.Click link "RESULTS"': function() {
        act.click(".tabs a:containsExcludeChildren(RESULTS)");
    },
    '4.Click link "PROJECT"': function() {
        act.click(".tabs a:containsExcludeChildren(PROJECT)");
    },
    "5.Check level 2": function() {
        eq(tc.fixture('level2').length, 1);
    },
    "6.At level 1": function() {
        var tableCell = $("#project-browser").find(".browser-cell.nav-button").eq(1);
        act.click(tableCell, {
            offsetX: 99,
            offsetY: 34
        });
    },
    '7.Click link "RESULTS"': function() {
        act.click(".tabs a:containsExcludeChildren(RESULTS)");
    },
    '8.Click link "PROJECT"': function() {
        act.click(".tabs a:containsExcludeChildren(PROJECT)");
    },
    "9.Check level 1": function() {
        eq(tc.fixture('level1').length, 1);
    },
    "10.At root level": function() {
        var tableCell = $("#project-browser").find(".browser-cell.nav-button").eq(1);
        act.click(tableCell, {
            offsetX: 215,
            offsetY: 20
        });
    },
    '11.Click link "RESULTS"': function() {
        act.click(".tabs a:containsExcludeChildren(RESULTS)");
    },
    '12.Click link "PROJECT"': function() {
        act.click(".tabs a:containsExcludeChildren(PROJECT)");
    },
    "13.Check Root": function() {
        eq(tc.fixture('Root Marker').length, 1);
    }
};

"@test"["Restore expanded elements"] = {
    "1.Click div": function() {
        act.click(tc.fixture('Root Marker'));
    },
    '2.Click link "RESULTS"': function() {
        act.click(".tabs a:containsExcludeChildren(RESULTS)");
    },
    '3.Click link "project"': function() {
        var link = $(".tabs a").eq(0);
        act.click(link);
    },
    '4.Check expanded element': function() {
        ok(tc.fixture('Root Marker').isExpanded());
    },
    "5.Click table cell": function() {
        act.click(tc.fixture('Root Marker'));
    },
    '6.Click link "RESULTS"': function() {
        act.click(".tabs a:containsExcludeChildren(RESULTS)");
    },
    '7.Click link "project"': function() {
        var link = $(".tabs a").eq(0);
        act.click(link);
    },
    '8.Check collapsed element': function() {
        notOk(tc.fixture('Root Marker').isExpanded());
    }
};

"@test"["Restore expanded tests group"] = {
    '1.Click div': function() {
        act.click(tc.fixture('Data driving test'));
    },
    '2.Expand group': function() {
        act.click(tc.fixture('Data driving test').test('Test1').find('.expand-test-group'));
    },
    '3.Click link "RESULTS"': function() {
        act.click(".tabs a:containsExcludeChildren(RESULTS)");
    },
    '4.Click link "project"': function() {
        var link = $(".tabs a").eq(0);
        act.click(link);
    },
    '5.Check expanded group': function() {
        eq(tc.fixture('Data driving test').test('Test1').css('display'), 'none');
        eq(tc.fixture('Data driving test').test('My first test').css('display'), 'block');
    },
    '6.Collapse tests group': function() {
        act.click(tc.fixture('Data driving test').test('Test1').next().find('.collapse-test-group'));
    },
    '7.Expand other tests group': function() {
        act.click(tc.fixture('Data driving test').test('My first test').find('.expand-test-group'));
    },
    '8.Click link "RESULTS"': function() {
        act.click(".tabs a:containsExcludeChildren(RESULTS)");
    },
    '9.Click link "project"': function() {
        var link = $(".tabs a").eq(0);
        act.click(link);
    },
    '10.Check collapsed element': function() {
        eq(tc.fixture('Data driving test').test('Test1').css('display'), 'block');
        eq(tc.fixture('Data driving test').test('My first test').css('display'), 'none');
    }
};

"@test"["Hide top panel"] = {
    '1.Check top panel visibility': function() {
        ok($('.fixtures-top-buttons').is(':visible'));
    },
    '2.Go to level1': function() {
        act.click(tc.dir('level1'));
    },
    '3.Check top panel visibility': function() {
        ok($('.fixtures-top-buttons').is(':visible'));
    },
    '4.Back to root level': function() {
        act.click($('.root.nav-link'));
    },
    '5.Check top panel visibility': function() {
        ok($('.fixtures-top-buttons').is(':visible'));
    },
    '6.Open dir dialog': function() {
        act.click(tc.dialogs.addDir.openBtn);
    },
    '7.Enter dir name': function() {
        act.type(tc.dialogs.addDir.nameInput, 'test');
    },
    '8.Click create': function() {
       act.click(tc.dialogs.addDir.createBtn);
    },
    '9.Check top panel visibility': function() {
        ok($('.fixtures-top-buttons').is(':visible'));
    },
    "10.Clear resources": function() {
        var xhr = fs.deleteDir("/test");

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    }
};