"@fixture Navigation";

"@page http://127.0.0.1:1335/project";

"@require :util";
"@require :tc";

"@test"["Go to current task"] = {
    '1.Add ie to config': function() {
        var xhr = util.addBrowser('Internet Explorer');

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    },
    "2.Create task": function() {
        util.showBtns();
        util.hideTestsStatus();

        act.click(tc.fixture('Root Marker').btns.run);
    },
    "3.Open run dialog": function() {
        act.click("input[data-browsername='Internet Explorer']")
    },
    "4.Run test": function() {
        act.click(tc.dialogs.run.runBtn);
    },
    "5.Go to workers view": function() {
        var link = $(".tabs a").eq(2);
        act.click(link);
    },
    "6.Go to current task": function() {
        act.click($('.workers-dashboard tr').eq(1).find('.task-info a'));
    },
    "7.Check page": function() {
        ok(/results\/[a-z0-9-]{36}/.test(window.location.pathname));
    },
    "8.Return to workers view": function() {
        var link = $(".tabs a").last();
        act.click(link, {});
    },
    "9.Go to current task": function() {
        var link = $('.workers-dashboard tr').eq(1).find('.task-info a');
        act.click(link);
    },
    "10.Check page": function() {
        ok(/results\/[a-z0-9-]{36}/.test(window.location.pathname));
    }
};

"@test"["Go to current test"] = {
    '1.Add ie to config': function() {
        var xhr = util.addBrowser('Internet Explorer');

        act.waitFor(xhr, util.WAIT_FOR_TIMEOUT);
    },
    "2.Create task": function() {
        util.showBtns();
        util.hideTestsStatus();
        act.click(tc.fixture('Root Marker').btns.run);
    },
    "3.Open run dialog": function() {
        act.click("input[data-browsername='Internet Explorer']")
    },
    "4.Run test": function() {
        act.click(tc.dialogs.run.runBtn);
    },
    "5.Go to workers view": function() {
        var link = $(".tabs a").eq(2);
        act.click(link, {});
    },
    "6.Go to current test": function() {
        var worker = this.worker,
            link = $('.workers-dashboard tr').eq(1).find('.current-test a').eq(0);
        act.click(link, {});
    },
    "7.Wait": function() {
        act.wait(300);
    },
    "8.Check page": function() {
        ok(tc.fixture('Root Marker').isExpanded());
    }
};