"@fixture Sorting workers";

"@page http://127.0.0.1:1335/workers";

"@require :util";

"@test"["Sorting by name"] = {
    "1.Create workers": function() {
        util.addUniqueWorker();
        util.addUniqueWorker();
    },
    "2.Wait": function() {
        act.wait(300);
    },
    "2.Sorting by name: ask order": function() {
        var link = $('.workers-dashboard .name-sort');

        act.click(link, {});
    },
    "3. Check sorting": function() {
        var $tablesRows = $('.workers-dashboard table tbody tr');

        ok($tablesRows.eq(0).attr('data-workername') < $tablesRows.eq(1).attr('data-workername'));
    },
    "4.Sorting by name: desc order": function() {
        act.click('.workers-dashboard .name-sort');
    },
    "5. Check sorting": function() {
        var $tablesRows = $('.workers-dashboard table tbody tr');

        ok($tablesRows.eq(0).attr('data-workername') > $tablesRows.eq(1).attr('data-workername'));
    }
};

"@test"["Sorting by type"] = {
    "1.Create workers": function() {
        util.addUniqueWorker();
        util.addUniqueWorker();
    },
    "2.Wait": function() {
        act.wait(300);
    },
    "3.Emulate auto-generate worker": function() {
        var worker = this.worker,
            workerRow = $('.workers-dashboard table tbody tr').eq(0);

        workerRow.find('.worker-type p').removeClass('connected').addClass('auto-created').text('Auto-created');

    },
    "4.Sorting by type: ask order": function() {
        act.click('.workers-dashboard .type-sort');
    },
    "5. Check sorting": function() {
        var $tablesRows = $('.workers-dashboard table tbody tr');

        ok($tablesRows.eq(0).find('.worker-type p.auto-created').length, 1);
    },
    "6.Sorting by type: desc order": function() {
        act.click('.workers-dashboard .type-sort');
    },
    "7. Check sorting": function() {
        var $tablesRows = $('.workers-dashboard table tbody tr');

        ok($tablesRows.eq(0).find('.worker-type p.connected').length, 1);
    }
};