var fs = {};

fs.REQUEST_COMPLETE_DELAY = 400;

fs.createFixture = function(name, filename, path) {
	var options = {
		  curPath: path,
		  fixtureName: name,
          filename: filename,
          fixturePage: 'http://test'
	};

    return function(callback) {
        $.post('http://127.0.0.1:1335/create_fixture/', options).complete(function() {
            setTimeout(callback, fs.REQUEST_COMPLETE_DELAY);
        });
    };
};

fs.createDir = function(path, name) {
	var options = {
		curPath: path,
		dirName: name
	};

    return function(callback) {
        $.post('http://127.0.0.1:1335/create_dir/', options).complete(function() {
            setTimeout(callback, fs.REQUEST_COMPLETE_DELAY);
        });
    };
};

fs.deleteFixture = function(path, filename) {
	var options = {
		  curPath: path,
		  fixtureFilename: filename
	};

    var targetFixture = $('.browser-row[data-fixture-file="' + filename + '"]');

    if(targetFixture.length)
        return function(callback) {
            $.post('http://127.0.0.1:1335/delete_fixture/', options).complete(function() {
                setTimeout(callback, fs.REQUEST_COMPLETE_DELAY);
            });
        };
    else
        return function(callback){
            callback();
        };
};

fs.deleteDir = function(path) {
    var pathArr = path.split('/'),
        targetDir = pathArr[pathArr.length - 1];

    if(targetDir.length)
        return function(callback) {
            $.post('http://127.0.0.1:1335/delete_dir/', {curPath: path}).complete(function() {
                setTimeout(callback, fs.REQUEST_COMPLETE_DELAY);
            });
        };
    else
        return function(callback){
            callback();
        };
};

fs.addTestToFixture = function(filename, fixtureName, testName) {
    var fixtureCode = '"@fixture ' + fixtureName + '";\n' +
    '"@page http://127.0.0.1:1335";\n' +
    '"@test"["' + testName + '"] = {\n' +
        '"step": function() {\n' +
            'act.wait(1);\n' +
        '}\n' +
    '};';

    var options = {
        filename: filename,
        urlPath: '/',
        code: fixtureCode
    };

    return function(callback) {
        $.post('http://127.0.0.1:1335/save_fixture_code/', options, function(res) {}).complete(function() {
            setTimeout(callback, fs.REQUEST_COMPLETE_DELAY);
        });
    };
};

fs.createDataDrivingTest = function(filename, fixtureName, testName) {
    var fixtureCode = '"@fixture ' + fixtureName + '";\n' +
        '"@page http://127.0.0.1:1335";\n' +
        '"@test"["' + testName + '"] = {\n' +
        '"@testCases": [{"@name": "1", data: 1}, {"@name": "2", data: 2}],' +
        '"step": function() {\n' +
        'act.wait(1);\n' +
        '}\n' +
        '};';

    var options = {
        filename: filename,
        urlPath: '/',
        code: fixtureCode
    };

    return function(callback) {
        $.post('http://127.0.0.1:1335/save_fixture_code/', options, function(res) {}).complete(function() {
            setTimeout(callback, fs.REQUEST_COMPLETE_DELAY);
        });
    };
};

