var tc = (function () {
    var
    //Selectors
        ADD_DIR_BTN ='#add-dir-btn',
        ADD_DIR_DLG_CLOSE_BTN = '.dialog.add-dir .dialog-close-btn',
        ADD_DIR_DLG_OPEN_BTN = '.add-dir-btn',
        ADD_DIR_NAME_INPUT = '#add-dir-name',
        ADD_FIXTURE_BTN = '#add-fixture-btn',
        ADD_FIXTURE_DLG_AUTH_FORM = '#add-fixture-auth-credentials-group table',
        ADD_FIXTURE_DLG_AUTH_FORM_BTN = '#add-fixture-show-credentials',
        ADD_FIXTURE_DLG_CLOSE_BTN = '.dialog.add-fixture .dialog-close-btn',
        ADD_FIXTURE_DLG_OPEN_BTN = '.add-fixture-btn',
        ADD_FIXTURE_FILENAME_INPUT = '#add-fixture-filename',
        ADD_FIXTURE_NAME_INPUT ='#add-fixture-name',
        ADD_FIXTURE_PAGE_INPUT = '#add-fixture-page',
        ADD_FIXTURE_PASS_INPUT = '#add-fixture-auth-password',
        ADD_FIXTURE_USER_INPUT = '#add-fixture-auth-username',
        ANIM_CONT = '.anim-container',
        BROWSER_ROW = '.browser-row',
        BROWSER_WORKERS = '.browserWorkers input[type="checkbox"]',
        CHANGE_REPORTS_PATH_DLG_CLOSE_BTN = '.dialog.reports-path .dialog-close-btn',
        CHANGE_REPORTS_PATH_DLG_HEADER = '.dialog.reports-path .dialog-header',
        CHANGE_REPORTS_PATH_DLG_LAYOUT = '.dialog.reports-path',
        CHANGE_REPORTS_PATH_DLG_OPEN_BTN = '#change-report-btn',
        CHANGE_REPORTS_PATH_PATH_INPUT = '#reports-path-dialog-input',
        CHANGE_REPORTS_PATH_SCROLLBAR = '.reports-path-scrollbar',
        CLEAR_REPORTS_DLG_NO_BTN = '#clear-reports-no-btn',
        CLEAR_REPORTS_DLG_OPEN_BTN = '#clear-reports',
        CLEAR_REPORTS_DLG_YES_BTN = '#clear-reports-yes-btn',
        CONNECTED_WORKERS = '.connectedWorkers input[type="checkbox"]',
        CREATE_PROJECT_DLG_CLOSE_BTN = '.dialog.create-project .dialog-close-btn',
        CREATE_PROJECT_DLG_HEADER = '.dialog.create-project .dialog-header',
        CREATE_PROJECT_DLG_LAYOUT = '.dialog.create-project',
        CREATE_PROJECT_DLG_OK_BTN = '#create-project-ok-btn',
        CREATE_PROJECT_DLG_OPEN_BTN = '.create-project-btn',
        CREATE_PROJECT_NAME_INPUT = '#project-name',
        CREATE_PROJECT_PATH_INPUT = '#project-path',
        CREATE_PROJECT_SCROLLBAR = '.create-project-scrollbar',
        DELETE_DIR_BTN = '.delete-dir-btn',
        DELETE_DIR_NO_BTN = '#delete-dir-no-btn',
        DELETE_DIR_YES_BTN = '#delete-dir-yes-btn',
        DELETE_FIXTURE_BTN = '.delete-fixture-btn',
        DELETE_FIXTURE_NO_BTN = '#delete-fixture-no-btn',
        DELETE_FIXTURE_YES_BTN = '#delete-fixture-yes-btn',
        DELETE_TEST_NO_BTN = '#delete-test-no-btn',
        DELETE_TEST_YES_BTN = '#delete-test-yes-btn',
        DESELECT_ALL_BROWSERS = '#deselect-all-browsers',
        DESELECT_ALL_WORKERS = '#deselect-all-workers',
        DIALOG = '.dialog',
        DIALOG_CLOSE_BTN = '.dialog-close-btn',
        EDIT_FIXTURE_BTN = '#edit-fixture-btn',
        EDIT_FIXTURE_DLG_AUTH_FORM = '#edit-fixture-auth-credentials-group table',
        EDIT_FIXTURE_DLG_AUTH_FORM_BTN = '#edit-fixture-show-credentials',
        EDIT_FIXTURE_DLG_CLOSE_BTN = '.dialog.edit-fixture .dialog-close-btn',
        EDIT_FIXTURE_DLG_OPEN_BTN = '.edit-fixture-btn',
        EDIT_FIXTURE_FILENAME_INPUT = '#edit-fixture-filename',
        EDIT_FIXTURE_NAME_INPUT = '#edit-fixture-name',
        EDIT_FIXTURE_PAGE_INPUT = '#edit-fixture-page',
        EDIT_FIXTURE_PASS_INPUT = '#edit-fixture-auth-password',
        EDIT_FIXTURE_USER_INPUT = '#edit-fixture-auth-username',
        ERR_TEXT = '.err-text',
        FAIL_ON_JS_ERRS_OPTION = '#fail-on-js-errors-option',
        FIXTURE_FILENAME = '.file-name',
        FIXTURE_PAGE = '.fixture-page',
        OPEN_PROJECT_BTN = '.open-project-btn',
        OPEN_PROJECT_DLG_CLOSE_BTN = '.dialog.open-project .dialog-close-btn',
        OPEN_PROJECT_DLG_HEADER = '.dialog.open-project .dialog-header',
        OPEN_PROJECT_DLG_LAYOUT = '.dialog.open-project',
        OPEN_PROJECT_PATH_INPUT = '#input-path',
        OPEN_PROJECT_SCROLLBAR = '.open-project-scrollbar',
        PROJECT_BROWSER = '#project-browser',
        REMOVE_REPORT_BTN = '.remove-report-btn',
        REMOVE_REPORT_NO_BTN = "#remove-report-no-btn",
        REMOVE_REPORT_YES_BTN = '#remove-report-yes-btn',
        RENAME_DIR_BTN = '#rename-dir-btn',
        RENAME_DIR_DLG_CLOSE_BTN = '.dialog.rename-dir .dialog-close-btn',
        RENAME_DIR_DLG_OPEN_BTN = '.rename-dir-btn',
        RENAME_DIR_NAME_INPUT = '#rename-dir-dir-name',
        RENAME_TEST_BTN = '#rename-test-btn',
        RENAME_TEST_NAME_INPUT = '#test-new-name',
        RESIZE_MARKER = '.resize-marker',
        RUN_BTN = '.run-button',
        RUN_DLG_RUN_BTN = '#dialog-run-btn',
        SELECT_ALL_BROWSERS = '#select-all-browsers',
        SELECT_ALL_WORKERS = '#select-all-workers',
        WORKERS_LIST_DLG = '.worker-list-dialog',

    //Classes

    //Attributes
        DIR_NAME_ATTR = 'data-dir-name',
        FIXTURE_NAME_ATTR = 'data-fixture-name',
        TEST_NAME_ATTR = 'data-test-name';

    function getErrText($input) {
        return $input.next().find(ERR_TEXT).text();
    }

    var tc = {};

    tc.fixture = function (name) {
        var fixture = $(PROJECT_BROWSER).find(BROWSER_ROW).filter(function () {
                return $(this).attr(FIXTURE_NAME_ATTR) === name;
            }),
            $fixtureInfo = fixture.closest('tr').next(),
            $tests = fixture.next();

        fixture.btns = {
            delete: fixture.find(DELETE_FIXTURE_BTN).eq(0),
            edit: fixture.find(EDIT_FIXTURE_DLG_OPEN_BTN).eq(0),
            run: fixture.find(RUN_BTN).eq(0)
        };

        fixture.info = {
            page: $fixtureInfo.find(FIXTURE_PAGE).text(),
            file: $fixtureInfo.find(FIXTURE_FILENAME).text()
        };

        fixture.test = function (name) {
            return $tests.find('tr').filter(function() {
                return $(this).attr(TEST_NAME_ATTR) === name;
            });
        };

        fixture.isExpanded = function () {
            return $tests.find(ANIM_CONT).css("display") !== 'none';
        };

        return fixture;
    };

    tc.dir = function (name) {
        var dir = $(BROWSER_ROW).filter(function() {
            return $(this).attr(DIR_NAME_ATTR) === name;
        });

        dir.btns = {
            delete: dir.find(DELETE_DIR_BTN).eq(0),
            rename: dir.find(RENAME_DIR_DLG_OPEN_BTN).eq(0),
            run: dir.find(RUN_BTN).eq(0)
        };

        return dir;
    };

    tc.dialogs = {
        //IDE autocomplete references
        addDir: {
            openBtn: null,
            closeBtn: null,
            createBtn: null,
            nameInput: null,
            nameInputErr: null
        },
        addFixture: {
            openBtn: null,
            closeBtn: null,
            createBtn: null,
            nameInput: null,
            nameInputErr: null,
            fileInput: null,
            fileInputErr: null,
            pageInput: null,
            pageInputErr: null,
            authForm: null,
            authFormBtn: null,
            userInput: null,
            passInput: null
        },
        createProject: {
            openBtn: null,
            scroll: null,
            pathInput: null,
            closeBtn: null,
            okBtn: null,
            layout: null,
            resizeBtn: null,
            header: null,
            nameInputErr: null,
            pathInputErr: null
        },
        clearReports: {
            openBtn: null,
            yesBtn: null,
            noBtn: null
        },
        removeReport: {
            openBtn: null,
            yesBtn: null,
            noBtn: null
        },
        deleteFixture: {
            yesBtn: null,
            noBtn: null
        },
        deleteDir: {
            yesBtn: null,
            noBtn: null
        },
        deleteTests: {
            yesBtn: null,
            noBtn: null
        },
        editFixture: {
            closeBtn: null,
            createBtn: null,
            nameInput: null,
            nameInputErr: null,
            fileInput: null,
            fileInputErr: null,
            pageInput: null,
            pageInputErr: null,
            authForm: null,
            authFormBtn: null,
            userInput: null,
            passInput: null
        },
        openProject: {
            openBtn: null,
            openBtnStartPage: null,
            scroll: null,
            pathInput: null,
            closeBtn: null,
            layout: null,
            resizeBtn: null,
            header: null
        },
        renameTest: {
            renameBtn: null,
            nameInput: null,
            nameInputErr: null
        },
        renameDir: {
            closeBtn: null,
            renameBtn: null,
            nameInput: null,
            nameInputErr: null
        },
        run: {
            selectAllBrowsers: null,
            selectAllWorkers: null,
            deselectAllBrowsers: null,
            deselectAllWorkers: null,
            browsers: null,
            checkedBrowsers: null,
            workers: null,
            checkedWorkers: null,
            runBtn: null,
            failIfJSErrors: null
        },
        reportsPath: {
            openBtn: null,
            openBtnStartPage: null,
            scroll: null,
            pathInput: null,
            closeBtn: null,
            layout: null,
            resizeBtn: null,
            header: null
        }
    };

    Object.defineProperty(tc.dialogs, 'addDir', {
        get: function () {
            var $addDirName = $(ADD_DIR_NAME_INPUT);

            return {
                openBtn: $(ADD_DIR_DLG_OPEN_BTN).eq(0),
                closeBtn: $(ADD_DIR_DLG_CLOSE_BTN),
                createBtn: $(ADD_DIR_BTN),
                nameInput: $addDirName,
                nameInputErr: getErrText($addDirName)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'addFixture', {
        get: function () {
            var $addFixtureName = $(ADD_FIXTURE_NAME_INPUT),
                $addFixtureFilename = $(ADD_FIXTURE_FILENAME_INPUT),
                $addFixturePage = $(ADD_FIXTURE_PAGE_INPUT);

            return {
                openBtn: $(ADD_FIXTURE_DLG_OPEN_BTN).eq(0),
                createBtn: $(ADD_FIXTURE_BTN),
                closeBtn: $(ADD_FIXTURE_DLG_CLOSE_BTN),
                nameInput: $addFixtureName,
                nameInputErr: getErrText($addFixtureName),
                fileInput: $addFixtureFilename,
                fileInputErr: getErrText($addFixtureFilename),
                pageInput: $addFixturePage,
                pageInputErr: getErrText($addFixturePage),
                authForm: $(ADD_FIXTURE_DLG_AUTH_FORM),
                authFormBtn: $(ADD_FIXTURE_DLG_AUTH_FORM_BTN),
                userInput: $(ADD_FIXTURE_USER_INPUT),
                passInput: $(ADD_FIXTURE_PASS_INPUT)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'editFixture', {
        get: function () {
            var $editFixtureName = $(EDIT_FIXTURE_NAME_INPUT),
                $editFixtureFilename = $(EDIT_FIXTURE_FILENAME_INPUT),
                $editFixturePage = $(EDIT_FIXTURE_PAGE_INPUT);

            return {
                closeBtn: $(EDIT_FIXTURE_DLG_CLOSE_BTN),
                createBtn: $(EDIT_FIXTURE_BTN),
                nameInput: $editFixtureName,
                nameInputErr: getErrText($editFixtureName),
                fileInput: $editFixtureFilename,
                fileInputErr: getErrText($editFixtureFilename),
                pageInput: $editFixturePage,
                pageInputErr: getErrText($editFixturePage),
                authForm: $(EDIT_FIXTURE_DLG_AUTH_FORM),
                authFormBtn: $(EDIT_FIXTURE_DLG_AUTH_FORM_BTN),
                userInput: $(EDIT_FIXTURE_USER_INPUT),
                passInput: $(EDIT_FIXTURE_PASS_INPUT)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'deleteFixture', {
        get: function () {
            return {
                yesBtn: $(DELETE_FIXTURE_YES_BTN),
                noBtn: $(DELETE_FIXTURE_NO_BTN)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'deleteDir', {
        get: function () {
            return {
                yesBtn: $(DELETE_DIR_YES_BTN),
                noBtn: $(DELETE_DIR_NO_BTN)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'openProject', {
        get: function () {
            return {
                openBtn: $(OPEN_PROJECT_BTN).eq(0),
                scroll: $(OPEN_PROJECT_SCROLLBAR).eq(0),
                pathInput: $(OPEN_PROJECT_PATH_INPUT),
                closeBtn: $(OPEN_PROJECT_DLG_CLOSE_BTN),
                openBtnStartPage: $(OPEN_PROJECT_BTN).eq(1),
                layout: $(OPEN_PROJECT_DLG_LAYOUT),
                resizeBtn: $(RESIZE_MARKER).eq(0),
                header: $(OPEN_PROJECT_DLG_HEADER)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'createProject', {
        get: function () {
            var $projectPathInput = $(CREATE_PROJECT_PATH_INPUT),
                $projectNameInput = $(CREATE_PROJECT_NAME_INPUT);

            return {
                openBtn: $(CREATE_PROJECT_DLG_OPEN_BTN).eq(0),
                scroll: $(CREATE_PROJECT_SCROLLBAR).eq(0),
                pathInput: $projectPathInput,
                nameInput: $projectNameInput,
                closeBtn: $(CREATE_PROJECT_DLG_CLOSE_BTN),
                okBtn: $(CREATE_PROJECT_DLG_OK_BTN),
                layout: $(CREATE_PROJECT_DLG_LAYOUT),
                resizeBtn: $(RESIZE_MARKER).eq(0),
                header: $(CREATE_PROJECT_DLG_HEADER),
                nameInputErr: getErrText($projectNameInput),
                pathInputErr: getErrText($projectPathInput)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'run', {
        get: function () {
            var $browserWorkers = $(BROWSER_WORKERS),
                $connectedWorkers = $(CONNECTED_WORKERS);

            return {
                closeBtn: $(WORKERS_LIST_DLG).closest(DIALOG).find(DIALOG_CLOSE_BTN),
                runBtn: $(RUN_DLG_RUN_BTN),
                selectAllBrowsers: $(SELECT_ALL_BROWSERS),
                selectAllWorkers: $(SELECT_ALL_WORKERS),
                deselectAllBrowsers: $(DESELECT_ALL_BROWSERS),
                deselectAllWorkers: $(DESELECT_ALL_WORKERS),
                browsers: $browserWorkers,
                checkedBrowsers: $browserWorkers.filter(function () {
                    return $(this).prop('checked');
                }),
                workers: $connectedWorkers,
                checkedWorkers: $connectedWorkers.filter(function () {
                    return $(this).prop('checked');
                }),
                failIfJSErrors: $(FAIL_ON_JS_ERRS_OPTION)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'renameTest', {
        get: function () {
            var $nameInput = $(RENAME_TEST_NAME_INPUT);

            return {
                renameBtn: $(RENAME_TEST_BTN),
                nameInput: $nameInput,
                nameInputErr: getErrText($nameInput)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'renameDir', {
        get: function () {
            var $nameInput = $(RENAME_DIR_NAME_INPUT);

            return {
                closeBtn: $(RENAME_DIR_DLG_CLOSE_BTN),
                renameBtn: $(RENAME_DIR_BTN),
                nameInput: $nameInput,
                nameInputErr: getErrText($nameInput)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'deleteTests', {
        get: function () {
            return {
                yesBtn: $(DELETE_TEST_YES_BTN),
                noBtn: $(DELETE_TEST_NO_BTN)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'clearReports', {
        get: function () {
            return {
                openBtn: $(CLEAR_REPORTS_DLG_OPEN_BTN),
                yesBtn: $(CLEAR_REPORTS_DLG_YES_BTN),
                noBtn: $(CLEAR_REPORTS_DLG_NO_BTN)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'removeReport', {
        get: function () {
            return {
                openBtn: $(REMOVE_REPORT_BTN),
                yesBtn: $(REMOVE_REPORT_YES_BTN),
                noBtn: $(REMOVE_REPORT_NO_BTN)
            }
        }
    });

    Object.defineProperty(tc.dialogs, 'reportsPath', {
        get: function () {
            return {
                openBtn: $(CHANGE_REPORTS_PATH_DLG_OPEN_BTN).eq(0),
                scroll: $(CHANGE_REPORTS_PATH_SCROLLBAR).eq(0),
                pathInput: $(CHANGE_REPORTS_PATH_PATH_INPUT),
                closeBtn: $(CHANGE_REPORTS_PATH_DLG_CLOSE_BTN),
                layout: $(CHANGE_REPORTS_PATH_DLG_LAYOUT),
                resizeBtn: $(RESIZE_MARKER).eq(0),
                header: $(CHANGE_REPORTS_PATH_DLG_HEADER)
            }
        }
    });

    return tc;
})
();