var Process = require('child_process'),
    path = require('path'),
    fs = require('fs'),
    tmp = require('tmp'),
	ejs = require('ejs');
    TestCafe = require('../../../index').TestCafe;

var testCafeUserDir = path.join(process.env['USERPROFILE'], 'Documents', 'TestCafe');

if(!fs.existsSync(testCafeUserDir)) {
    fs.mkdirSync(testCafeUserDir);
    fs.writeFileSync(path.join(testCafeUserDir, 'testcafe_config.json'), '{}');
}

function copyDirRecursive(from, to) {
    fs.readdirSync(from).forEach(function (fileName) {
        var filePath = path.join(from, fileName),
            stats = fs.statSync(filePath);

        if (stats.isDirectory()) {
            fs.mkdirSync(path.join(to, fileName));
            copyDirRecursive(filePath, path.join(to, fileName));
        }
        else{
            fs.writeFileSync(path.join(to, fileName), fs.readFileSync(filePath));
        }
    });
}

var run = function(testsDir) {
    var reportsPath = path.join(testsDir, 'reports');

    fs.mkdirSync(reportsPath);

    var testInstanceStartup = {
            "controlPanelPort": 1335,
            "servicePort": 1336,
            "servicePort2": 1340,
            "testsDir": testsDir,
            "hostname": '127.0.0.1',
            "reportsPath": reportsPath,
            "browsers": {
                "Internet Explorer": {
                    "path": 'C:\\Program Files\\Internet Explorer\\iexplore.exe'
                },
                "testTwo": {
                    "path": 'test2'
                }
            }
        },
        startupConfig = {
            "controlPanelPort": 1337,
            "servicePort": 1338,
            "servicePort2": 1341,
            "hostname": '127.0.0.1',
            "testsDir": path.join(__dirname, 'fixtures'),
            "reportsPath": reportsPath,
            "browsers": JSON.parse(
                fs.existsSync(path.join(__dirname, '../../../config.json')) ?
                fs.readFileSync(path.join(__dirname, '../../../config.json'), 'utf8') :
                fs.readFileSync(path.join(testCafeUserDir, './testcafe_config.json'), 'utf8')
            ).browsers
        };

        new TestCafe(testInstanceStartup, false);
        new TestCafe(startupConfig, true);
};

tmp.dir(function (tmpErr, basePath) {
    //NOTE: the tmp module returns path with tilde
    basePath = process.env['USERPROFILE'] + basePath.substr(basePath.indexOf('\\AppData'));
    copyDirRecursive(path.join(__dirname, 'data'), basePath);

    run(basePath);
});