"@fixture T173448 - TD_14_2 - Recorder - Step draggin icon and cursor are shown in playback mode";
"@page ./tests";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

"@test"["T173448"] = {
    "0.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },
    "1.1.Record wait action": function () {
        act.click(recorderHelper.toolbar.getRecordWaitActionSelector);
    },
    "1.2.Record wait action": function () {
        act.type(document.activeElement, "10000", {
            caretPos: 0
        });
    },
    "1.3.Record wait action": function () {
        act.click(recorderHelper.addActionDialog.getAddActionButton);
    },
    "1.4.Check step item style": function () {
        eq(recorderHelper.stepsPanel.getItemSortableIcon(0).css("visibility"), "visible");
        eq(recorderHelper.stepsPanel.getItemSortableArea(0).css("cursor"), "move");
        eq(recorderHelper.stepsPanel.getStepListItem(0).css("cursor"), "pointer");
    },
    "2.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },
    "3.Wait for toolbar is visible": function () {
        act.wait(10000, recorderHelper.toolbar.isShown);
    },
    "4.Assert": function () {
        eq(recorderHelper.stepsPanel.getItemSortableIcon(0).css("visibility"), "hidden");
        eq(recorderHelper.stepsPanel.getItemSortableArea(0).css("cursor"), "default");
        eq(recorderHelper.stepsPanel.getStepListItem(0).css("cursor"), "default");
    }
};

