"@fixture T173746 - TD_14_2 Playback doesn't wait step in an iframe executing before next step running in some cases";
"@page ./tests";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

"@test"["T173746"] = {
    "0.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('SameDomainPage'));
    },
    '1.Click element in the iframe': inIFrame('#iframe', function () {
        act.click('.black');
    }),
    '1.1.Add a failed assertion in the iframe': function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem,
            recorderHelper.editAssertionDialog.getOpenWizardButton
        ]);
    },
    '1.2.Add a failed assertion in the iframe': inIFrame('#iframe', function () {
        act.click('.black');
    }),

    '1.3.Add a failed assertion in the iframe': function () {
        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    '1.4.Add a failed assertion in the iframe': function () {
        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    '1.5.Add a failed assertion in the iframe': function () {
        act.press('ctrl+a f a l s e');
    },

    '1.6.Add a failed assertion in the iframe': function () {
        act.click(recorderHelper.editAssertionDialog.getConfirmButton());
    },

    '1.7.Add a failed assertion in the iframe': function () {
        act.click(recorderHelper.getPopupButtonSelector('OK'));
    },
    '2.Click submit button "Reload IFrame"': function () {
        act.click("#reloadBtn");
    },
    "3.1.Type in input": inIFrame($("#iframe"), function () {
        act.type("#input", "text");
    }),
    "3.2.Type in input": function () {
        act.press('ctrl+g');
    },
    '4.Run playback': function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },
    '5.Wait for assertion is failed': function () {
        act.wait(10000, recorderHelper.isPopupShown);
    },
    '6.Skip step': function () {
        act.click(recorderHelper.stepsPanel.getSkipStepButtonSelector);
    },
    "7.Finish playback": "@mixin Finish playback",

    "8.Check all steps completed": inIFrame($("#iframe"), function () {
        eq($("#input").val(), "text");
    })
};

