"@fixture T176225 - Cannot hide test steps once a test is failed";
"@page http://localhost:1341/tests";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

var PLAYBACK_TIMEOUT = 20000;

"@test"["T176225"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Record click and changes selector": "@mixin Record click and changes selector",

    "2.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "3.Finish playback": "@mixin Finish playback",

    "4.Check toolbar and steps panel": function () {
        eq(recorderHelper.stepsPanel.getCurrentSelector(), '".green"');
        ok(recorderHelper.getSelectorEditorError());
        ok(recorderHelper.toolbar.isExpandStepsButtonEnabled());
    },

    "5.Collapse steps panel and check collapsed": "@mixin Collapse steps panel",

    "6.Expand steps panel and check expanded": "@mixin Expand steps panel",

    "7.1.Delete failed step": function () {
        act.click(recorderHelper.stepsPanel.getDeleteStepButton);
    },

    "7.2.Delete failed step": function () {
        act.click(recorderHelper.popup.getPopupButtonSelector('Go back to initial page'));
    },

    "8.1.Add failed assertion": "@mixin Add failed assertion",

    "8.2.Add failed assertion": function () {
        act.click(recorderHelper.assertionsStepDialog.getAddAssertionsButton);
    },

    "9.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "10.Wait for playback failed": function () {
        act.wait(PLAYBACK_TIMEOUT, recorderHelper.isPopupShown);
    },

    "11.Check toolbar and steps panel and try to collapse steps panel": function () {
        eq(recorderHelper.stepsPanel.getCurrentStepIndex(), 0);
        ok(recorderHelper.toolbar.getHideStepsButton().length);
        notOk(recorderHelper.toolbar.isExpandStepsButtonEnabled());

        act.click(recorderHelper.toolbar.getHideStepsButton());
    },

    "12.Check non collapsed steps panel and skip step": function () {
        ok(recorderHelper.toolbar.getHideStepsButton().length);
        notOk(recorderHelper.toolbar.getShowStepsButton().length);
        notOk(recorderHelper.toolbar.isExpandStepsButtonEnabled());
        ok(recorderHelper.stepsPanel.getStepListPanel().is(':visible'));

        act.click(recorderHelper.stepsPanel.getSkipStepButtonSelector);
    },

    "13.Finish playback": "@mixin Finish playback",

    "14.Check toolbar and steps panel": function () {
        eq(recorderHelper.stepsPanel.getCurrentStepIndex(), 0);
        ok(recorderHelper.toolbar.getHideStepsButton().length);
        ok(recorderHelper.toolbar.isExpandStepsButtonEnabled());
    },

    "15.Collapse steps panel and check collapsed": "@mixin Collapse steps panel",

    "16.Expand steps panel and check expanded": "@mixin Expand steps panel"
};

//Local mixins
"@mixin"["Collapse steps panel"] = {
    "1.Collapse steps panel": function () {
        act.click(recorderHelper.toolbar.getHideStepsButton());
    },
    "2.Check collapsed steps panel": function () {
        notOk(recorderHelper.toolbar.getHideStepsButton().length);
        ok(recorderHelper.toolbar.getShowStepsButton().length);
        ok(recorderHelper.toolbar.isExpandStepsButtonEnabled());
        notOk(recorderHelper.stepsPanel.getStepListPanel().is(':visible'));
    }
};

"@mixin"["Expand steps panel"] = {
    "1.Expand steps panel": function () {
        act.click(recorderHelper.toolbar.getShowStepsButton);
    },
    "2.Check expanded steps panel": function () {
        ok(recorderHelper.toolbar.getHideStepsButton().length);
        notOk(recorderHelper.toolbar.getShowStepsButton().length);
        ok(recorderHelper.toolbar.isExpandStepsButtonEnabled());
        ok(recorderHelper.stepsPanel.getStepListPanel().is(':visible'));
    }
};