"@fixture T210251 - Playback on page with location.hash";
"@page ./tests";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

"@test"["T210251"] = {
    "-1.Open folder with test": function () {
        act.click(recorderHelper.controlPanelHelper.getFixtureElementSelector('Regression'));
    },
    "0.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('T210251'));
    },

    "1.Click on body": function () {
        act.click('body');
    },

    "2.Start playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "3.Wait for redirect during playback": function () {
        act.wait(10000);
    },

    "4.Finish playback": "@mixin Finish playback"
};

"@test"["T230853"] = {
    "0.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Click on body": function () {
        window.location.hash = 'event';
        this.oldLocationHref = window.location.href;
        act.click('body');
    },

    "2.Start playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "3.Wait for redirect during playback": function () {
        act.wait(10000);
    },

    "4.Finish playback": "@mixin Finish playback",

    '': function () {
        notEq(window.location.href, this.oldLocationHref, 'location changed');
        notOk(/#.*$/.test(window.location.href), 'start recording location does not contain hash');
    }
};