"@fixture T230851 - TD15.1 - wait for action target fails silently if redirect happens during wait";
"@page http://localhost:1341/tests/TestRunner/Regression";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

"@test"["T230851"] = {
    "0.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('T230851'));
    },

    "1.1.Move toolbar": function () {
        act.drag(recorderHelper.toolbar.getDragArea, 300, 0);
    },

    "1.2.Click on the first div": function () {
        act.click('#div1');
    },

    "2.Wait for redirect": function () {
        act.wait(5000, function () {
            return !!$('#div3').length;
        });
    },

    "3.Wait for the third div is appeared": function () {
        act.wait(5000, function () {
            return !!$('#div3').length;
        });
    },

    "4.Click on the third div": function () {
        act.click('#div3');
    },

    "5.Click add assertions button": function () {
        act.click(recorderHelper.toolbar.getAddAssertionsSelector);
    },

    "6.Open edit assertion dialog": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "7.Fill actual argument": function () {
        act.type(recorderHelper.getCodeEditorSelector().eq(0), '$("#result").text() === "div3 click"');
    },

    "8.Click the confirm button": function () {
        act.click(recorderHelper.editAssertionDialog.getConfirmButton);
    },

    "9.Click the confirm button": function () {
        act.click(recorderHelper.getPopupButtonSelector('OK'));
    },

    "10.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "11.1.Wait for playback finished": function () {
        act.wait(20000, function () {
            return recorderHelper.getPopupButtonSelector('Return to recording').length;
        });
    },

    "11.2.Wait for playback finished": function () {
        act.wait(20000, function () {
            return recorderHelper.getPopupButtonSelector('Return to recording').length;
        });
    },

    "12.Check playback success": function () {
        ok(selectUIElementByText('Test completed').length);
    }
};