"@fixture Upload";
"@page ./tests/Recorder/Upload";

"@require :recorderHelper";
"@require ./../../../mixins/recorder.js";


'@mixin'['Check uploading step parameters'] = {
    '1.Check': function () {
        var files = recorderHelper.stepsPanel.getCurrentUploadStepFiles();

        eq(files, './uploads/img1.jpg./uploads/img2.jpg');
        eq(recorderHelper.stepsPanel.getCurrentStepType(), 'upload');
        eq(recorderHelper.stepsPanel.getCurrentSelector(), '$("#file")');
        eq(recorderHelper.stepsPanel.getStepListItem(0).text(), '1Upload "img1.jpg", "img2.jpg" files');
    }
};

'@test'['Playback'] = {
    "1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('UploadPage'));
    },

    '2.Upload "img1.jpg", "img2.jpg" files': function () {
        act.upload('#file', [ './../../../uploads/img1.jpg', './../../../uploads/img2.jpg' ]);
    },

    '3.Click step "Upload "img1.jpg",..."': function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    '4.Check step params': '@mixin Check uploading step parameters',

    '5.Playback test': function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector());
    },

    '6.Finish playback': '@mixin Finish playback',

    '7.Click step "Upload "img1.jpg",..."': function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    '8.Check property value': '@mixin Check uploading step parameters'
};

'@test'['Playback with errors'] = {
    "1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('UploadPage'));
    },

    '2.Upload "img1.jpg", "img2.jpg" files': function () {
        act.upload('#file', [ './../../../uploads/img1.jpg', './../../../uploads/img2.jpg' ]);
    },

    '3.Click step "Upload "img1.jpg",..."': function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    '4.Check step params': '@mixin Check uploading step parameters',

    '5.1.Open dialogs editor': function () {
        act.click(recorderHelper.popup.getDialogsEditor);
    },

    '5.2.Set browser alert dialog handler': function () {
        act.click(recorderHelper.popup.getAlertHandlerCheckbox);
    },

    '6.Playback test': function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector());
    },

    '7.Finish playback': '@mixin Finish playback',

    "8.1.Check opened dialog": function () {
        ok(recorderHelper.popup.hasAlertHandler());
        ok(recorderHelper.popup.isAlertHandlerFailed());
    },

    "8.1.Check opened dialog params": '@mixin Check uploading step parameters',

    '9.Deselect browser alert dialog handler': function () {
        act.click(recorderHelper.popup.getAlertHandlerCheckbox);
    },

    '10.Playback test': function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector());
    },

    '11.Finish playback': '@mixin Finish playback',

    '12.Click step "Upload "img1.jpg",..."': function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    '13.Check property value': '@mixin Check uploading step parameters'
};
