"@fixture Failed steps during playback";
"@page ./tests";

"@require :recorderHelper";
"@require ../../mixins/recorder.js";

var PLAYBACK_TIMEOUT = 20000;

"@test"["Failed actions and assertions"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Record click and changes selector": "@mixin Record click and changes selector",

    "2.1.Add failed assertion": "@mixin Add failed assertion",

    "2.2.Add failed assertion": function () {
        act.click(recorderHelper.assertionsStepDialog.getAddAssertionsButton);
    },

    "3.Record click action": function () {
        act.click('.red');
    },

    "4.1.Add doubled assertion step": "@mixin Add failed assertion",

    "4.2.Add doubled assertion step": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getNotOkPopupItem
        ]);
    },

    "4.3.Add doubled assertion step": function () {
        act.click(recorderHelper.getCodeEditorSelector);
    },

    "4.4.Add doubled assertion step": function () {
        act.press('ctrl+a delete f a l s e esc enter');
    },

    "4.5.Add doubled assertion step": function () {
        act.click(recorderHelper.assertionsStepDialog.getAddAssertionsButton);
    },

    "5.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "6.Finish playback": "@mixin Finish playback",

    "7.Check dialog": function () {
        eq(recorderHelper.stepsPanel.getCurrentSelector(), '".green"');
        ok(recorderHelper.getSelectorEditorError());
    },

    "8.Check dialog background, write incorrect value and check buttons": function () {
        notOk(recorderHelper.isSvgBackgroundShown());
        notOk(recorderHelper.isDivBackgroundShown());

        act.click(recorderHelper.getCodeEditorSelector);
    },

    "9.1.Write incorrect selector and try to replay step": function () {
        act.press('ctrl+a delete " . y e l l o w esc enter');
    },

    "9.2.Write incorrect selector and try to replay step": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "10.Finish playback": "@mixin Finish playback",

    "11.1.Check dialog and repair step": function () {
        eq(recorderHelper.stepsPanel.getCurrentSelector(), '".yellow"');
        ok(recorderHelper.getSelectorEditorError());

        act.click(recorderHelper.getCodeEditorSelector);
    },

    "11.2.Check dialog and repair step": function () {
        act.press('ctrl+a delete " . b l a c k esc enter');
    },

    "11.3.Check dialog and repair step": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "12.Wait for playback failed": function () {
        act.wait(PLAYBACK_TIMEOUT, recorderHelper.isPopupShown);
    },

    "13.Check dialog and skip step": function () {
        eq(recorderHelper.stepsPanel.getCurrentStepIndex(), 1);
        notOk(recorderHelper.isSvgBackgroundShown());
        ok(recorderHelper.isDivBackgroundShown());
        ok(!recorderHelper.stepsPanel.isResumePlaybackButtonEnabled());
        ok(recorderHelper.stepsPanel.isSkipStepButtonEnabled());

        act.click(recorderHelper.stepsPanel.getSkipStepButtonSelector);
    },

    "14.Wait for playback failed": function () {
        act.wait(PLAYBACK_TIMEOUT, recorderHelper.isPopupShown);
    },

    "15.Remove first step and resume playback": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getRemoveAssertionButton(0),
            recorderHelper.stepsPanel.getResumePlaybackButtonSelector
        ]);
    },

    "16.Finish playback": "@mixin Finish playback",

    "17.Run playback": function () {
        notOk(recorderHelper.isCursorShown());
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "18.Wait for playback failed": function () {
        act.wait(PLAYBACK_TIMEOUT, recorderHelper.isPopupShown);
    },

    "19.1.Check dialog and repair step": function () {
        eq(recorderHelper.stepsPanel.getCurrentStepIndex(), 1);

        act.click([
            recorderHelper.assertionsStepDialog.getEditAssertionSelector(0),
            recorderHelper.editAssertionDialog.getOpenWizardButton
        ]);
    },

    "19.2.Check dialog and repair step": function () {
        act.click([
            '.red',
            function () {
                return recorderHelper.getPopupButtonSelector('Next');
            },
            function () {
                return recorderHelper.selectUIElementByText('length');
            },
            function () {
                return recorderHelper.getPopupButtonSelector('Next');
            },
            function () {
                return recorderHelper.editAssertionDialog.getConfirmButton();
            }
        ]);
    },

    "20.Resume playback": function () {
        act.click(recorderHelper.stepsPanel.getResumePlaybackButtonSelector);
    },

    "21.Finish playback": "@mixin Finish playback",

    "22.Run playback": function () {
        notOk(recorderHelper.isCursorShown());
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "23.Finish playback": "@mixin Finish playback",

    "24.Check recording is run": function () {
        ok(recorderHelper.toolbar.isShown());
    }
};

"@test"["Check toolbar and popups dragging behavior"] = {
    "1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "2.Try move toolbar out of left window bound": function () {
        this.toolbarPosition = recorderHelper.toolbar.getDragArea().offset();
        this.toolbarWidth = recorderHelper.toolbar.getToolbarArea().width();
        this.maxLeftToolbarPosition = $(window).width() - this.toolbarWidth;
        $('body').width(5000);
        act.drag(recorderHelper.toolbar.getDragArea, this.maxLeftToolbarPosition * 2, 0);
    },

    "3.Check that toolbar moved not farther maximum left value": function () {
        this.maxLeftToolbarPosition = $(window).width() - this.toolbarWidth;
        eq(parseInt(recorderHelper.toolbar.getToolbarArea().css('left').replace('px', '')), this.maxLeftToolbarPosition);
    },

    "4.Try move toolbar out of top window bound": function () {
        this.toolbarPosition = recorderHelper.toolbar.getDragArea().offset();
        this.maxTopToolbarPosition = $(window).height() - recorderHelper.toolbar.getToolbarArea().height();
        $('body').height(5000);
        act.drag(recorderHelper.toolbar.getDragArea, 0, this.maxTopToolbarPosition * 2);
    },

    "5.Check that toolbar moved not farther maximum top value and make sure that steps panel is open": function () {
        eq(parseInt(recorderHelper.toolbar.getToolbarArea().css('top').replace('px', '')), this.maxTopToolbarPosition);
        var selector = !recorderHelper.stepsPanel.getStepListPanel().is(':visible') ? 
            [recorderHelper.toolbar.getShowStepsButton] :
            document.body;
        act.click(selector);
        
        //NOTE: for API 2.0
        //act.if(!recorderHelper.stepsPanel.getStepListPanel().is(':visible')).click(recorderHelper.toolbar.getShowStepsButton);
    }
};


"@test"["Failed actions and assertions in IFrame"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('CrossDomainPage'));
    },

    "1.Click on an element": inIFrame('#iframe', function () {
        act.click('.black');
    }),

    "2.1.Change action selector": function () {
        act.click(recorderHelper.selectUIElementByText('Click div'));
    },

    "2.2.Change action selector": function () {
        act.click(recorderHelper.addActionDialog.getElementSelectorEditor);
    },

    "2.3.Change action selector": function () {
        act.press('ctrl+a delete " . g r e e n');
    },

    "2.4.Change action selector": function () {
        act.click(recorderHelper.selectUIElementByText('Click div'));
    },

    "3.1.Add failed assertion": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "3.2.Add failed assertion": function () {
        act.click(recorderHelper.editAssertionDialog.getOpenWizardButton);
    },

    "3.3.Add failed assertion": inIFrame('#iframe', function () {
        act.click('.black');
    }),

    "3.4.Add failed assertion": function () {
        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "3.5.Add failed assertion": function () {
        act.click(recorderHelper.selectUIElementByText('child element count'));
    },

    "3.6.Add failed assertion": function () {
        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "3.7.Add failed assertion": function () {
        act.click(recorderHelper.editAssertionDialog.getConfirmButton);
    },

    "3.8.Add failed assertion": function () {
        act.click(recorderHelper.getPopupButtonSelector('OK'));
    },

    "4.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "5.Finish playback": "@mixin Finish playback",

    "6.1.Fix step": function () {
        act.click(recorderHelper.addActionDialog.getElementSelectorEditor);
    },

    "6.2.Fix step": function () {
        act.press('ctrl+a delete " . b l a c k esc');
    },
    
    "6.3.Fix step": function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    "7.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "8.Wait for playback failed": function () {
        act.wait(PLAYBACK_TIMEOUT, recorderHelper.isPopupShown);
    },

    "9.Skip error": function () {
        ok(!recorderHelper.stepsPanel.isResumePlaybackButtonEnabled());
        ok(recorderHelper.stepsPanel.isSkipStepButtonEnabled());

        act.click(recorderHelper.stepsPanel.getSkipStepButtonSelector);
    },

    "10.Finish playback": "@mixin Finish playback",

    "11.Run playback again": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "12.Wait for playback failed": function () {
        act.wait(PLAYBACK_TIMEOUT, recorderHelper.isPopupShown);
    },

    "13.Try to resume": function () {
        ok(!recorderHelper.stepsPanel.isResumePlaybackButtonEnabled());
        ok(recorderHelper.stepsPanel.isSkipStepButtonEnabled());
    },

    "14.1.Repair step": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getEditAssertionSelector(0),
            recorderHelper.editAssertionDialog.getOpenWizardButton
        ]);
    },

    "14.2.Repair step": inIFrame('#iframe', function () {
        act.click('.red');
    }),

    "14.3.Repair step": function () {
        act.click([
            function () {
                return recorderHelper.getPopupButtonSelector('Next');
            },
            function () {
                return recorderHelper.selectUIElementByText('length').eq(1);
            },
            function () {
                return recorderHelper.getPopupButtonSelector('Next');
            },
            function () {
                return recorderHelper.editAssertionDialog.getConfirmButton();
            }
        ]);
    },

    "15.Click body to check dialog is not hidden after that": function () {
        act.click('body', {
            offsetX: 1,
            offsetY: 1
        });
    },

    "16.Resume test": function () {
        act.click(recorderHelper.stepsPanel.getResumePlaybackButtonSelector);
    },

    "17.Finish playback": "@mixin Finish playback"
};

"@test"["Mark failed assertions after playback"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.1.Add double assertion step": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "1.2.Add double assertion step": function () {
        act.click(recorderHelper.getCodeEditorSelector);
    },

    "1.3.Add double assertion step": function () {
        act.press('ctrl+a delete f a l s e esc enter');
    },

    "1.5.Add double assertion step": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getNotOkPopupItem
        ]);
    },

    "1.6.Add double assertion step": function () {
        act.click(recorderHelper.getCodeEditorSelector);
    },

    "1.7.Add double assertion step": function () {
        act.press('ctrl+a delete f a l s e esc enter');
    },

    "1.8.Add double assertion step": function () {
        act.click(recorderHelper.assertionsStepDialog.getAddAssertionsButton);
    },

    "2.Click link": function () {
        act.click('#link');
    },

    "3.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "4.Wait for playback failed": function () {
        act.wait(PLAYBACK_TIMEOUT, recorderHelper.isPopupShown);
    },

    "5.Skip step": function () {
        act.click(recorderHelper.stepsPanel.getSkipStepButtonSelector);
    },

    "6.Finish playback": "@mixin Finish playback",

    "7.Check step is failed and open the step's info": function () {
        ok(recorderHelper.stepsPanel.isStepFailed(0));

        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    "8.Check assertions": function () {
        ok(recorderHelper.assertionsStepDialog.isAssertionFailed(0), 'The first assertion is marked as a failed');

        ok(!recorderHelper.assertionsStepDialog.isAssertionFailed(1), 'The second assertion is not marked as a failed');
        ok(!recorderHelper.assertionsStepDialog.isAssertionSuccessful(1), 'The second assertion is not marked as a successful');
    },

    "9.1.Change the second assertion": function () {
        act.click(recorderHelper.assertionsStepDialog.getAssertions().eq(1));
    },

    "9.2.Change the second assertion": function () {
        act.click(recorderHelper.getCodeEditorSelector);
    },

    "9.3.Change the second assertion": function () {
        act.press('ctrl+a 2 esc enter');
    },

    "10.Check assertions": function () {
        ok(recorderHelper.stepsPanel.isStepFailed(0), 'The step is marked as a failed');
        ok(recorderHelper.assertionsStepDialog.isAssertionFailed(0), 'The first assertion is marked as a failed');

        ok(!recorderHelper.assertionsStepDialog.isAssertionFailed(1), 'The second assertion is not marked as a failed');
        ok(!recorderHelper.assertionsStepDialog.isAssertionSuccessful(1), 'The second assertion is not marked as a successful');
    },

    "11.1.Change the first assertion": function () {
        act.click(recorderHelper.assertionsStepDialog.getAssertions().eq(0));
    },

    "11.2.Change the first assertion": function () {
        act.click(recorderHelper.getCodeEditorSelector);
    },

    "11.3.Change the first assertion": function () {
        act.press('ctrl+a n u l l esc enter');
    },

    "12.Check assertions": function () {
        ok(!recorderHelper.stepsPanel.isStepFailed(0), 'The step is not marked as a failed');
        ok(!recorderHelper.assertionsStepDialog.isAssertionFailed(0), 'The first assertion is not marked as a failed');
        ok(!recorderHelper.assertionsStepDialog.isAssertionSuccessful(0), 'The first assertion is not marked as a successful');

        ok(!recorderHelper.assertionsStepDialog.isAssertionFailed(1), 'The second assertion is not marked as a failed');
        ok(!recorderHelper.assertionsStepDialog.isAssertionSuccessful(1), 'The second assertion is not marked as a successful');
    }
};

"@test"["Failed actions indication"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Record click and changes selector": "@mixin Record click and changes selector",

    "2.Record click action": function () {
        act.click('.red');
    },

    "3.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "4.1.Finish playback": function () {
        act.wait(PLAYBACK_TIMEOUT, function () {
            return recorderHelper.getPopupButtonSelector('Return to recording').length;
        });
    },

    "4.2.Finish playback": function () {
        ok(recorderHelper.selectUIElementByText('action has not been found in the DOM tree').length);
    },

    "4.3.Finish playback": function () {
        act.click(recorderHelper.getPopupButtonSelector('Return to recording'));
    },

    "5.Check dialog": function () {
        eq(recorderHelper.stepsPanel.getCurrentSelector(), '".green"');
        ok(recorderHelper.getSelectorEditorError());
        ok(recorderHelper.stepsPanel.isStepFailed(0));
    },

    "6.Click on steps": function () {
        act.click([
            recorderHelper.stepsPanel.getStepListItem(1),
            recorderHelper.stepsPanel.getStepListItem(0)
        ]);
    },

    "7.Check dialog": function () {
        ok(recorderHelper.getSelectorEditorError());
        ok(recorderHelper.stepsPanel.isStepFailed(0));
    },

    "8.1.Change selector": function () {
        act.click(recorderHelper.addActionDialog.getElementSelectorEditor);
    },

    "8.2.Change selector": function () {
        act.press('ctrl+a delete " . r e d');
    },

    "9.Check dialog": function () {
        notOk(recorderHelper.getSelectorEditorError());
        notOk(recorderHelper.stepsPanel.isStepFailed(0));
    },
    "10.1.Change selector": function () {
        act.click(recorderHelper.addActionDialog.getElementSelectorEditor);
    },

    "10.2.Change selector": function () {
        act.press('ctrl+a delete " . b l u e');
    },

    "11.Check dialog and close step info": function () {
        ok(recorderHelper.getSelectorEditorError());
        ok(recorderHelper.stepsPanel.isStepFailed(0));
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    "12.Click one more action": function () {
        act.click('.red');
    },

    "13.Check the first action and open it": function () {
        ok(recorderHelper.stepsPanel.isStepFailed(0));
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    "14.1.Change selector": function () {
        act.click(recorderHelper.addActionDialog.getElementSelectorEditor);
    },

    "14.2.Change selector": function () {
        act.press('ctrl+a delete " . g r e e n');
    },

    "15.Check dialog": function () {
        notOk(recorderHelper.getSelectorEditorError());
        notOk(recorderHelper.stepsPanel.isStepFailed(0));
    }
};

"@test"["Playback after delete all assertions in step"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.1.Add failed assertion": "@mixin Add failed assertion",

    "1.2.Add failed assertion": function () {
        act.click(recorderHelper.assertionsStepDialog.getAddAssertionsButton);
    },

    "2.Run playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "3.Wait for playback failed": function () {
        act.wait(PLAYBACK_TIMEOUT, recorderHelper.isPopupShown);
    },

    "4.Delete assertion": function () {
        act.click(recorderHelper.assertionsStepDialog.getRemoveAssertionButton(0));
    },

    "5.Check buttons state and add new assertion": function () {
        notOk(recorderHelper.assertionsStepDialog.getAssertions().length);
        ok(!recorderHelper.stepsPanel.isResumePlaybackButtonEnabled());
        ok(!recorderHelper.stepsPanel.isSkipStepButtonEnabled());
    },

    "6.1.Add failed assertion": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "6.2.Add failed assertion": function () {
        act.click(recorderHelper.getCodeEditorSelector);
    },

    "6.3.Add failed assertion": function () {
        act.press('ctrl+a delete f a l s e esc enter');
    },

    "7.Check buttons state and finish playback": function () {
        eq(recorderHelper.assertionsStepDialog.getAssertions().length, 1);
        ok(recorderHelper.stepsPanel.isResumePlaybackButtonEnabled());
        ok(recorderHelper.stepsPanel.isSkipStepButtonEnabled());

        act.click(recorderHelper.popup.getPopupButtonSelector('Skip step'));
    },

    "8.Finish playback": "@mixin Finish playback"
};


//Local mixins
"@mixin"["Check that toolbar is draggable"] = {
    "1.Drag toolbar": function () {
        this.toolbarPosition = recorderHelper.toolbar.getDragArea().offset();
        act.drag(recorderHelper.toolbar.getDragArea, 5, 5);
    },

    "2.Check that toolbar was dragged": function () {
        eq(recorderHelper.toolbar.getDragArea().offset(), {left: this.toolbarPosition.left + 5, top: this.toolbarPosition.top + 5});
    }
};

"@mixin"["Check that popup is draggable"] = {
    "1.Drag popup": function () {
        this.popupPosition = recorderHelper.popup.getPopupHeader().offset();
        act.drag(recorderHelper.popup.getPopupHeader(), 5, 5);
    },

    "2.Check that popup was dragged": function () {
        eq(recorderHelper.popup.getPopupHeader().offset(), {left: this.popupPosition.left + 5, top: this.popupPosition.top + 5});
    }
};

"@mixin"["Move toolbar as low as possible"] = {
    "1.Drag toolbar": function () {
        this.toolbarPosition = recorderHelper.toolbar.getDragArea().offset();
        this.maxTopToolbarPosition = $(window).height() - recorderHelper.popup.getPopup().height();

        act.drag(recorderHelper.toolbar.getDragArea, 5, this.maxTopToolbarPosition - this.toolbarPosition.top + 5);
    },

    "2.Check that toolbar moved not below maximum top value": function () {
        eq(recorderHelper.toolbar.getDragArea().offset(), {left: this.toolbarPosition.left + 5, top: this.maxTopToolbarPosition});
    }
};
