"@fixture Playback in cross-domain iframe";
"@page ./tests";

"@require :recorderHelper";
"@require ../../mixins/recorder.js";

var PLAYBACK_TIMEOUT = 20000;

var iframeSelector = '#iframe';

"@test"["Check recorded steps executing"] = {
    "@testCases": [
        { '@name': 'Cross-domain iframe', title: 'CrossDomainPage' },
        { '@name': 'Same-domain iframe', title: 'SameDomainPage' },
        { '@name': 'Inline iframe', title: 'InlineIframePage' }
    ],

    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector(this.title));
    },

    "1.Click several elements": inIFrame(iframeSelector, function () {
        act.click(['.black', '.red', '#input']);
    }),

    "1.1.Confirm typing": function () {
        act.click(recorderHelper.getCompleteClickIcon);
    },

    "1.2.Check actions executed": inIFrame(iframeSelector, function () {
        eq(document.activeElement, document.getElementById('input'));
        eq(window.blackClick, 1);
        eq(window.redClick, 1);
    }),

    "2.Run Playback": function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "3.Finish playback": inIFrame(iframeSelector, function () {
        act.wait(PLAYBACK_TIMEOUT, function () {
            return document.activeElement === document.getElementById('input');
        });
    }),

    "3.1.Finish playback": "@mixin Finish playback",

    "4.Check action executed": inIFrame(iframeSelector, function () {
        eq(window.blackClick, 1);
        eq(window.redClick, 1);
    })
};