"@fixture Playback recorded steps";
"@page ./tests";

"@require :recorderHelper";
"@require ../../mixins/recorder.js";

"@test"["Check recorded steps executing"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Click several elements": function () {
        act.click(['.black', '.red', '#input', recorderHelper.getCompleteClickIcon]);
    },

    "2.Run Playback": function () {
        eq(document.activeElement, document.getElementById('input'));
        eq(window.blackClick, 1);
        eq(window.redClick, 1);

        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "3.Finish playback": "@mixin Finish playback",

    "4.Check actions are executed": function () {
        eq(document.activeElement, document.getElementById('input'));
        eq(window.blackClick, 1);
        eq(window.redClick, 1);
    }
};

"@test"["'UseOffsets' flag should not be considered in playback if appropriate checkbox isn't checked"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Click body": function () {
        act.click('body');
    },

    "2.1.Change action selector": function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    "2.2.Change action selector": function () {
        act.click(recorderHelper.addActionDialog.getElementSelectorEditor);
    },

    "2.3.Change action selector": function () {
        act.press('ctrl+a delete " . b l a c k');
    },

    "2.4.Change action selector": function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    "3.Run Playback": function () {
        eq(window.blackClick, 0);

        act.click(recorderHelper.toolbar.getRunPlaybackSelector);
    },

    "4.Finish playback": "@mixin Finish playback",

    "5.Check actions with changed selector are executed": function () {
        eq(window.blackClick, 1);
    }
};