"@fixture Add assertions step";
"@page ./tests";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

"@test"["Assertions step OK button disabling"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Click add assertions button": function () {
        act.click(recorderHelper.toolbar.getAddAssertionsSelector);
    },

    "2.Check OK button is disabled": function () {
        ok(recorderHelper.assertionsStepDialog.getAddAssertionsButton().attr('disabled'));
    },

    "3.Try to click disabled OK button": function () {
        act.click(recorderHelper.assertionsStepDialog.getAddAssertionsButton);
    },

    "4.Check that click on disabled button does nothing": function () {
        ok(recorderHelper.isPopupShown());
    },

    "5.Open edit assertion dialog": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "6.Fill actual argument": function () {
        act.type(recorderHelper.getCodeEditorSelector().eq(0), 'true');
    },

    "7.Click confirm button": function () {
        act.click(recorderHelper.editAssertionDialog.getConfirmButton);
    },

    "8.Check OK button is enabled": function () {
        ok(!recorderHelper.getPopupButtonSelector('OK').attr('disabled'));
    },

    "9.Delete assertion": function () {
        act.click(recorderHelper.assertionsStepDialog.getRemoveAssertionButton(0));
    },

    "10.Check OK button is disabled": function () {
        ok(recorderHelper.getPopupButtonSelector('OK').attr('disabled'));
    }
};

"@test"["Check dialog states"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Open edit assertion dialog": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getEqPopupItem
        ]);
    },

    "2.Check editors, actual values, state indicator and button": function () {
        this.popupHeight = recorderHelper.popup.getPopup().eq(1).height();

        notOk(recorderHelper.getCodeEditorSelector().eq(0).text());
        notOk(recorderHelper.getCodeEditorSelector().eq(1).text());
        notOk(recorderHelper.editAssertionDialog.getActualValue());
        notOk(recorderHelper.editAssertionDialog.getExpectedValue());
        notOk(recorderHelper.editAssertionDialog.isStateIndicatorVisible());
        ok(recorderHelper.editAssertionDialog.getConfirmButton().attr('disabled'));
    },

    "3.1.Fill actual argument": function () {
        act.click(recorderHelper.getCodeEditorSelector().eq(0));
    },

    "3.2.Fill actual argument": function () {
        act.press('t r u e');
    },

    "4.1.Fill expected argument": function () {
        act.click(recorderHelper.getCodeEditorSelector().eq(1));
    },

    "4.2.Fill expected argument": function () {
        act.press('t r u e');
    },

    "5.Check actual values, state indicator and button": function () {
        eq(recorderHelper.popup.getPopup().eq(1).height(), this.popupHeight, 'popup height stored after state indicator was appeared');
        eq(recorderHelper.editAssertionDialog.getActualValue(), 'true');
        eq(recorderHelper.editAssertionDialog.getExpectedValue(), 'true');
        ok(recorderHelper.editAssertionDialog.isStateIndicatorVisible());
        ok(!recorderHelper.editAssertionDialog.getConfirmButton().attr('disabled'));
    },

    "6.1.Change actual argument": function () {
        act.click(recorderHelper.getCodeEditorSelector().eq(0));
    },

    "6.2.Change actual argument": function () {
        act.press('backspace');
    },

    "7.Check actual values, state indicator and button and restore value": function () {
        eq(recorderHelper.editAssertionDialog.getActualValue(), '');
        eq(recorderHelper.editAssertionDialog.getExpectedValue(), 'true');
        notOk(recorderHelper.editAssertionDialog.isStateIndicatorVisible());
        ok(recorderHelper.editAssertionDialog.getConfirmButton().attr('disabled'));

        act.press('ctrl+z');
    },

    "8.Close and reopen assertion": function () {
        act.click([
            recorderHelper.editAssertionDialog.getConfirmButton,
            recorderHelper.assertionsStepDialog.getAssertions
        ]);
    },

    "9.Check actual values, state indicator and button": function () {
        eq(recorderHelper.editAssertionDialog.getActualValue(), 'true');
        eq(recorderHelper.editAssertionDialog.getExpectedValue(), 'true');
        ok(recorderHelper.editAssertionDialog.isStateIndicatorVisible());
        eq(recorderHelper.editAssertionDialog.getConfirmButton().css('visibility'), 'visible');
    }
};

"@test"["Check auto generated message"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Open edit assertion dialog": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getEqPopupItem
        ]);
    },

    "2.1.Check message and fill the first argument": function () {
        notOk(recorderHelper.editAssertionDialog.getMessageInput()[0].value);
        act.click(recorderHelper.getCodeEditorSelector().eq(0));
    },

    "2.2.Check message and fill the first argument": function () {
        act.press('t r u e');
    },

    "3.1.Check message and fill the second argument": function () {
        notOk(recorderHelper.editAssertionDialog.getMessageInput()[0].value);
        act.click(recorderHelper.getCodeEditorSelector().eq(1));
    },

    "3.2.Check message and fill the second argument": function () {
        act.press('t r u e');
    },

    "4.Check message and confirm assertion": function () {
        notOk(recorderHelper.editAssertionDialog.getMessageInput()[0].value);
        act.click(recorderHelper.editAssertionDialog.getConfirmButton);
    },

    "5.Edit assertion": function () {
        eq(recorderHelper.assertionsStepDialog.getEditAssertionSelector(0).text(), 'eq(true, true)');
        act.click(recorderHelper.assertionsStepDialog.getEditAssertionSelector(0));
    },

    "6.Change the message": function () {
        act.type(recorderHelper.editAssertionDialog.getMessageInput(), 'custom message', { replace: true });
    },

    "7.Confirm assertion": function () {
        eq(recorderHelper.editAssertionDialog.getMessageInput()[0].value, 'custom message');
        act.click(recorderHelper.editAssertionDialog.getConfirmButton);
    },

    "8.Edit assertion": function () {
        eq(recorderHelper.assertionsStepDialog.getEditAssertionSelector(0).text(), 'custom message');
        act.click(recorderHelper.assertionsStepDialog.getEditAssertionSelector(0));
    },

    "9.1.Change the message": function () {
        act.click(recorderHelper.editAssertionDialog.getMessageInput());
    },

    "9.2.Change the message": function () {
        act.press('ctrl+a delete');
    },

    "10.Confirm assertion": function () {
        act.click(recorderHelper.editAssertionDialog.getConfirmButton);
    },

    "11.Check message": function () {
        eq(recorderHelper.assertionsStepDialog.getEditAssertionSelector(0).text(), 'eq(true, true)');
    }
};

"@test"["Element property wizard"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Open edit assertion dialog": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "2.Start wizard": function () {
        act.click(recorderHelper.editAssertionDialog.getOpenWizardButton);
    },

    "3.Cancel picking": function () {
        act.press('esc');
    },

    "4.Check dialog and restart wizard": function () {
        ok(recorderHelper.isPopupShown());
        eq(recorderHelper.editAssertionDialog.getActualValue(), '');

        act.click(recorderHelper.editAssertionDialog.getOpenWizardButton);
    },

    "5.Select the black element": function () {
        act.click('.black');
    },

    "6.Check dialog and click the 'Back' button": function () {
        ok(recorderHelper.chooseElementSelectorDialog.getElementSelector().text().indexOf('black') > -1);

        act.click(recorderHelper.getPopupButtonSelector('Back'));
    },

    "7.Check dialog and restart wizard": function () {
        ok(recorderHelper.isPopupShown());
        eq(recorderHelper.editAssertionDialog.getActualValue(), '');

        act.click(recorderHelper.editAssertionDialog.getOpenWizardButton);
    },

    "8.Select the red element": function () {
        act.click('.red');
    },

    "9.Check dialog and click the 'Next' button and then the 'Back button": function () {
        ok(recorderHelper.chooseElementSelectorDialog.getElementSelector().text().indexOf('red') > -1);

        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "10.Return to the previous dialog": function () {
        act.click(recorderHelper.getPopupButtonSelector('Back'));
    },

    "11.Check dialog and click the 'Next' button": function () {
        ok(recorderHelper.chooseElementSelectorDialog.getElementSelector().text().indexOf('red') > -1);
        this.argumentSelector = recorderHelper.getCodeEditorSelector().text();

        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "12.Check dialog and select the 'Css properties' tab": function () {
        eq(recorderHelper.chooseAssertionArgumentPropertyDialog.getResult(), this.argumentSelector + '.length > 0');

        act.click(recorderHelper.selectUIElementByText('css prop'));
    },

    "13.Select the 'zIndex' property": function () {
        act.click(recorderHelper.selectUIElementByText('zIndex'));
    },

    "14.Check dialog and close wizard": function () {
        eq(recorderHelper.chooseAssertionArgumentPropertyDialog.getResult(), this.argumentSelector + '.css("zIndex")');
        this.argumentSelector = recorderHelper.chooseAssertionArgumentPropertyDialog.getResult();

        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "15.Check dialog": function () {
        eq(recorderHelper.getCodeEditorSelector().text(), this.argumentSelector);
    }
};

"@test"["Choose property dialog"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Open edit assertion dialog": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "2.Start wizard": function () {
        act.click(recorderHelper.editAssertionDialog.getOpenWizardButton);
    },

    "3.Select the 'red' element": function () {
        act.click('.red');
    },

    "4.Click the 'Next' button": function () {
        this.argumentSelector = recorderHelper.getCodeEditorSelector().text();
        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "5.Check dialog and select the 'text' property": function () {
        eq(recorderHelper.chooseAssertionArgumentPropertyDialog.getResult(), this.argumentSelector + '.length > 0');

        act.click(recorderHelper.selectUIElementByText('text'));
    },

    "6.Check dialog and unselect the 'text' property": function () {
        eq(recorderHelper.chooseAssertionArgumentPropertyDialog.getResult(), this.argumentSelector + '.text()');

        act.click(recorderHelper.selectUIElementByText('text'));
    },

    "7.Check dialog and select the 'text' property": function () {
        eq(recorderHelper.chooseAssertionArgumentPropertyDialog.getResult(), this.argumentSelector);

        act.click(recorderHelper.selectUIElementByText('text'));
    },

    "8.Check the 'length' property is selected and open the 'css properties' tab": function () {
        eq(recorderHelper.chooseAssertionArgumentPropertyDialog.getSelectedPropertyName(), 'text');
        eq(recorderHelper.chooseAssertionArgumentPropertyDialog.getResult(), this.argumentSelector + '.text()');

        this.argumentSelector = recorderHelper.chooseAssertionArgumentPropertyDialog.getResult();

        act.click(recorderHelper.selectUIElementByText('css properties'));
    },

    "9.Check there is no selected property and return to general properties": function () {
        eq(recorderHelper.chooseAssertionArgumentPropertyDialog.getSelectedPropertyName(), null);

        act.click(recorderHelper.selectUIElementByText('common'));
    },

    "10.Check the selected property and return to css properties": function () {
        eq(recorderHelper.chooseAssertionArgumentPropertyDialog.getSelectedPropertyName(), 'text');

        act.click(recorderHelper.selectUIElementByText('css properties'));
    },

    "11.Close dialog": function () {
        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "12.Check selector": function () {
        eq(recorderHelper.getCodeEditorSelector().text(), this.argumentSelector);
    },

    "13.Change argument": function () {
        function getNextButton() {
            return recorderHelper.getPopupButtonSelector('Next');
        }

        function getFinishButton() {
            return recorderHelper.getPopupButtonSelector('Next');
        }

        act.click([
            recorderHelper.editAssertionDialog.getOpenWizardButton,
            '.black',
            getNextButton,
            getFinishButton
        ]);
    },

    "14.Check argument is changed": function () {
        eq(recorderHelper.getCodeEditorSelector().text(), '$(":containsExcludeChildren(black)").length > 0');
    }
};

"@test"["Adding new assertions to the previous step"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Record click action": function () {
        act.click('.black');
    },

    "2.1.Add an assertion step": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "2.2.Add an assertion step": function () {
        act.click(recorderHelper.getCodeEditorSelector);
    },

    "2.3.Add an assertion step": function () {
        act.press('t r u e esc enter');
    },

    "2.4.Add an assertion step": function () {
        act.click(recorderHelper.getPopupButtonSelector('OK'));
    },

    "3.Click on add assertions button": function () {
        act.click(recorderHelper.toolbar.getAddAssertionsSelector);
    },

    "4.Check is previous step opened": function () {
        eq(recorderHelper.assertionsStepDialog.getAssertions().length, 1);
    },

    "5.1.Add a new assertion": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "5.2.Add a new assertion": function () {
        this.popupHeight = recorderHelper.popup.getPopup().eq(1).height();
        act.click(recorderHelper.getCodeEditorSelector);
    },

    "5.3.Add a new assertion": function () {
        act.press('t r u e esc');
    },

    "5.4.Add a new assertion": function () {
        eq(recorderHelper.popup.getPopup().eq(1).height(), this.popupHeight, 'popup height stored after state indicator was appeared');
        act.press('enter');
    },

    "5.5.Add a new assertion": function () {
        act.click(recorderHelper.getPopupButtonSelector('OK'));
    },

    "6.Check steps count and open the second step": function () {
        eq(recorderHelper.stepsPanel.getStepCount(), 2);

        act.click(recorderHelper.stepsPanel.getStepListItem(1));
    },

    "7.Check assertions": function () {
        eq(recorderHelper.assertionsStepDialog.getAssertions().length, 2);
    }
};

"@test"["Copy actual value to expected argument button"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Open edit assertion dialog": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getEqPopupItem
        ]);
    },

    "2.Check copy button is enabled": function () {
        notOk(recorderHelper.editAssertionDialog.isCopyButtonEnabled());
    },

    "3.Start wizard": function () {
        act.click(recorderHelper.editAssertionDialog.getOpenWizardButton);
    },

    "4.Select the black element": function () {
        act.click('.black');
    },

    "5.Click the 'Next' button": function () {
        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "6.Select the 'text' property": function () {
        act.click(recorderHelper.selectUIElementByText('text'));
    },

    "7.Click the 'Finish' button": function () {
        this.actualArgument = recorderHelper.chooseAssertionArgumentPropertyDialog.getResult();

        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "8.Check copy button is enabled": function () {
        ok(recorderHelper.editAssertionDialog.isCopyButtonEnabled());
    },

    "9.Check assertion state is not determined": function () {
        notOk(recorderHelper.editAssertionDialog.isStateIndicatorVisible());
    },

    "10.Check actual argument and actual argument value": function () {
        eq(recorderHelper.editAssertionDialog.getActualCodeEditor().text(), this.actualArgument);
        eq(recorderHelper.editAssertionDialog.getActualValue(), '"black"');
    },

    "11.Click copy button": function () {
        act.click(recorderHelper.editAssertionDialog.getCopyButton());
    },

    "12.Check expected argument": function () {
        eq(recorderHelper.editAssertionDialog.getExpectedCodeEditor().text(), '"black"');
    },

    "13.Check assertion is successful": function () {
        ok(recorderHelper.editAssertionDialog.isAssertionSuccessful());
    }
};

"@test"["Active element in assertion"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Click on the input": function () {
        act.click('#input');
    },

    "2.Start wizard": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getEqPopupItem,
            recorderHelper.editAssertionDialog.getOpenWizardButton
        ]);
    },

    "3.Select the input": function () {
        act.click('#input');
    },

    "4.Click on the 'Next' and the 'Finish' buttons": function () {
        act.click([
            generateButtonSelector('Next'),
            function () {
                return recorderHelper.selectUIElementByText('exists');
            },
            generateButtonSelector('Next')
        ]);
    },

    "5.Change selector": function () {
        act.press('[ 0 ]');
    },

    "6.Fill the second argument": function () {
        act.type(recorderHelper.getCodeEditorSelector().eq(1), 'document.activeElement');
    },

    "7.Check assertion result": function () {
        ok(recorderHelper.editAssertionDialog.isAssertionSuccessful(0));
        act.click(recorderHelper.editAssertionDialog.getConfirmButton);
    },

    "8.Check assertion in assertions list and reopen step": function () {
        ok(recorderHelper.assertionsStepDialog.isAssertionSuccessful(0));

        act.click(recorderHelper.addActionDialog.getAddActionButton);
    },

    "9.1.Open assertion info": function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    "9.2.Open assertion info": function () {
        ok(recorderHelper.assertionsStepDialog.isAssertionSuccessful(0));

        act.click(recorderHelper.assertionsStepDialog.getEditAssertionSelector(0));
    },

    "10.Close assertion editor": function () {
        act.click(recorderHelper.editAssertionDialog.getConfirmButton);
    },

    "11.Check assertion": function () {
        ok(recorderHelper.assertionsStepDialog.isAssertionSuccessful(0));
    }
};

"@test"["Wizard close buttons"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Start wizard": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getEqPopupItem,
            recorderHelper.editAssertionDialog.getOpenWizardButton
        ]);
    },

    "2.Select the input": function () {
        act.click('#input');
    },

    "3.Click on the close button": function () {
        act.click([
            recorderHelper.popup.getPopupCloseButton
        ]);
    },

    "4.Check wizard was cancelled": function () {
        ok(!recorderHelper.chooseElementSelectorDialog.isDialogVisible());
        ok(recorderHelper.editAssertionDialog.isDialogVisible());
        eq(recorderHelper.editAssertionDialog.getActualCodeEditor().text(), '');
    },

    "5.Open wizard": function () {
        act.click(recorderHelper.editAssertionDialog.getOpenWizardButton);
    },

    "6.Select the input": function () {
        act.click('#input');
    },

    "7.Click on the 'Next' button": function () {
        act.click([
            generateButtonSelector('Next')
        ]);
    },

    "8.Click on the close button": function () {
        act.click([
            recorderHelper.popup.getPopupCloseButton
        ]);
    },

    "9.Check wizard was cancelled": function () {
        ok(!recorderHelper.chooseAssertionArgumentPropertyDialog.isDialogVisible());
        ok(recorderHelper.editAssertionDialog.isDialogVisible());
        eq(recorderHelper.editAssertionDialog.getActualCodeEditor().text(), '');
    }
};

"@test"["Check 'Attributes' tab in Choose property dialog for selector contains more than one element"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "1.Click toolbar 'Add Assertion button' and start element picking": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem,
            recorderHelper.editAssertionDialog.getOpenWizardButton
        ]);
    },

    "2.Select on the black element": function () {
        act.click('.black');
    },

    "3.Click code editor": function () {
        act.click(recorderHelper.getCodeEditorSelector().last());
    },

    "4.Enter selector contains more than one element": function () {
        act.press('ctrl+a delete $ ( " d i v " )');
    },

    "5.Click the 'Next' button": function () {
        act.click(recorderHelper.getPopupButtonSelector('Next'));
    },

    "6.Open 'Attributes' tab in Choose property dialog": function () {
        act.click(recorderHelper.chooseAssertionArgumentPropertyDialog.getTabByIndex(2));
    },

    "7.Select the 'class' attribute for check in assertion": function () {
        act.click(recorderHelper.selectUIElementByText('class'));
    },

    "8.Confirm assertion": function () {
        function generateButtonSelector(text) {
            return function () {
                return recorderHelper.getPopupButtonSelector(text);
            }
        }

        act.click([
            generateButtonSelector('Next'),
            recorderHelper.editAssertionDialog.getConfirmButton,
            generateButtonSelector('OK')
        ]);
    },

    "9.Check that assertion was recorded": function () {
        eq(recorderHelper.stepsPanel.getStepCount(), 1);
    }
};

"@test"["Check scrollbar functionality in assertions step dialogs"] = {
    "-1.Start recording": function () {
        this.curNum = 1;
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "0.Click 'Add assertion' toolbar button": function () {
        act.click(recorderHelper.toolbar.getAddAssertionsSelector);
    },

    "1.Add assertion '1'": "@mixin Add 'Ok' assertion",
    "2.Add assertion '2'": "@mixin Add 'Ok' assertion",
    "3.Add assertion '3'": "@mixin Add 'Ok' assertion",
    "4.Add assertion '4'": "@mixin Add 'Ok' assertion",
    "5.Add assertion '5'": "@mixin Add 'Ok' assertion",
    "6.Add assertion '6'": "@mixin Add 'Ok' assertion",
    "7.Add assertion '7'": "@mixin Add 'Ok' assertion",
    "8.Add assertion '8'": "@mixin Add 'Ok' assertion",

    "9.Check scrollbar added and remove one assertion": function () {
        ok(recorderHelper.popup.hasScroll());
        act.click(recorderHelper.assertionsStepDialog.getRemoveAssertionButton(1));
    },

    "10.Check scrollbar removed": function () {
        notOk(recorderHelper.popup.hasScroll());
    },

    "11.Add assertion '9'": "@mixin Add 'Ok' assertion",

    "12.Check scrollbar added again and click 'OK' button": function () {
        ok(recorderHelper.popup.hasScroll());
        act.click(recorderHelper.popup.getPopupButtonSelector('OK'));
    },

    "13.Open recorded assertions step": function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    "14.Check scrollbar added and remove one assertion": function () {
        ok(recorderHelper.popup.hasScroll());
        act.click(recorderHelper.assertionsStepDialog.getRemoveAssertionButton(2));
    },

    "15.Check scrollbar stored and remove second assertion": function () {
        ok(recorderHelper.popup.hasScroll());
        act.click(recorderHelper.assertionsStepDialog.getRemoveAssertionButton(3));
    },

    "16.Check scrollbar removed and add new assertion": function () {
        notOk(recorderHelper.popup.hasScroll());
        act.click(recorderHelper.assertionsStepDialog.getAddAssertionButton);
    },

    "17.1.Check scrollbar doesn't shown and start adding assertion": function () {
        notOk(recorderHelper.popup.hasScroll());
        act.click([recorderHelper.assertionsStepDialog.getOkPopupItem,
            recorderHelper.getCodeEditorSelector]);
    },

    "17.2.Add assertion": function () {
        act.press('1 0 esc enter');
    },

    '18.Check scrollbar added again': function () {
        ok(recorderHelper.popup.hasScroll());
    }
};

function generateButtonSelector(text) {
    return function () {
        return recorderHelper.getPopupButtonSelector(text);
    }
}

"@mixin"["Add 'Ok' assertion"] = {
    "1.1.Add assertion": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem,
            recorderHelper.getCodeEditorSelector
        ]);
    },

    "1.2.Add assertion": function () {
        act.press(this.curNum + ' esc enter');
    },

    "1.3.Increase assertion counter": function () {
        this.curNum++;
    }
};

