"@fixture Native dialogs handling";
"@page ./tests";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

var iframeSelector = '#iframe';

"@test"["Check handle dialog directives are saved"] = {
    "@testCases": [
        { '@name': 'Cross-domain iframe', title: 'CrossDomainPage' },
        { '@name': 'Same-domain iframe', title: 'SameDomainPage' },
        { '@name': 'Inline iframe', title: 'InlineIframePage' }
    ],

    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector(this.title));
    },

    "1.Click on alert div": inIFrame(iframeSelector, function () {
        handleAlert();
        act.click('#alertDiv');
    }),

    "2.Open step and dialogs editor": function () {
        act.click([recorderHelper.stepsPanel.getStepListItem(0),
            recorderHelper.popup.getDialogsEditor]);
    },

    "3.Check handleAlert is added": function () {
        ok(recorderHelper.popup.hasAlertHandler());
    }
};