'@fixture Upload';
'@page ./tests';

'@require :recorderHelper';
'@require ../../../mixins/recorder.js';

'@test'['Record uploading in the iframe'] = {
    '@testCases': [
        { '@name': 'Cross-domain iframe', title: 'CrossDomainPage' },
        { '@name': 'Same-domain iframe', title: 'SameDomainPage' },
        { '@name': 'Inline iframe', title: 'InlineIframePage' }
    ],

    '1.Start recording': function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector(this.title));
    },
    
    '2.Upload': inIFrame('#iframe', function () {
        act.upload('#file', './../../../uploads/img1.jpg');
    }),
    
    '3.Wait uploding': '@mixin Wait file uploding',
    
    '4.Check action': function () {
        eq(recorderHelper.stepsPanel.getStepCount(), 1);
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    '5.Check action params': function () {
        eq(recorderHelper.stepsPanel.getCurrentStepType(), 'upload');
        eq(recorderHelper.stepsPanel.getCurrentSelector(), '$("#file")');
        eq(recorderHelper.stepsPanel.getCurrentUploadStepFiles(), './uploads/img1.jpg');
    },
	
    '6.Playback': function () {
        act.click(recorderHelper.toolbar.getRunPlaybackSelector());
    },

    '7.Finish playback': '@mixin Finish playback',

    '8.Check action': function () {
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    '9.Check steps panel after playback': function () {
        eq(recorderHelper.stepsPanel.getStepCount(), 1);
        eq(recorderHelper.stepsPanel.getCurrentStepIndex(), 0);
    },
    
    '10.Check action params': function () {
        eq(recorderHelper.stepsPanel.getCurrentStepType(), 'upload');
        eq(recorderHelper.stepsPanel.getCurrentSelector(), '$("#file")');
		eq(recorderHelper.stepsPanel.getCurrentUploadStepFiles(), './uploads/img1.jpg');
    },
	
	'11.Save Test': '@mixin Save Test And Open Edit Dialog',
	
	'12.Check generated test code': function () {
		var testCode = $(".ace_content").text().replace(/\s/g, " ");

		notEq(testCode.indexOf('\'1.Upload "img1.jpg" file\': inIFrame($("#iframe")'), -1);
		notEq(testCode.indexOf('act.upload("#file", "./uploads/img1.jpg");'), -1);
    },
	
	'13.Close edit dialog and delete test': '@mixin Close Edit Dialog And Delete Test'
};
