"@fixture B253851 - Page and frames have different cookies";
"@page http://localhost:1341/tests/Recorder/Regression";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

"@test"["Same-domain iframe"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('B253851'));
    },

    "1.Check cookie are cleared and create a same-domain iFrame": function () {
        ok(document.cookie.indexOf('test1') < 0);
        ok(document.cookie.indexOf('test2') < 0);

        act.click('#createSameDomainIFrame');
    },

    "2.Set cookie in the iframe and save it to a variable": inIFrame('#iframe', function () {
        act.click(['#setCookie', '#getCookie']);
    }),

    "3.Check cookie in the iframe": inIFrame('#iframe', function () {
        ok(window.currentCookie.indexOf('test2') > -1);
    }),

    "4.Save cookie in the top document to a variable": function () {
        act.click('#getCookie');
    },

    "5.Check cookie in the top document": function () {
        ok(window.currentCookie.indexOf('test2') > -1);
    },

    "6.Set cookie in the top window and save it to a variable": function () {
        act.click(['#setCookie', '#getCookie']);
    },

    "7.Check cookie in the top document": function () {
        ok(window.currentCookie.indexOf('test1') > -1);
    },

    "8.Save cookie in the iframe to a variable": inIFrame('#iframe', function () {
        act.click('#getCookie');
    }),

    "9.Check cookie in the iframe": inIFrame('#iframe', function () {
        ok(window.currentCookie.indexOf('test1') > -1);
    })
};

"@test"["Cross-domain iframe"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('B253851'));
    },

    "1.Check cookie are cleared and create a same-domain iFrame": function () {
        ok(document.cookie.indexOf('test1') < 0);
        ok(document.cookie.indexOf('test2') < 0);
        act.click('#createCrossDomainIFrame');
    },

    "2.Set cookie in the iframe and save it to a variable": inIFrame('#iframe', function () {
        act.click(['#setCookie', '#getCookie']);
    }),

    "3.Check cookie in the iframe": inIFrame('#iframe', function () {
        ok(window.currentCookie.indexOf('test2') > -1);
    }),

    "4.Save cookie in the top document to a variable": function () {
        act.click('#getCookie');
    },

    "5.Check cookie in the top document": function () {
        notOk(window.currentCookie.indexOf('test2') > -1);
    },

    "6.Set cookie in the top window and save it to a variable": function () {
        act.click(['#setCookie', '#getCookie']);
    },

    "7.Check cookie in the top document": function () {
        ok(window.currentCookie.indexOf('test1') > -1);
    },

    "8.Save cookie in the iframe to a variable": inIFrame('#iframe', function () {
        act.click('#getCookie');
    }),

    "9.Check cookie in the iframe": inIFrame('#iframe', function () {
        notOk(window.currentCookie.indexOf('test1') > -1);
    })
};