"@fixture T184000 - TD_14_2_2 - Redundant page scrolling on http://habrahabr.ru/";
"@page ./tests";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

function getWaitActionStepName(ms) {
    return 'Wait ' + ms + ' milliseconds';
}

"@test"["T184000 - TD_14_2_2 - Redundant page scrolling on http://habrahabr.ru/"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('BaseRecorderPage'));
    },

    "2.Start wait action recording via toolbar": function () {
        $('body').bind('keypress', function (e) {
            window.pressed = true;
            e.preventDefault();
        });
        act.click(recorderHelper.toolbar.getRecordWaitActionSelector);
    },

    "3.Check dialog and try type in step name input": function () {
        ok(recorderHelper.isPopupShown());
        var $testNameInput = recorderHelper.selectUIElementByText('Name').parent().find('div input');
        eq($testNameInput[0].value, getWaitActionStepName(1000));

        act.type($testNameInput, 'a');
    },

    "4.Check changed step name input value and add action": function () {
        var $stepNameInput = recorderHelper.selectUIElementByText('Name').parent().find('div input');
        eq($stepNameInput[0].value, getWaitActionStepName(1000) + 'a');
        notOk(window.pressed);

        act.click(recorderHelper.getPopupButtonSelector('OK'));
    },

    '5.Click toolbar save button': function () {
        act.click(recorderHelper.toolbar.getSaveTestButtonSelector);
    },

    '6.Set empty test name': function () {
        ok(recorderHelper.isPopupShown());
        act.type(recorderHelper.setTestNameDialog.getTestNameInput, 'a');
    },

    "7.Check changed test name input value and add action": function () {
        eq(recorderHelper.setTestNameDialog.getTestNameInput().find('input')[0].value, 'a');
        notOk(window.pressed);
    }
};

