"@fixture T198725 - Can't select element for the assertion";
"@page http://localhost:1341/tests/Recorder/Regression";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

"@test"["Create assertion as the first action"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('T198725'));
    },

    "1.Add assertion": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "2.Start wizard to choose element for assertion": function () {
        act.click(recorderHelper.editAssertionDialog.getOpenWizardButton);
    },

    "3.Select div": function () {
        act.click('.div_with_class');
    },

    "4.Check generated selector": function () {
        eq(recorderHelper.chooseElementSelectorDialog.getElementSelector().text(), '$(".div_with_class")');
    }
};

"@test"["Should refresh stored attributed during creation assertion"] = {
    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector('T198725'));
    },

    "1.Record first action": function () {
        act.click('body');
    },

    "2.Dispatch 'mouseover' event to store element attributes": function () {
        var ev = document.createEvent('MouseEvents');
        ev.initMouseEvent('mouseover', true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
        $('.div_with_class')[0].dispatchEvent(ev);
    },

    "3.Add assertion": function () {
        $('.div_with_class').removeClass('hovered');

        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "4.Start wizard to choose element for assertion": function () {
        act.click(recorderHelper.editAssertionDialog.getOpenWizardButton);
    },

    "5.Select div": function () {
        act.click('.div_with_class');
    },

    "6.Check generated selector": function () {
        eq(recorderHelper.chooseElementSelectorDialog.getElementSelector().text(), '$(".div_with_class")');
    }
};