"@fixture Record hover action in iframe";
"@page ./";

"@require :recorderHelper";
"@require ../../../mixins/recorder.js";

var iframeSelector = '#iframe';

"@test"["Record hover action"] = {
    "@testCases": [
        { '@name': 'Cross-domain iframe', title: 'CrossDomainPage' },
        { '@name': 'Same-domain iframe', title: 'SameDomainPage' },
        { '@name': 'Inline iframe', title: 'InlineIframePage' }
    ],

    "-1.Start recording": function () {
        act.click(recorderHelper.controlPanelHelper.getStartRecordingSelector(this.title));
    },

    "1.Start hover action recording via toolbar": function () {
        recorderHelper.hideCursor();
        act.click(recorderHelper.toolbar.getRecordHoverActionSelector);
    },

    "2.Hover over the action target": inIFrame(iframeSelector, function () {
        act.hover('#hoverDiv');
    }),

    "3.Check element frame": function () {
        ok(recorderHelper.isElementFrameShown(null, true));
    },

    "4.Select the action target": inIFrame(iframeSelector, function () {
        act.click("#hoverDiv");
    }),

    "5.Select the first recorded action": function () {
        eq(recorderHelper.stepsPanel.getStepCount(), 1);
        act.click(recorderHelper.stepsPanel.getStepListItem(0));
    },

    "6.Check the step": function () {
        eq(recorderHelper.stepsPanel.getCurrentStepType(), 'hover');
        eq($.trim(recorderHelper.stepsPanel.getCurrentSelector()), '$("#hoverDiv")');
        eq($.trim(recorderHelper.stepsPanel.getCurrentIFrameSelector()), '$("' + iframeSelector + '")');
    }
};