"@fixture T230851 - TD15.1 - wait for action target fails silently if redirect happens during wait";
"@page http://localhost:1341/project/TestRunner/Regression";

'@require :recorderHelper';
"@require ./../../../mixins/testrunner.js";

'@test'['T230851 - succeed tests'] = {
    '@testCases': [
        {
            '@name': 'Click on the element after redirect',
            fixture: 'T230851base',
            testName: 'Click on the element after redirect',
            succeed: true
        },
        {
            '@name': 'Wait for element after redirect',
            fixture: 'T230851base',
            testName: 'Wait for element after redirect',
            succeed: true
        },
        {
            '@name': 'Click on the element after redirect in iframe',
            fixture: 'T230851iframe',
            testName: 'Click in iframe on the element after redirect',
            succeed: true
        },
        {
            '@name': 'Wait for element after redirect in iframe',
            fixture: 'T230851iframe',
            testName: 'Wait in iframe for element after redirect',
            succeed: true
        }
    ],

    '1.Run test and wait for results': '@mixin Run test and go to results',

    '2.Check test results': function () {
        eq(recorderHelper.testResults.getFailIndicator().length, this.succeed ? 0 : 1);
    }
};

'@test'['T230851 - failed tests'] = {
    '@testCases': [
        {
            '@name': 'Redirect before target element is appeared',
            fixture: 'T230851base',
            testName: 'Redirect before target element is appeared',
            succeed: false,
            errorText: 'Error on step "2.Click div "The second div"'
        },
        {
            '@name': 'Wait for element before redirect',
            fixture: 'T230851base',
            testName: 'Wait for element before redirect',
            succeed: false,
            errorText: 'Error on step "2.Wait for the second div"'
        },
        {
            '@name': 'Redirect before target element is appeared in iframe',
            fixture: 'T230851iframe',
            testName: 'Redirect in iframe before target element is appeared',
            succeed: false,
            errorText: 'Error on step "2.Click div "The second div"'
        },
        {
            '@name': 'Wait for element before redirect in iframe',
            fixture: 'T230851iframe',
            testName: 'Wait in iframe for element before redirect',
            succeed: false,
            errorText: 'Error on step "2.Wait for the second div"'
        }
    ],

    '1.Run test and wait for results': '@mixin Run test and go to results',

    '2.Check test results': function () {
        eq(recorderHelper.testResults.getFailIndicator().length, this.succeed ? 0 : 1);
    },

    '3.Expand failed test': '@mixin Expand failed test',

    '4.Check error message': function () {
        ok(recorderHelper.testResults.getErrorMessageText().indexOf(this.errorText) > -1);
    }
};