'@fixture Screenshots';
'@page ./project/TestRunner';

'@require :recorderHelper';
"@require ./../../mixins/testrunner.js";

var FIXTURE_NAME = 'Screenshots';

//HACK: in the tested TestCafe we get window.locaiton to determine IE window to make a screenshot. But patched TestCafe
// patch the scripts change this to something like __get$__(window, 'location'). It's result is not equal to the real page url.
// Now we cannot find nice way to fix it, so we will use this hack for a some time.
function pageSetup () {
    if (!recorderHelper.isIE)
        return;

    var link = document.createElement('a'),
        realLocation = null;
    link.setAttribute('href', '');

    with (link) {
        realLocation = href;
    }

    var nativeGet = window.__get$__;

    window.__get$__ = function (elem, prop) {
        if (elem === window && prop === 'location') {
            var loc = {
                toString: function () {
                    return realLocation;
                }
            };

            Object.defineProperty(loc, 'href', {
                get: function () {
                    return realLocation;
                },
                set: function (value) {
                    return window.location = value;
                }
            });

            return loc;
        }
        else
            return nativeGet.apply(this, arguments);
    };
}

'@mixin'['Check screenshots creating'] = {
    'a.Get saved screenshots indicators': function () {
        var that = this;

        act.waitFor(function (callback) {
            $.ajax({
                url: 'http://localhost:3000/screenshot-count',
                type: 'GET',
                dataType: 'jsonp',
                success: function (res) {
                    that.reportSaved = res.reportSaved;
                    that.screenshotDirCreated = res.screenshotDirCreated;
                    that.screenshotCount = res.screenshotCount;
                    callback();
                },
                jsonpCallback: 'cb'
            });
        }, 500);
    },

    'b.Check saved screenshots indicators and expand results': function () {
        var $failIndicator = recorderHelper.testResults.getFailIndicator();

        ok(this.expectError ? $failIndicator.length : !$failIndicator.length, 'results of test running are correct');
        ok(this.reportSaved, 'report file saved');
        ok(this.screenshotDirCreated, 'screenshot directory created');
        eq(this.screenshotCount, this.expectScreenshotCount, 'count of saved screenshots is correct');
    }
};

'@test'['Action Screenshot'] = {
    'Init': function () {
        this.fixture = FIXTURE_NAME;
        this.testName = 'action screenshot';

        this.expectError = false;
        this.expectScreenshotCount = 4;
    },

    '1.Run test and go to results': '@mixin Run test and go to results',

    '2.Check screenshots creating': '@mixin Check screenshots creating'
};

'@test'['Screenshots on fails'] = {
    'Init': function () {
        this.fixture = FIXTURE_NAME;
        this.testName = 'Failed assertion in step without action in iframe';
        this.takeScreenshotOnFails = true;

        this.expectError = true;
        this.expectScreenshotCount = 4;
    },

    '1.Run test and go to results': '@mixin Run test and go to results',

    '2.Check screenshots creating': '@mixin Check screenshots creating',

    '3.Click on the expand button': function () {
        act.click(recorderHelper.testResults.getExpandButtonSelector);
    },

    '4.Wait for test results are shown': function () {
        act.wait(2000, function () {
            return recorderHelper.testResults.isFailedTestExpanded();
        });
    },

    '5.Check errors and screenshots count': function () {
        eq(recorderHelper.controlPanelHelper.getReportErrorRows().length, 3, 'check error count');
        eq(recorderHelper.controlPanelHelper.getReportScreenshotCount().length, 3, 'check screenshot count');
    }
};