'@fixture Uncaught Js Errors handling';
'@page ./project/UncaughtJsErrors';
'@require :recorderHelper';
"@require ./../../mixins/testrunner.js";

'@test'['Should fail with error'] = {
    '@testCases': [
        {
            '@name': 'no handler',
            fixture: 'no handler',
            urlPart: '/uncaught_js_errors/no_handler'
        },
        {
            '@name': 'handler returns undefined',
            fixture: 'handler returns undefined',
            urlPart: '/uncaught_js_errors/handler_returns_undefined'
        },
        {
            '@name': 'iframe with src',
            fixture: 'iframe with src',
            urlPart: '/uncaught_js_errors/handler_returns_undefined'
        },
        {
            '@name': 'loaded',
            fixture: 'loaded',
            urlPart: '/uncaught_js_errors/loaded'
        }
    ],

    '1.Run test and wait for results': '@mixin Run test and go to results',

    '2.Expand failed test': '@mixin Expand failed test',

    '3.Check that test failed with JS error': function () {
        eq(recorderHelper.testResults.getFailIndicator().length, 1);
        ok(recorderHelper.testResults.getErrorMessageText().indexOf('%TC_TEST_ERR%') > -1);
        ok(recorderHelper.testResults.getErrorMessageText().indexOf(this.urlPart) > -1);
    }
};

'@test'['Should succeed'] = {
    '@testCases': [
        {'@name': 'handler returns true', fixture: 'handler returns true'},
        {'@name': 'cross domain iframe', fixture: 'cross domain iframe'}
    ],

    '1.Run test and wait for results': '@mixin Run test and go to results',

    '2.Check that test finished successfully': function () {
        eq(recorderHelper.testResults.getFailIndicator().length, 0);
    }
};

'@test'['Should succeed if "fail on JS errors" option is disabled'] = {
    '@testCases': [
        { '@name': 'no handler', fixture: 'no handler' },
        { '@name': 'handler returns undefined', fixture: 'handler returns undefined' },
        { '@name': 'iframe with src', fixture: 'iframe with src' },
        { '@name': 'loaded', fixture: 'loaded' }
    ],

    '1.Disable option' : function(){
        this.disableFailOnJsErrors = true;
    },

    '2.Run test and wait for results': '@mixin Run test and go to results',

    '3.Check that test finished successfully': function () {
        eq(recorderHelper.testResults.getFailIndicator().length, 0);
    }
};