"@fixture Use shared code in cross-domain iframe steps";
"@page ./tests";

"@require :testModule";
"@require ./mixin.js";

var basePath = "http://localhost:3000/common/",
    text = "test";

"@test"["Use shared code in iframe"] = {
    "@testCases": [
        { '@name': 'Cross-domain iframe', pageUrl: 'cross_domain' },
        { '@name': 'Same-domain iframe', pageUrl: 'same_domain' },
        { '@name': 'Inline iframe', pageUrl: 'iframe_without_src_page' }
    ],

    "0.Navigate to the test page": function () {
        act.navigateTo(basePath + this.pageUrl);
    },
    "1.Type in input": inIFrame("#iframe", function () {
        act.type(getInput, text);
    }),
    "2.Check input value": inIFrame("#iframe", function () {
        eq($('#input')[0].value, 'test');
    })
};

"@test"["Use cross-domain mixin"] = {
    "@testCases": [
        { '@name': 'Cross-domain iframe', pageUrl: 'cross_domain' },
        { '@name': 'Same-domain iframe', pageUrl: 'same_domain' },
        { '@name': 'Inline iframe', pageUrl: 'iframe_without_src_page' }
    ],

    "0.Navigate to the test page": function () {
        act.navigateTo(basePath + this.pageUrl);
    },
    "1.Type in input": "@mixin Type in input in iFrame",
    "2.Check input value": inIFrame("#iframe", function () {
        eq($('#input')[0].value, 'test');
    })
};