var PLAYBACK_TIMEOUT = 20000,
    TEST_NAME = 'temp_test';

function getStyle($el) {
    return window.getComputedStyle($el[0]);
}

"@mixin"["Finish playback"] = {
    "Wait for playback finished": function () {
        act.wait(PLAYBACK_TIMEOUT, function () {
            return recorderHelper.getPopupButtonSelector('Return to recording').length;
        });
    },

    "Close playback results": function () {
        act.click(recorderHelper.getPopupButtonSelector('Return to recording'));
    }
};

'@mixin'['Save Test And Open Edit Dialog'] = {
    '1.Click div "Save the test..."': function () {
        act.click(recorderHelper.toolbar.getSaveTestButtonSelector());
    },

    '2.Type in input "Test name:"': function () {
        act.type(recorderHelper.saveTestDialog.getTestNameInputSelector(), TEST_NAME);
    },

    '3.Click submit button "Save"': function () {
        act.click(recorderHelper.dialog.getSaveButton());
    },

    '4.Click div "Exit test..."': function () {
        act.click(recorderHelper.toolbar.getExitRecordingButtonSelector());
    },

    '5.Wait test save': function () {
        act.wait(10000, function () {
            return getStyle($('[data-test-name="' + TEST_NAME + '"]')).visibility === 'visible';
        });
    },

    '6.Click Edit': function () {
        act.click(recorderHelper.controlPanelHelper.getEditTestButtonSelector(TEST_NAME));
    }
};

'@mixin'['Close Edit Dialog And Delete Test'] = {
    '1.Click submit button "Cancel"': function () {
        act.click('#cancel-fixture-code-btn');
    },

    '2.Click Delete': function () {
        act.click(recorderHelper.controlPanelHelper.getDeleteTestButtonSelector(TEST_NAME));
    }
};

'@mixin'['Wait file uploding'] = {
    '1.Wait uploading': function () {
        act.wait(10000, function () {
            return recorderHelper.tooltip.isTooltipVisible();
        });
    },

    '2.Modal background visibility': function () {
        ok(!recorderHelper.isLoadingIconShown());
        ok(!recorderHelper.isDivBackgroundShown());
    },

    '3.Wait tooltip hide': function () {
        act.wait(10000, function () {
            return !recorderHelper.tooltip.isTooltipVisible();
        });
    }
};

'@mixin'['Record ten action'] = {
    '1.Press 1': function () {
        act.press('1');
    },
    '2.Press 2': function () {
        act.press('2');
    },
    '3.Press 3': function () {
        act.press('3');
    },
    '4.Press 4': function () {
        act.press('4');
    },
    '5.Press 5': function () {
        act.press('5');
    },
    '6.Press 6': function () {
        act.press('6');
    },
    '7.Press 7': function () {
        act.press('7');
    },
    '8.Press 8': function () {
        act.press('8');
    },
    '9.Press 9': function () {
        act.press('9');
    },
    '10.Press 0': function () {
        act.press('0');
    }
};

'@mixin'['Add assertion step'] = {
    "1.Click add assertions button": function () {
        act.click(recorderHelper.toolbar.getAddAssertionsSelector);
    },

    "2.Open edit 'ok' assertion dialog": function () {
        act.click([
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "3.Fill actual argument": function () {
        act.type(recorderHelper.getCodeEditorSelector().eq(0), 'true');
    },

    "4.Click confirm button": function () {
        act.click(recorderHelper.editAssertionDialog.getConfirmButton);
    },

    "5.Click OK button": function () {
        act.click(recorderHelper.getPopupButtonSelector('OK'));
    }
};

"@mixin"["Record click and changes selector"] = {
    "2. Click on element": function () {
        act.click('.black');
    },

    "2.1.Change action selector": function () {
        act.click(recorderHelper.selectUIElementByText('Click div'));
    },

    "2.2.Change action selector": function () {
        act.click(recorderHelper.addActionDialog.getElementSelectorEditor);
    },

    "2.3.Change action selector": function () {
        act.press('ctrl+a delete " . g r e e n');
    },

    "2.4.Change action selector": function () {
        act.click(recorderHelper.selectUIElementByText('Click div'));
    }
};

"@mixin"["Add failed assertion"] = {
    "1.Add failed assertion": function () {
        act.click([
            recorderHelper.toolbar.getAddAssertionsSelector,
            recorderHelper.assertionsStepDialog.getAddAssertionButton,
            recorderHelper.assertionsStepDialog.getOkPopupItem
        ]);
    },

    "2.Add failed assertion": function () {
        act.click(recorderHelper.getCodeEditorSelector);
    },

    "3.Add failed assertion": function () {
        act.press('ctrl+a delete f a l s e esc enter');
    }
};