"@fixture basePage";
"@page http://localhost:3000/common/browser_dialogs/index";

"@test"["Confirm (true) after redirect - should succeed"] = {
    '1.Click link "Confirm page"': function() {
        handleConfirm(true);
        act.click(":containsExcludeChildren(Confirm page)");
    },
    "2.Assert": function() {
        eq($("#result").text(), "true");
    }
};

"@test"["Confirm (false) after redirect - should succeed"] = {
    '1.Click link "Confirm page"': function() {
        handleConfirm(false);
        act.click(":containsExcludeChildren(Confirm page)");
    },
    "2.Assert": function() {
        eq($("#result").text(), "false");
    }
};

"@test"["Confirm after redirect - should be failed"] = {
    '1.Click link "Confirm page"': function() {
        act.click(":containsExcludeChildren(Confirm page)");
    }
};

"@test"["Confirm after an action - should succeed"] = {
    '1.Click submit button "Confirm"': function() {
        handleConfirm(true);
        act.click("#confirm");
    },
    "2.Assert": function() {
        eq($("#result").text(), "true");
    },
    '3.Click submit button "Confirm"': function() {
        handleConfirm(false);
        act.click("#confirm");
    },
    "4.Assert": function() {
        eq($("#result").text(), "false");
    }
};

"@test"["Confirm after an action - should be failed"] = {
    '1.Click submit button "Confirm"': function() {
        act.click("#confirm");
    }
};

"@test"["No expected confirm after an action - should be failed"] = {
    '1.Click submit button "Button"': function() {
        handleConfirm(true);
        act.click("#simpleButton");
    }
};

"@test"["No expected confirm after redirect - should be failed"] = {
    '1.Click link "This page"': function() {
        handleConfirm(true);
        act.click(":containsExcludeChildren(This page)");
    }
};

"@test"["Before unload dialog - should succeed"] = {
    '1.Click submit button "Enable..."': function() {
        act.click("#enableBeforeUnload");
    },
    '2.Click link "This page"': function() {
        handleBeforeUnload();
        act.click(":containsExcludeChildren(This page)");
    }
};

"@test"["Unexpected before unload dialog - should be failed"] = {
    '1.Click submit button "Enable..."': function() {
        act.click("#enableBeforeUnload");
    },
    '2.Click link "This page"': function() {
        act.click(":containsExcludeChildren(This page)");
    }
};

"@test"["No expected before unload dialog - should be failed"] = {
    '1.Click link "This page"': function() {
        handleBeforeUnload();
        act.click(":containsExcludeChildren(This page)");
    }
};

"@test"["Expected native dialog after the click on the link without redirect"] = {
    '1.Click link "Fake link"': function() {
        handleAlert();
        act.click("#fakeLink");
    }
};