"@fixture iframePage";
"@page http://localhost:3000/common/browser_dialogs/iframe";

"@test"["Confirm (true) after redirect in iframe - should succeed"] = {
    '1.Click link "Confirm page"': inIFrame('#iframe', function () {
        handleConfirm(true);
        act.click(":containsExcludeChildren(Confirm page)");
    }),
    "2.Assert": inIFrame('#iframe', function () {
        eq($("#result").text(), "true");
    })
};

"@test"["Confirm (false) after redirect in iframe - should succeed"] = {
    '1.Click link "Confirm page"': inIFrame('#iframe', function () {
        handleConfirm(false);
        act.click(":containsExcludeChildren(Confirm page)");
    }),
    "2.Assert": inIFrame('#iframe', function () {
        eq($("#result").text(), "false");
    })
};

"@test"["Confirm after redirect in iframe - should be failed"] = {
    '1.Click link "Confirm page"': inIFrame('#iframe', function () {
        act.click(":containsExcludeChildren(Confirm page)");
    })
};

"@test"["Confirm after an action in iframe - should succeed"] = {
    '1.Click submit button "Confirm"': inIFrame('#iframe', function () {
        handleConfirm(true);
        act.click("#confirm");
    }),
    "2.Assert": inIFrame('#iframe', function () {
        eq($("#result").text(), "true");
    }),
    '3.Click submit button "Confirm"': inIFrame('#iframe', function () {
        handleConfirm(false);
        act.click("#confirm");
    }),
    "4.Assert": inIFrame('#iframe', function () {
        eq($("#result").text(), "false");
    })
};

"@test"["Confirm after an action in iframe - should be failed"] = {
    '1.Click submit button "Confirm"': inIFrame('#iframe', function () {
        act.click("#confirm");
    })
};

"@test"["No expected confirm after an action in iframe- should be failed"] = {
    '1.Click submit button "Button"': inIFrame($("#iframe"), function () {
        handleConfirm(true);
        act.click("#simpleButton");
    })
};

"@test"["No expected confirm after redirect in iframe - should be failed"] = {
    '1.Click link "This page"': inIFrame($("#iframe"), function () {
        handleConfirm(true);
        act.click(":containsExcludeChildren(This page)");
    })
};

"@test"["Before unload dialog in iframe - should succeed"] = {
    '1.Click submit button "Enable..."': inIFrame('#iframe', function () {
        act.click("#enableBeforeUnload");
    }),
    '2.Click link "This page"': inIFrame('#iframe', function () {
        handleBeforeUnload();
        act.click(":containsExcludeChildren(This page)");
    })
};

"@test"["Unexpected before unload dialog in iframe - should be failed"] = {
    '1.Click submit button "Enable..."': inIFrame('#iframe', function () {
        act.click("#enableBeforeUnload");
    }),
    '2.Click link "This page"': inIFrame('#iframe', function () {
        act.click(":containsExcludeChildren(This page)");
    })
};

"@test"["No expected before unload dialog in iframe - should be failed"] = {
    '1.Click link "This page"': inIFrame('#iframe', function () {
        handleBeforeUnload();
        act.click(":containsExcludeChildren(This page)");
    })
};

