"@fixture T230851_iframe";
"@page http://localhost:3000/test_runner/regression/T230851/iframe";

"@test"["Redirect in iframe before target element is appeared - should fail"] = {
    '1.Click div "Click to show..."': inIFrame('#iframe', function () {
        act.click("#div1");
    }),
    '2.Click div "The second div"': inIFrame('#iframe', function () {
        act.click("#div2");
    })
};

"@test"["Click in iframe on the element after redirect - should succeed"] = {
    '1.Click div "Click to show..."': inIFrame('#iframe', function () {
        act.click("#div1");
    }),
    '2.Click div "The third div"': inIFrame('#iframe', function () {
        act.click("#div3");
    }),
    "3.Assert": inIFrame('#iframe', function () {
        eq($("#result").text(), "div3 click");
    })
};

"@test"["Wait in iframe for element before redirect - should fail"] = {
    '1.Click div "Click to show..."': inIFrame('#iframe', function () {
        act.click("#div1");
    }),
    "2.Wait for the second div": inIFrame('#iframe', function () {
        act.waitFor('#div2', 5000);
    }),
    '3.Click div "The third div"': inIFrame('#iframe', function () {
        act.click("#div3");
    }),
    "4.Assert": inIFrame('#iframe', function () {
        eq($("#result").text(), "div3 click");
    })
};

"@test"["Wait in iframe for element after redirect - should succeed"] = {
    '1.Click div "Click to show..."': inIFrame('#iframe', function () {
        act.click("#div1");
    }),
    "2.Wait for the third div": inIFrame('#iframe', function () {
        act.waitFor('#div3', 5000);
    }),
    '3.Click div "The third div"': inIFrame('#iframe', function () {
        act.click(document.getElementById('div3'));
    }),
    "4.Assert": inIFrame('#iframe', function () {
        eq($("#result").text(), "div3 click");
    })
};