'@fixture Screenshots';
'@page ./common/cross_domain';

'@test'['action screenshot'] = {
    '-1.Remove reports': function () {
        act.waitFor(function (callback) {
            $.get('/remove-reports', function () {
                callback();
            });
        }, 500);
    },
    '1.Set start document title': function () {
        document.title = '1';
    },
    '2.Make screenshot': function () {
        intervalToChangeDocumentTitle();

        act.screenshot();
    },
    '3.Check changed document title': function () {
        notEq(document.title, '1');
    },
    '3.': inIFrame($('#iframe'), function () {
        act.screenshot();
    })
};

'@test'['Failed assertion in step without action in iframe'] = {
    '-1.Remove reports': function () {
        act.waitFor(function (callback) {
            $.get('/remove-reports', function () {
                callback();
            });
        }, 500);
    },
    '1.': inIFrame($('#iframe'), function () {
        ok(0);
        eq(0, 1);
    }),
    '2.': function () {
        act.click('#thowError');
    }
};

function intervalToChangeDocumentTitle() {
    var startTitle = parseInt(document.title);

    window.setInterval(function () {
        document.title = startTitle++;
    }, 300);
}