function InfoLoader() {
    this._lock = null;
    this._unlock = null;
}

InfoLoader.prototype.RESPONSE_STATUS_ERROR_TEXT = 'Response from server with status ';

InfoLoader.prototype._setOnLock = function(handler) {
    this._lock = function() {
        this._isLock = true;
        handler();
    };
};

InfoLoader.prototype._setOnUnlock = function(handler) {
    this._unlock = function() {
        this._isLock = false;
        handler();
    };
};

InfoLoader.prototype._sendMsg = function(action, text, success, error) {
    this._lock();

    var xhr = new XMLHttpRequest(),
        loader = this;

    xhr.open("POST", "/xhr/" + action, true);
    xhr.addEventListener('readystatechange', function() {
        if (xhr.readyState === xhr.DONE) {
            if (xhr.status === 200) {
                try {
                    setTimeout(function() {
                        success(JSON.parse(xhr.responseText));
                    }, 0);
                } catch(e) {
                    error(e);
                }
            } else
                error(loader.RESPONSE_STATUS_ERROR_TEXT + xhr.status);

            loader._unlock();
        }
    });
    xhr.send(text);
};
