/* global InfoLoader: true */
function UrlInfoLoader(lock, unlock) {
    this._setOnLock(lock);
    this._setOnUnlock(unlock);
}

UrlInfoLoader.prototype = new InfoLoader();

UrlInfoLoader.prototype.addUrls = function(urls, success, error) {
    if (urls.length)
        this._sendMsg('add_urls', JSON.stringify(urls), success, error);
};

UrlInfoLoader.prototype.getUrls = function(success, error) {
    this._sendMsg('get_urls', '{}', success, error);
};

UrlInfoLoader.prototype.changeUrl = function(urlInfo, success, error) {
    this._sendMsg('change_url', JSON.stringify(urlInfo), success, error);
};

UrlInfoLoader.prototype.removeUrl = function(urlId, success, error) {
    var urlObj = { _id: urlId };

    this._sendMsg('remove_url', JSON.stringify(urlObj), success, error);
};

UrlInfoLoader.prototype.removeAllUrls = function(success, error) {
    this._sendMsg('remove_url', '{}', success, error);
};
