/* global $: true */

window.addEventListener('load', function() {
    var chartBar = $('#chartBar'),
        chartPie = $('#chartPie'),
        settingsChartBar = {
            equalBarWidth: false,
            dataSource: window.dataForChartBar,
            commonSeriesSettings: {
                argumentField: 'state',
                type: 'bar'
            },
            valueAxis: {
                title: 'Time, ms'
            },
            series: [
                { valueField: 'origin', name: 'Origin'},
                { valueField: 'proxy', name: 'Proxy'}
            ],
            legend: {
                verticalAlignment: 'bottom',
                horizontalAlignment: 'center'
            },
            title: 'Timing'
        },
        settingsChartPie = {
            dataSource: window.dataForChartPie,
            series: {
                argumentField: "name",
                valueField: "area"
            },
            legend: {
                verticalAlignment: 'bottom',
                horizontalAlignment: 'center'
            },
            title: 'Proxy time'
        };

    chartBar.dxChart(settingsChartBar);
    chartPie.dxPieChart(settingsChartPie);
});

window.addEventListener('load', function() {
    var elements = document.querySelectorAll('.list-table .list-table-cell.more a');

    if (elements.length) {
        [].slice.call(elements, 0).forEach(function(element) {
            element.addEventListener('click', function() {
                var row = this.parentNode.parentNode.parentNode;

                if (row.className.indexOf(' show-all') !== -1)
                    row.className = row.className.replace(' show-all', '');
                else
                    row.className += ' show-all';
            }, false);
        });
    }
}, false);
