window.sendMsg = function(action, text, callback) {
    var xhr = new XMLHttpRequest(),
        errMsg = 'An error occurred!';

    xhr.open("POST", "/xhr/" + action, true);
    xhr.addEventListener('readystatechange', function() {
        if (xhr.readyState === xhr.DONE) {
            if (xhr.status === 200) {
                try {
                    callback(JSON.parse(xhr.responseText));
                } catch(e) {
                    window.alert(errMsg);
                }
            } else
                window.alert(errMsg);
        }
    });
    xhr.send(text);
};

window.getStringTime = function(timestamp) {
    var date = new Date(timestamp);

    return [
        ["January", "February", "March", "April", "May", "June", "July",
            "August", "September", "October", "November", "December"][date.getMonth()],
        ('0' + date.getDate()).substr(-2, 2),
        [
            ('0' + date.getHours()).substr(-2, 2),
            ('0' + date.getMinutes()).substr(-2, 2),
            ('0' + date.getSeconds()).substr(-2, 2)
        ].join(':')
    ].join(' ');
};

window.addEventListener('load', function() {
    var clearButton = document.querySelector('.main-menu .clear-all-data');

    clearButton.addEventListener('click', function() {
        if (window.confirm("Are you sure?")) {
            window.sendMsg('clear_data', null, function() {
                location.reload();
            });
        }
    });
});
