var Express = require('express'),
    Process = require('child_process'),
    Path = require('path'),
    Http = require('http'),
    Hammerhead = require('../../hammerhead');


//Const
var PROXY_PORT_1 = 1401,
    PROXY_PORT_2 = 1402,
    SERVER_PORT = 1400;

exports.start = function () {
    var app = Express(),
        hammerhead = new Hammerhead.Hammerhead(PROXY_PORT_1, PROXY_PORT_2, 'localhost'),
        appServer = Http.createServer(app);

    hammerhead.serviceEvents.for('').listen('taskScriptRequested', function (refererInfo, cookie, callback) {
        callback('');
    });

    hammerhead.crossDomainServiceEvents.for('').listen('taskScriptRequested', function (refererInfo, cookie, callback) {
        callback('');
    });

    app
        .use(Express.bodyParser())
        .set('view engine', 'ejs')
        .set('view options', {layout: false})
        .set('views', Path.join(__dirname, './views'));

    app.get('*', function (req, res) {
        res.render('index');
    });

    app.post('*', function (req, res) {
        var url = req.param('url');

        if (!url) {
            res.status(403);
            res.render('403');
        }
        else {
            if (url.indexOf('http://') !== 0 && url.indexOf('https://') !== 0)
                url = 'http://' + url;

            res.statusCode = 301;

            var jobUid = new Date().getTime();

            res.setHeader('location', hammerhead.getProxyUrl(url, jobUid));
            res.end();
        }
    });


    hammerhead.start();
    appServer.listen(SERVER_PORT);

    console.log('Server listens on port ' + SERVER_PORT);
    Process.exec('start http://localhost:' + SERVER_PORT);
};