var Process = require('child_process'),
    path = require('path'),
    fs = require('fs'),
    tmp = require('tmp'),
    ejs = require('ejs');

exports.TRIAL_DIR = 'trial';
exports.TRIAL_EXPIRED_DIR = 'trial_expired';
exports.LICENSE_DIR = 'license';
exports.TRIAL_NOT_EXPIRE_PORT = 1450;
exports.TRIAL_EXPIRED_PORT = 1460;
exports.LICENSE_PORT = 1470;

var run = function(dirName, port, testCafePath, callback) {
        var startupConfig = {
            "controlPanelPort": port,
            "servicePort": port + 1,
            "hostname": '127.0.0.1',
            "testsDir": path.join(__dirname, 'fixtures'),
            "browsers": JSON.parse(fs.readFileSync(path.join(__dirname, '../../config.json'))).browsers
            },
            options = {
                source: dirName,
                sourceType: 'dir',
                browsers: ['Google Chrome']
            };

    var TestCafe = require(testCafePath).TestCafe,
        testCafe = new TestCafe(startupConfig);

    testCafe.runTests(options, function(err) {
        if(err) {
            testCafe.close();
            callback(err);
        }
    });

    testCafe.on('taskComplete', function(report) {
        callback(Object.keys(report.testErrReports).length ? report.testErrReports : null);
        testCafe.close();
    });
};

exports.run = run;
