var fs = require('fs'),
    path = require('path'),
    errMsgBuilder = require('../../../../../lib/err_msg_builder');

exports['Error text coverage'] = function (t) {
    var errCodes = [];

    [
        require('../../../../../lib/server/server_errs'),
        require('../../../../../lib/shared/client_errs'),
        require('../../../../../lib/fixture_code/err_codes'),
        require('../../../../../hammerhead/lib/server_errs')
    ].forEach(function (errCodeModule) {
            errCodes = errCodes.concat(Object.keys(errCodeModule).map(function (codeKey) {
                return errCodeModule[codeKey];
            }));
        });

    var failedAssertions = [];

    errCodes.forEach(function (code) {
        if (typeof code !== 'function') {
            var msg = errMsgBuilder.build({code: code});

            if (!msg || msg === errMsgBuilder.UNKNOW_ERR_MSG)
                failedAssertions.push('Missing text description for error code: ' + code);
        }
    });

    t.ok(!failedAssertions.length, failedAssertions.join('\n'));

    t.done();
};