var fs = require('fs'),
    path = require('path');

var nodeModulesDir = path.join(__dirname, '../../../../node_modules');

exports['Foreign'] = {
    'Wrong paths in package.json files': function (t) {
        var walk = function(dir, condition, done) {
            var results = [];
            
            fs.readdir(dir, function(err, list) {
                if (err)
                    return done(err);
                
                var pending = list.length;
                
                if (!pending)
                    return done(null, results);
                
                list.forEach(function(file) {
                    var fileName = file;
                    file = dir + '/' + fileName;
                    fs.stat(file, function(err, stat) {
                        if (stat && stat.isDirectory()) {
                            walk(file, condition, function(err, res) {
                                results = results.concat(res);
                                if (!--pending)
                                    done(null, results);
                            });
                        } else {
                            if(condition(fileName))
                                results.push(file);
                            if (!--pending)
                                done(null, results);
                        }
                    });
                });
            });
        };

        walk(nodeModulesDir,
            function(fileName) {
                return fileName === 'package.json';
            },
            function(err, res){
                for(var i = 0; i < res.length; i++) {
                    var fileContent = fs.readFileSync(res[i]).toString();

                    // index.js must searches in the local dir
                    t.ok(fileContent.indexOf("\"/index") === -1, res[i]);
                }

                t.done();
            }
        );
    }
};

