var Hammerhead = HammerheadClient.get('Hammerhead'),
    IFrameSandbox = HammerheadClient.get('DOMSandbox.IFrame'),
    ActiveWindowTracker = HammerheadClient.get('DOMSandbox.ActiveWindowTracker'),
    async = Hammerhead.async;

Hammerhead.init();

var handler = function (e) {
    if (e.iframe.id.indexOf('test') !== -1) {
        e.iframe.contentWindow.eval.call(e.iframe.contentWindow, [
            'HammerheadClient.define(\'Settings\', function (require, exports) {',
            '    exports.ORIGIN_URL_OBJ = { protocol: "https:", host: "example.com" };',
            '});',
            'HammerheadClient.get(\'Hammerhead\').init();'
        ].join(''));
    }
};

QUnit.testStart = function () {
    IFrameSandbox.on(IFrameSandbox.IFRAME_READY_TO_INIT, handler);
    IFrameSandbox.off(IFrameSandbox.IFRAME_READY_TO_INIT, IFrameSandbox.iframeReadyToInitHandler);
};

QUnit.testDone = function () {
    IFrameSandbox.off(IFrameSandbox.IFRAME_READY_TO_INIT, handler);
};

asyncTest('check changing active window', function () {
    var $iFrame = $('<iframe src="/data/active_window_tracker/iframe.html">').appendTo(document.body);

    $iFrame.load(function () {
        var iFrameWindow = this.contentWindow;

        ok(ActiveWindowTracker.isCurrentWindowActive());
        ok(!iFrameWindow.ActiveWindowTracker.isCurrentWindowActive());

        iFrameWindow.document.body.focus();

        window.setTimeout(function () {
            ok(!ActiveWindowTracker.isCurrentWindowActive());
            ok(iFrameWindow.ActiveWindowTracker.isCurrentWindowActive());

            document.body.focus();

            window.setTimeout(function () {
                ok(ActiveWindowTracker.isCurrentWindowActive());
                ok(!iFrameWindow.ActiveWindowTracker.isCurrentWindowActive());

                $iFrame.remove();
                start();
            }, 50);
        }, 50);
    });
});

asyncTest('check switching active window (between two iFrames)', function () {
    var $firstIFrame = $('<iframe>');
    var $secondIFrame = $('<iframe>');
    var firstIFrameWindow = null;
    var secondIFrameWindow = null;

    $firstIFrame = $('<iframe src="/data/active_window_tracker/iframe.html">').appendTo(document.body);

    $firstIFrame.load(function () {
        $secondIFrame = $('<iframe src="/data/active_window_tracker/iframe.html">').appendTo(document.body);
        $secondIFrame.load(function () {
            firstIFrameWindow = $firstIFrame[0].contentWindow;
            secondIFrameWindow = $secondIFrame[0].contentWindow;

            firstIFrameWindow.document.body.focus();

            window.setTimeout(function () {
                ok(!ActiveWindowTracker.isCurrentWindowActive());
                ok(firstIFrameWindow.ActiveWindowTracker.isCurrentWindowActive());
                ok(!secondIFrameWindow.ActiveWindowTracker.isCurrentWindowActive());

                secondIFrameWindow.document.body.focus();

                window.setTimeout(function () {
                    ok(!ActiveWindowTracker.isCurrentWindowActive());
                    ok(!firstIFrameWindow.ActiveWindowTracker.isCurrentWindowActive());
                    ok(secondIFrameWindow.ActiveWindowTracker.isCurrentWindowActive());

                    $firstIFrame.remove();
                    $secondIFrame.remove();
                    start();
                }, 50);
            }, 50);
        })
    });
});