var Hammerhead = HammerheadClient.get('Hammerhead'),
    $ = Hammerhead.$,
    JSProcessor = Hammerhead.JSProcessor,
    UrlUtil = HammerheadClient.get('UrlUtil'),
    PageProc = HammerheadClient.get('Shared.PageProc'),
    Settings = HammerheadClient.get('Settings');

Hammerhead.init();

asyncTest('onmessage event', function () {
    var $iframe = $('<iframe>'),
        storedGetOriginObj = UrlUtil.getOriginUrlObj,
        storedCrossDomainPort = Settings.CROSS_DOMAIN_PROXY_PORT,
        count = 0;

    Settings.CROSS_DOMAIN_PROXY_PORT = 1336;

    UrlUtil.getOriginUrlObj = function () {
        return {
            protocol: 'http:',
            host: 'origin_parent_host'
        };
    };

    $iframe[0].src = window.getCrossDomainPageUrl('get_message.html');
    $iframe.appendTo('body');

    var onMessageHandler = function (evt) {
        if (evt.origin.indexOf('origin_iframe_host') === -1)
            return;

        var data = typeof evt.data === 'string' ? JSON.parse(evt.data) : evt.data;

        equal(evt.origin, 'http://origin_iframe_host');
        equal(data.msg, 'http://origin_parent_host');

        count++;

        if (count === 2) {
            Settings.CROSS_DOMAIN_PROXY_PORT = storedCrossDomainPort;
            UrlUtil.getOriginUrlObj = storedGetOriginObj;
            $iframe.remove();
            eval(PageProc.processScript("window.onmessage = null;"));
            window.removeEventListener("message", onMessageHandler);
            start();
        }
    };

    $iframe.bind('load', function () {
        eval(PageProc.processScript("window.onmessage = onMessageHandler;"));
        window.addEventListener("message", onMessageHandler);
        eval(PageProc.processScript("this.contentWindow.postMessage('', '*')"));
    });
});

asyncTest('target url', function () {
    expect(0);

    var $iframe = $('<iframe>'),
        storedGetOriginObj = UrlUtil.getOriginUrlObj;

    UrlUtil.getOriginUrlObj = function () {
        return {
            protocol: 'http:',
            host: 'parent.com'
        };
    };

    $iframe[0].src = window.getCrossDomainPageUrl('target_url.html');
    $iframe.appendTo('body');

    var result = 0,
        checkResult = function () {
            if (result === 4) {
                UrlUtil.getOriginUrlObj = storedGetOriginObj;
                $iframe.remove();
                eval(PageProc.processScript("window.onmessage = null;"));
                start();
            }
        };

    var onMessageHandler = function (e) {
        if (e.origin.indexOf('target_url') === -1)
            return;

        if (parseInt(e.data))
            result++;

        checkResult();
    };

    eval(PageProc.processScript("window.onmessage = onMessageHandler;"));
});

