var Hammerhead    = HammerheadClient.get('Hammerhead');
var NativeMethods = Hammerhead.NativeMethods;

if (NativeMethods.inputValueSetter) {
    test('correct value property setters are saved for the input and textarea elements', function () {
        var input                 = document.createElement('input');
        var inputValueGetter      = Object.getOwnPropertyDescriptor(HTMLInputElement.prototype, 'value').get;
        var textArea              = document.createElement('textarea');
        var textAreaValueGetter   = Object.getOwnPropertyDescriptor(HTMLTextAreaElement.prototype, 'value').get;
        var testNativeValueSetter = function (el, setter, getter) {
            Object.defineProperty(el, 'value', {
                get: function () {
                    return getter.call(el);
                },
                set: function (value) {
                    return value;
                }
            });

            el.value = '123';

            strictEqual(el.value, '');

            setter.call(el, '123');

            strictEqual(el.value, '123');
        };

        testNativeValueSetter(input, NativeMethods.inputValueSetter, inputValueGetter);
        testNativeValueSetter(textArea, NativeMethods.textAreaValueSetter, textAreaValueGetter);
    });
}